/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 118 "language.yacc" /* yacc.c:339  */

/* This is the grammar definition of Pike. */

#include "global.h"
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "port.h"
#include "interpret.h"
#include "array.h"
#include "object.h"
#include "mapping.h"
#include "stralloc.h"
#include "las.h"
#include "interpret.h"
#include "program.h"
#include "pike_types.h"
#include "constants.h"
#include "pike_macros.h"
#include "pike_error.h"
#include "docode.h"
#include "pike_embed.h"
#include "opcodes.h"
#include "operators.h"
#include "bignum.h"

#define YYMAXDEPTH	1000

#ifdef PIKE_DEBUG
#ifndef YYDEBUG
/* May also be defined by machine.h */
#define YYDEBUG 1
#endif /* YYDEBUG */
#endif

/* Get verbose parse error reporting. */
#define YYERROR_VERBOSE	1

/* #define LAMBDA_DEBUG	1 */

static void yyerror_reserved(const char *keyword);
static struct pike_string *get_new_name(struct pike_string *prefix);
int add_local_name(struct pike_string *, struct pike_type *, node *);
int low_add_local_name(struct compiler_frame *,
		       struct pike_string *, struct pike_type *, node *);
static void mark_lvalues_as_used(node *n);
static node *lexical_islocal(struct pike_string *);
static node *safe_inc_enum(node *n);
static int call_handle_import(struct pike_string *s);

static int inherit_depth;
static struct program_state *inherit_state = NULL;

/*
 * Kludge for Bison not using prototypes.
 */
#ifndef __GNUC__
#ifndef __cplusplus
static void __yy_memcpy(char *to, const char *from,
			unsigned int count);
#endif /* !__cplusplus */
#endif /* !__GNUC__ */


#line 132 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ARROW = 258,
    TOK_CONSTANT = 259,
    TOK_FLOAT = 260,
    TOK_STRING = 261,
    TOK_NUMBER = 262,
    TOK_INC = 263,
    TOK_DEC = 264,
    TOK_RETURN = 265,
    TOK_EQ = 266,
    TOK_GE = 267,
    TOK_LE = 268,
    TOK_NE = 269,
    TOK_NOT = 270,
    TOK_LSH = 271,
    TOK_RSH = 272,
    TOK_LAND = 273,
    TOK_LOR = 274,
    TOK_SWITCH = 275,
    TOK_SSCANF = 276,
    TOK_CATCH = 277,
    TOK_FOREACH = 278,
    TOK_LEX_EOF = 279,
    TOK_ADD_EQ = 280,
    TOK_AND_EQ = 281,
    TOK_ARRAY_ID = 282,
    TOK_ATTRIBUTE_ID = 283,
    TOK_BREAK = 284,
    TOK_CASE = 285,
    TOK_CLASS = 286,
    TOK_COLON_COLON = 287,
    TOK_CONTINUE = 288,
    TOK_DEFAULT = 289,
    TOK_DEPRECATED_ID = 290,
    TOK_DIV_EQ = 291,
    TOK_DO = 292,
    TOK_DOT_DOT = 293,
    TOK_DOT_DOT_DOT = 294,
    TOK_ELSE = 295,
    TOK_ENUM = 296,
    TOK_EXTERN = 297,
    TOK_FLOAT_ID = 298,
    TOK_FOR = 299,
    TOK_FUNCTION_ID = 300,
    TOK_GAUGE = 301,
    TOK_GLOBAL = 302,
    TOK_IDENTIFIER = 303,
    TOK_RESERVED = 304,
    TOK_IF = 305,
    TOK_IMPORT = 306,
    TOK_INHERIT = 307,
    TOK_FACET = 308,
    TOK_INLINE = 309,
    TOK_LOCAL_ID = 310,
    TOK_FINAL_ID = 311,
    TOK_FUNCTION_NAME = 312,
    TOK_INT_ID = 313,
    TOK_LAMBDA = 314,
    TOK_MULTISET_ID = 315,
    TOK_MULTISET_END = 316,
    TOK_MULTISET_START = 317,
    TOK_LSH_EQ = 318,
    TOK_MAPPING_ID = 319,
    TOK_MIXED_ID = 320,
    TOK_MOD_EQ = 321,
    TOK_MULT_EQ = 322,
    TOK_NO_MASK = 323,
    TOK_OBJECT_ID = 324,
    TOK_OR_EQ = 325,
    TOK_PRIVATE = 326,
    TOK_PROGRAM_ID = 327,
    TOK_PROTECTED = 328,
    TOK_PREDEF = 329,
    TOK_PUBLIC = 330,
    TOK_RSH_EQ = 331,
    TOK_STATIC = 332,
    TOK_STRING_ID = 333,
    TOK_SUB_EQ = 334,
    TOK_TYPEDEF = 335,
    TOK_TYPEOF = 336,
    TOK_VARIANT = 337,
    TOK_VERSION = 338,
    TOK_VOID_ID = 339,
    TOK_WHILE = 340,
    TOK_XOR_EQ = 341,
    TOK_OPTIONAL = 342
  };
#endif
/* Tokens.  */
#define TOK_ARROW 258
#define TOK_CONSTANT 259
#define TOK_FLOAT 260
#define TOK_STRING 261
#define TOK_NUMBER 262
#define TOK_INC 263
#define TOK_DEC 264
#define TOK_RETURN 265
#define TOK_EQ 266
#define TOK_GE 267
#define TOK_LE 268
#define TOK_NE 269
#define TOK_NOT 270
#define TOK_LSH 271
#define TOK_RSH 272
#define TOK_LAND 273
#define TOK_LOR 274
#define TOK_SWITCH 275
#define TOK_SSCANF 276
#define TOK_CATCH 277
#define TOK_FOREACH 278
#define TOK_LEX_EOF 279
#define TOK_ADD_EQ 280
#define TOK_AND_EQ 281
#define TOK_ARRAY_ID 282
#define TOK_ATTRIBUTE_ID 283
#define TOK_BREAK 284
#define TOK_CASE 285
#define TOK_CLASS 286
#define TOK_COLON_COLON 287
#define TOK_CONTINUE 288
#define TOK_DEFAULT 289
#define TOK_DEPRECATED_ID 290
#define TOK_DIV_EQ 291
#define TOK_DO 292
#define TOK_DOT_DOT 293
#define TOK_DOT_DOT_DOT 294
#define TOK_ELSE 295
#define TOK_ENUM 296
#define TOK_EXTERN 297
#define TOK_FLOAT_ID 298
#define TOK_FOR 299
#define TOK_FUNCTION_ID 300
#define TOK_GAUGE 301
#define TOK_GLOBAL 302
#define TOK_IDENTIFIER 303
#define TOK_RESERVED 304
#define TOK_IF 305
#define TOK_IMPORT 306
#define TOK_INHERIT 307
#define TOK_FACET 308
#define TOK_INLINE 309
#define TOK_LOCAL_ID 310
#define TOK_FINAL_ID 311
#define TOK_FUNCTION_NAME 312
#define TOK_INT_ID 313
#define TOK_LAMBDA 314
#define TOK_MULTISET_ID 315
#define TOK_MULTISET_END 316
#define TOK_MULTISET_START 317
#define TOK_LSH_EQ 318
#define TOK_MAPPING_ID 319
#define TOK_MIXED_ID 320
#define TOK_MOD_EQ 321
#define TOK_MULT_EQ 322
#define TOK_NO_MASK 323
#define TOK_OBJECT_ID 324
#define TOK_OR_EQ 325
#define TOK_PRIVATE 326
#define TOK_PROGRAM_ID 327
#define TOK_PROTECTED 328
#define TOK_PREDEF 329
#define TOK_PUBLIC 330
#define TOK_RSH_EQ 331
#define TOK_STATIC 332
#define TOK_STRING_ID 333
#define TOK_SUB_EQ 334
#define TOK_TYPEDEF 335
#define TOK_TYPEOF 336
#define TOK_VARIANT 337
#define TOK_VERSION 338
#define TOK_VOID_ID 339
#define TOK_WHILE 340
#define TOK_XOR_EQ 341
#define TOK_OPTIONAL 342

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 185 "language.yacc" /* yacc.c:355  */

  int number;
  FLOAT_TYPE fnum;
  struct node_s *n;
  char *str;
  void *ptr;

#line 354 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 193 "language.yacc" /* yacc.c:358  */

/* Need to be included after YYSTYPE is defined. */
#define INCLUDED_FROM_LANGUAGE_YACC
#include "lex.h"
#include "pike_compiler.h"
#line 200 "language.yacc" /* yacc.c:358  */

/* Include <stdio.h> our selves, so that we can do our magic
 * without being disturbed... */
#include <stdio.h>
int yylex(YYSTYPE *yylval);
/* Bison is stupid, and tries to optimize for space... */
#ifdef YYBISON
#define short int
#endif /* YYBISON */


#line 387 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned /* short */ int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef /* short */ int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8263

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  112
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  201
/* YYNRULES -- Number of rules.  */
#define YYNRULES  656
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  974

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   342

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    98,    92,     2,
     105,   106,    97,    95,   104,    96,   111,    99,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   102,   101,
      94,    88,    93,    89,   110,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   107,     2,   108,    91,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   109,    90,   103,   100,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   380,   380,   381,   385,   386,   387,   390,   391,   404,
     405,   406,   407,   413,   438,   455,   466,   508,   508,   518,
     555,   561,   568,   574,   575,   580,   583,   590,   598,   599,
     604,   607,   680,   681,   684,   685,   688,   689,   690,   695,
     698,   703,   704,   705,   709,   722,   729,   735,   742,   744,
     749,   750,   756,   763,   765,   771,   790,   793,   802,   842,
     799,  1133,  1150,  1149,  1159,  1166,  1167,  1168,  1169,  1170,
    1171,  1172,  1173,  1179,  1185,  1193,  1191,  1204,  1205,  1210,
    1213,  1214,  1215,  1218,  1248,  1255,  1256,  1259,  1260,  1261,
    1269,  1277,  1278,  1279,  1280,  1281,  1282,  1283,  1284,  1285,
    1286,  1290,  1291,  1292,  1293,  1294,  1295,  1296,  1297,  1298,
    1299,  1300,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,  1313,  1314,  1315,  1316,  1317,  1318,  1319,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,  1349,  1349,  1349,  1351,  1351,  1352,  1360,  1367,
    1368,  1371,  1375,  1381,  1389,  1390,  1393,  1394,  1397,  1407,
    1417,  1418,  1427,  1427,  1429,  1436,  1439,  1446,  1449,  1462,
    1475,  1488,  1489,  1492,  1493,  1496,  1496,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,  1515,
    1521,  1525,  1531,  1540,  1626,  1629,  1630,  1643,  1646,  1647,
    1659,  1660,  1667,  1670,  1709,  1716,  1722,  1723,  1723,  1758,
    1762,  1757,  1789,  1802,  1803,  1806,  1808,  1807,  1813,  1814,
    1818,  1821,  1824,  1817,  1829,  1837,  1838,  1841,  1855,  1857,
    1856,  1881,  1885,  1890,  1897,  1913,  1914,  1933,  1938,  1944,
    1953,  1965,  1966,  1981,  1985,  1992,  1997,  1991,  2017,  2018,
    2025,  2026,  2027,  2032,  2038,  2039,  2044,  2045,  2050,  2088,
    2089,  2092,  2093,  2096,  2097,  2098,  2103,  2107,  2108,  2114,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2132,  2139,  2142,  2146,  2147,  2148,  2149,  2150,  2151,  2152,
    2153,  2157,  2156,  2173,  2174,  2177,  2178,  2179,  2185,  2188,
    2196,  2204,  2212,  2203,  2348,  2367,  2366,  2494,  2510,  2509,
    2644,  2660,  2706,  2709,  2710,  2711,  2718,  2719,  2722,  2723,
    2732,  2733,  2734,  2742,  2818,  2741,  2998,  2999,  3002,  3003,
    3007,  3008,  3074,  3080,  3081,  3082,  3087,  3097,  3086,  3118,
    3139,  3143,  3138,  3163,  3164,  3165,  3172,  3173,  3176,  3187,
    3190,  3191,  3192,  3196,  3197,  3200,  3201,  3206,  3210,  3205,
    3233,  3241,  3248,  3257,  3258,  3266,  3270,  3265,  3290,  3294,
    3289,  3310,  3311,  3315,  3319,  3314,  3334,  3338,  3342,  3348,
    3349,  3353,  3357,  3364,  3376,  3382,  3383,  3386,  3388,  3389,
    3392,  3393,  3396,  3397,  3398,  3399,  3400,  3404,  3405,  3411,
    3412,  3414,  3415,  3416,  3417,  3418,  3427,  3428,  3429,  3430,
    3436,  3443,  3444,  3447,  3448,  3449,  3450,  3451,  3452,  3453,
    3454,  3455,  3456,  3459,  3459,  3461,  3462,  3466,  3467,  3470,
    3471,  3474,  3475,  3484,  3487,  3491,  3494,  3495,  3496,  3497,
    3498,  3499,  3500,  3501,  3502,  3503,  3504,  3505,  3506,  3507,
    3508,  3509,  3510,  3511,  3512,  3513,  3514,  3515,  3516,  3517,
    3518,  3519,  3520,  3521,  3522,  3523,  3524,  3525,  3526,  3527,
    3528,  3529,  3530,  3533,  3534,  3539,  3544,  3545,  3546,  3547,
    3548,  3551,  3552,  3553,  3575,  3579,  3576,  3671,  3677,  3683,
    3690,  3696,  3705,  3716,  3717,  3718,  3719,  3720,  3721,  3722,
    3723,  3724,  3725,  3726,  3727,  3728,  3734,  3740,  3747,  3753,
    3759,  3761,  3763,  3765,  3773,  3780,  3790,  3797,  3804,  3805,
    3810,  3811,  3812,  3813,  3817,  3822,  3823,  3824,  3830,  3833,
    3834,  3901,  3907,  3908,  3917,  3933,  3940,  3941,  3944,  3983,
    3991,  4021,  4024,  4050,  4058,  4074,  4078,  4135,  4140,  4186,
    4187,  4188,  4227,  4235,  4236,  4238,  4240,  4245,  4252,  4267,
    4290,  4291,  4292,  4297,  4300,  4301,  4302,  4307,  4308,  4309,
    4310,  4314,  4313,  4324,  4331,  4338,  4346,  4353,  4360,  4366,
    4373,  4379,  4385,  4386,  4391,  4392,  4395,  4396,  4402,  4413,
    4417,  4423,  4424,  4430,  4431,  4462,  4463,  4481,  4482,  4484,
    4486,  4488,  4490,  4492,  4494,  4496,  4498,  4500,  4502,  4504,
    4506,  4508,  4510,  4512,  4514,  4516,  4526,  4528,  4530,  4532,
    4534,  4536,  4538,  4540,  4542,  4544,  4546,  4548,  4550,  4552,
    4554,  4556,  4558,  4560,  4562,  4564,  4566,  4568,  4570,  4572,
    4574,  4576,  4578,  4580,  4582,  4584,  4586
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ARROW", "TOK_CONSTANT", "TOK_FLOAT",
  "TOK_STRING", "TOK_NUMBER", "TOK_INC", "TOK_DEC", "TOK_RETURN", "TOK_EQ",
  "TOK_GE", "TOK_LE", "TOK_NE", "TOK_NOT", "TOK_LSH", "TOK_RSH",
  "TOK_LAND", "TOK_LOR", "TOK_SWITCH", "TOK_SSCANF", "TOK_CATCH",
  "TOK_FOREACH", "TOK_LEX_EOF", "TOK_ADD_EQ", "TOK_AND_EQ", "TOK_ARRAY_ID",
  "TOK_ATTRIBUTE_ID", "TOK_BREAK", "TOK_CASE", "TOK_CLASS",
  "TOK_COLON_COLON", "TOK_CONTINUE", "TOK_DEFAULT", "TOK_DEPRECATED_ID",
  "TOK_DIV_EQ", "TOK_DO", "TOK_DOT_DOT", "TOK_DOT_DOT_DOT", "TOK_ELSE",
  "TOK_ENUM", "TOK_EXTERN", "TOK_FLOAT_ID", "TOK_FOR", "TOK_FUNCTION_ID",
  "TOK_GAUGE", "TOK_GLOBAL", "TOK_IDENTIFIER", "TOK_RESERVED", "TOK_IF",
  "TOK_IMPORT", "TOK_INHERIT", "TOK_FACET", "TOK_INLINE", "TOK_LOCAL_ID",
  "TOK_FINAL_ID", "TOK_FUNCTION_NAME", "TOK_INT_ID", "TOK_LAMBDA",
  "TOK_MULTISET_ID", "TOK_MULTISET_END", "TOK_MULTISET_START",
  "TOK_LSH_EQ", "TOK_MAPPING_ID", "TOK_MIXED_ID", "TOK_MOD_EQ",
  "TOK_MULT_EQ", "TOK_NO_MASK", "TOK_OBJECT_ID", "TOK_OR_EQ",
  "TOK_PRIVATE", "TOK_PROGRAM_ID", "TOK_PROTECTED", "TOK_PREDEF",
  "TOK_PUBLIC", "TOK_RSH_EQ", "TOK_STATIC", "TOK_STRING_ID", "TOK_SUB_EQ",
  "TOK_TYPEDEF", "TOK_TYPEOF", "TOK_VARIANT", "TOK_VERSION", "TOK_VOID_ID",
  "TOK_WHILE", "TOK_XOR_EQ", "TOK_OPTIONAL", "'='", "'?'", "'|'", "'^'",
  "'&'", "'>'", "'<'", "'+'", "'-'", "'*'", "'%'", "'/'", "'~'", "';'",
  "':'", "'}'", "','", "'('", "')'", "'['", "']'", "'{'", "'@'", "'.'",
  "$accept", "all", "program", "string_constant",
  "optional_rename_inherit", "low_program_ref", "program_ref", "facet",
  "inherit_ref", "@1", "inheritance", "import", "constant_name",
  "constant_list", "constant", "block_or_semi", "type_or_error",
  "open_paren_with_line_info", "close_paren_or_missing",
  "close_brace_or_missing", "close_brace_or_eof",
  "open_bracket_with_line_info", "close_bracket_or_missing",
  "push_compiler_frame0", "optional_constant", "def", "@2", "@3", "$@4",
  "@5", "optional_dot_dot_dot", "optional_identifier", "new_arg_name",
  "func_args", "arguments", "arguments2", "modifier", "magic_identifiers1",
  "magic_identifiers2", "magic_identifiers3", "magic_identifiers",
  "magic_identifier", "modifiers", "modifier_list", "attribute",
  "optional_attributes", "optional_stars", "cast", "soft_cast",
  "full_type", "type6", "type", "type7", "simple_type", "simple_type2",
  "simple_identifier_type", "type4", "type2", "type8", "basic_type",
  "identifier_type", "number_or_maxint", "number_or_minint",
  "expected_dot_dot", "opt_int_range", "opt_string_width",
  "opt_object_type", "@6", "opt_function_type", "$@7", "$@8",
  "function_type_list", "function_type_list2", "$@9", "opt_array_type",
  "opt_mapping_type", "$@10", "$@11", "$@12", "name_list", "new_name",
  "@13", "new_local_name", "new_local_name2", "line_number_info", "block",
  "@14", "@15", "end_block", "failsafe_block", "propagated_type",
  "local_name_list", "local_name_list2", "local_constant_name",
  "local_constant_list", "local_constant", "statements",
  "statement_with_semicolon", "normal_label_statement", "statement",
  "labeled_statement", "$@16", "optional_label", "break", "default",
  "continue", "push_compiler_frame1", "implicit_identifier", "lambda",
  "$@17", "@18", "local_function", "@19", "local_function2", "@20",
  "create_arg", "create_arguments2", "create_arguments",
  "optional_create_arguments", "failsafe_program", "class", "@21", "@22",
  "simple_identifier", "enum_value", "enum_def", "propagated_enum_value",
  "enum_list", "enum", "$@23", "@24", "typedef", "cond", "@25", "@26",
  "end_cond", "optional_else_part", "safe_lvalue", "safe_expr0",
  "foreach_optional_lvalue", "foreach_lvalues", "foreach", "@27", "@28",
  "do", "expected_semicolon", "for", "@29", "@30", "while", "@31", "@32",
  "for_expr", "switch", "@33", "@34", "case", "expected_colon", "return",
  "unused", "unused2", "optional_comma_expr", "safe_comma_expr",
  "comma_expr", "comma_expr2", "expr00", "expr0", "expr01", "assign",
  "optional_comma", "expr_list", "expr_list2", "m_expr_list",
  "m_expr_list2", "assoc_pair", "expr1", "expr2", "expr3",
  "optional_block", "@35", "apply", "implicit_modifiers", "expr4",
  "idents2", "idents", "inherit_specifier", "low_idents", "range_bound",
  "gauge", "typeof", "catch_arg", "catch", "$@36", "sscanf", "lvalue",
  "low_lvalue_list", "lvalue_list", "string_segment", "string",
  "bad_identifier", "bad_expr_ident", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    61,    63,
     124,    94,    38,    62,    60,    43,    45,    42,    37,    47,
     126,    59,    58,   125,    44,    40,    41,    91,    93,   123,
      64,    46
};
# endif

#define YYPACT_NINF -765

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-765)))

#define YYTABLE_NINF -654

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -765,    66,   949,  -765,   410,  -765,   306,    22,  -765,  -765,
    -765,  -765,  -765,  -765,   243,  6286,  -765,  -765,  -765,  -765,
     569,  -765,  7762,   211,    60,  -765,  -765,    76,    91,    41,
     147,  7110,  -765,  -765,   291,   171,  7179,  -765,  -765,   398,
    7636,  -765,  7690,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,   258,  -765,  7831,  7900,  -765,  -765,  7248,
    -765,   302,   307,  -765,  -765,   749,   382,   283,  -765,   261,
     299,  7969,  7969,   591,   255,   467,   334,    78,   338,  -765,
     356,   358,   334,   361,  -765,   366,   366,   358,  -765,  6667,
     253,  -765,  -765,  -765,   296,  -765,   110,   395,   423,  -765,
    -765,   253,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,   300,  -765,  2959,  -765,  -765,  2959,  -765,  7317,
    2959,  -765,  -765,  -765,   343,  -765,  -765,  -765,   631,  7386,
     409,   422,  -765,   296,   262,  7636,  -765,  -765,   262,  5310,
    -765,  -765,   357,  -765,  -765,  -765,  -765,  -765,   418,  -765,
    -765,  -765,  -765,  -765,   439,  -765,  7636,  3900,   262,  5256,
    -765,  -765,  -765,  -765,  -765,  -765,  6186,  6186,  6206,   442,
      71,  -765,  5488,   516,   123,  -765,    76,   444,  6206,  6206,
    -765,  -765,  2054,  5899,  6206,  6206,  -765,  -765,  -765,  -765,
    6478,  -765,  -765,  -765,   310,  6313,  -765,   296,  -765,  -765,
    -765,  -765,   262,  1112,  -765,   463,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,   262,   179,   253,
     204,   447,   194,  7582,   470,  -765,   562,   355,  7636,   467,
    -765,  -765,  -765,  -765,  -765,   197,  -765,  6740,   322,  -765,
     442,  -765,    87,   516,  -765,   444,  3066,   181,   181,  4109,
    -765,   224,  3387,    87,  -765,  2161,  -765,  -765,  -765,  8038,
    -765,  2637,  3494,  -765,  -765,   335,  5992,  5700,   270,   483,
    -765,   146,  -765,  5899,   534,   238,  -765,   181,  5441,   481,
     480,  -765,  -765,  -765,  4072,  4101,  4208,  4237,  4344,  4373,
    4480,  4509,  6206,  4616,  4645,  4752,  4781,  4888,  4917,  5024,
    5053,  5160,  5189,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  3601,  2744,
    1411,  3708,  6099,  6099,   511,  6401,   262,  -765,  -765,   522,
    7636,  -765,  -765,  -765,   532,   420,   530,  -765,  -765,  -765,
    -765,  -765,   218,   -12,  -765,   536,  7636,   538,   165,  -765,
     -27,  -765,  -765,   238,   359,    57,  -765,   432,  -765,  8107,
     483,  -765,   541,   545,  -765,  -765,  -765,  -765,   381,  6099,
    -765,  -765,   -11,   560,   462,   563,  -765,  -765,  -765,  -765,
     565,  5899,   424,   566,   567,  -765,  6267,  1112,  -765,  -765,
    7636,  6099,  -765,   579,   573,  -765,  -765,  5899,  -765,   687,
    -765,   605,  -765,   528,  -765,   528,  -765,   605,  -765,   620,
    -765,   620,  -765,  6495,  -765,  5402,   575,  -765,  6504,  -765,
    5389,  -765,  4178,  -765,   528,  -765,   528,  -765,   311,  -765,
     311,  -765,  -765,  -765,  -765,  -765,  -765,  7041,  -765,  -765,
     535,   578,   312,  -765,  5807,   581,  -765,   587,   355,  -765,
    -765,  -765,  -765,    59,    70,  -765,   609,  -765,   269,  -765,
     272,  -765,  -765,   618,   347,  -765,  -765,   704,   616,  -765,
    -765,  -765,  3173,   124,  6099,   621,  6813,  -765,  -765,  -765,
    -765,  -765,   547,  6099,  -765,  -765,  -765,  -765,  6886,  -765,
     625,  -765,   237,  -765,   626,  -765,   643,  -765,  -765,   129,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  5992,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,   630,   639,  -765,  -765,
    -765,  -765,  3815,  -765,   632,  2851,  -765,  -765,  -765,  -765,
     481,  -765,  6099,  6099,  6206,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,   640,   640,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  5593,  7636,
    -765,   416,   646,  -765,  -765,  -765,  -765,  -765,  2959,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  7636,  -765,  -765,  7636,
    -765,  -765,  6099,  -765,  -765,  -765,  7582,   671,   673,  -765,
    -765,  -765,  -765,   117,   240,   676,  -765,  2959,   219,  -765,
    2959,  -765,  -765,   660,  -765,  -765,   476,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,   659,
    -765,  -765,    51,  -765,  -765,  -765,  3988,  -765,  8176,  7636,
     532,   532,  -765,  7582,  -765,   670,   430,    25,  -765,   555,
     674,  3280,   235,  6099,  -765,  -765,  -765,  7582,  -765,  -765,
    -765,  1304,  -765,  -765,  -765,  6594,  -765,  -765,  -765,  -765,
     325,   678,   646,    73,  7636,  7636,  -765,  7969,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  6959,
    -765,   646,   102,  -765,   684,  7455,  1046,   677,   681,   265,
    1196,   265,   816,  5243,   683,    15,   686,  5360,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,     6,  -765,
       6,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,     6,
    -765,   102,  -765,   731,  -765,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,   102,   701,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,   551,   705,  -765,   328,
     707,  -765,  -765,  -765,  -765,     6,  -765,  -765,  -765,  -765,
    -765,  2268,   703,  -765,  -765,  1519,  -765,   690,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,    73,  -765,  -765,  2959,
    -765,  -765,  2959,  -765,  7524,  2959,  -765,  -765,  -765,   424,
    1626,  -765,    11,  -765,  1519,  -765,  -765,  1304,  -765,  -765,
    -765,   711,  -765,  -765,   697,   698,  -765,   424,  -765,  -765,
     167,   706,  -765,   709,   710,  -765,  2268,  6099,  -765,  -765,
    2268,  1840,  2268,  2268,   373,   353,   373,     6,  -765,   373,
     373,  -765,  -765,  -765,  1519,  2452,  2544,   373,     6,  1947,
    1519,  1519,  -765,  -765,  -765,   715,  -765,  -765,  1519,  -765,
       6,  -765,   770,  -765,  2360,  -765,  1733,  1519,  -765,  -765,
     373,  -765,  1519,  -765
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       6,     0,     0,     1,     0,     3,     0,     0,     5,    66,
      65,    67,    68,     4,   164,   158,    71,    72,    73,    74,
       0,   603,     0,     0,   552,   553,   604,     0,     0,     0,
       0,     0,   542,   605,     0,     0,     0,   254,   346,     0,
       0,    75,     0,    69,    70,    93,    99,    96,    91,    90,
      95,    98,    97,    92,   100,    94,   160,    29,    28,    30,
     640,   648,   647,   644,   655,   608,   609,   650,   651,   610,
     652,   653,   611,   638,   639,   612,   636,   613,   654,   614,
     645,   561,   625,   656,   641,   643,   642,   626,   627,   637,
     615,   616,   646,   619,   617,   618,   628,   620,   630,   621,
     631,   629,   632,   635,   622,   623,   649,   634,   624,   633,
     562,   607,   549,     0,   548,     0,     0,   544,    26,     0,
     560,   558,   559,    27,   606,     0,     0,     0,    34,     0,
       0,    82,    82,     0,     0,     0,   229,     0,     0,   187,
     222,   212,   229,   234,   189,   216,   216,   212,   188,     0,
     170,   182,   185,   186,   203,     6,     0,   163,    56,   165,
      44,   178,   545,   554,   555,   556,   557,   547,   543,   546,
     550,   551,     0,    38,     0,    37,    39,     0,    36,     0,
       0,    80,   333,    81,     0,    24,    23,    25,     0,     0,
       0,    13,    18,    14,     7,     0,   196,   200,     0,     0,
     219,   193,     0,   191,   197,   230,   192,   194,     0,   195,
     215,   190,   336,   171,     0,   337,     0,     0,     0,     0,
      57,   167,    16,   362,   505,   504,   502,   502,   502,   647,
     644,   361,     0,   627,   646,   254,   629,   649,   502,   502,
      45,    52,     0,   502,   502,   502,   510,    33,   360,   411,
     421,   446,   483,   514,     0,   491,   513,   539,   507,   508,
     506,   509,   503,     0,    31,     0,    35,    32,   334,   347,
      21,    20,    22,    11,     9,    10,    19,     0,     0,   177,
       0,     0,     0,   433,     0,   208,     0,     0,     0,     0,
     349,   181,    51,    50,    76,     0,   162,     0,     0,   235,
       0,   581,     0,     0,   254,     0,     0,   486,   487,     0,
     488,   491,     0,     0,   580,     0,   255,   579,   568,     0,
     310,     0,     0,   490,   489,     0,   435,   439,     0,   175,
     184,     0,   407,   502,     0,   172,   173,   596,   203,   601,
       0,   599,   484,   485,     0,     0,     0,     0,     0,     0,
       0,     0,   502,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   511,   512,   254,   492,   493,   428,   423,
     432,   426,   431,   430,   424,   427,   429,   425,     0,     0,
       0,     0,   502,   502,   328,     0,     8,   176,   228,     0,
       0,   202,   201,   434,   225,    79,   433,   223,   214,   209,
     210,   211,   204,     0,    15,     0,   434,     0,    55,   166,
     238,    64,   167,     0,     0,     0,   582,     0,   167,     0,
     179,   180,     0,   402,   254,   540,   541,   309,     0,   502,
     437,   409,     0,   433,     0,     0,   529,   530,   531,   528,
      49,   502,     0,    54,   433,   441,   491,   599,   174,   168,
       0,   502,   523,   172,     0,   598,   169,   502,   600,     0,
     470,   452,   473,   455,   475,   457,   471,   453,   476,   458,
     477,   459,   466,   448,   465,   447,     0,   467,   449,   468,
     450,   469,   451,   472,   454,   474,   456,   478,   460,   479,
     461,   480,   462,   481,   463,   482,   464,     0,   413,   412,
       0,     0,     0,   566,   502,     0,   564,   407,     0,   417,
     416,   414,   418,   159,     0,   345,   338,   343,     0,   199,
       0,    78,    77,     0,   226,   224,   205,     0,     0,   231,
     218,   161,     0,     0,   502,     0,     0,   236,   593,   595,
     594,   592,     0,   502,   576,   578,   577,   575,     0,   264,
     403,   406,   250,   266,   404,   405,   251,   574,   256,     0,
     534,   532,   535,   536,   533,   410,   526,   527,   434,   436,
     572,   573,   571,   570,   569,    48,     0,     0,   392,   390,
     389,   391,     0,    53,     0,     0,   440,   183,   408,   597,
     601,   420,   502,   502,   502,   538,   139,   147,   149,   148,
     134,   133,   114,   115,   137,   138,   136,   140,   141,   116,
     129,   132,   126,   104,   124,   130,   120,   135,   151,   155,
     156,   128,   143,   144,   142,   109,   106,   102,   121,   125,
     145,   118,   117,   113,   101,   119,   105,   122,   108,   146,
     107,   103,   123,   127,   150,   111,   112,   131,   110,   152,
     153,   154,   157,   537,   499,   500,   501,   494,   494,   519,
     520,   521,   522,   518,   567,   565,   515,   516,   502,     0,
     323,   433,    47,   326,   331,   332,     6,   335,     0,   341,
     259,   258,   342,   348,   198,   220,     0,   206,   213,     0,
     241,   242,   502,    61,    58,   243,   433,   237,   238,   589,
     591,   590,   588,     0,   244,   245,   263,     0,     0,   263,
       0,   277,   314,     0,   438,   524,     0,   445,   444,   525,
     443,   442,   602,   415,   419,   422,   254,   498,   497,     0,
     167,   159,   159,   327,    46,   329,     0,   339,   340,     0,
     227,   232,   240,   433,    87,     0,   433,    79,    85,     0,
       0,     0,     0,   502,   167,   252,   317,   433,   315,   167,
     253,     0,   312,   309,   517,    79,   325,   324,   330,   344,
       0,     0,    47,     0,     0,   434,    86,    82,   585,   587,
     586,   584,   583,   248,   249,   246,   320,   318,   247,     0,
     265,    47,     0,   267,     0,     0,     0,   648,   655,   650,
       0,   652,   307,   254,   654,   552,   656,     0,   378,   291,
     281,   285,   257,   284,   280,   292,   278,   300,     0,   299,
       0,   282,   296,   294,   295,   293,   297,   298,   283,     0,
     397,     0,   495,     0,   322,   221,   233,    59,    43,    42,
      41,    63,    40,    89,    88,    83,     0,   244,    84,   261,
     262,   260,   316,   289,   288,   290,     0,     0,   271,     0,
       0,   401,   374,   373,   393,     0,   400,   254,   254,   303,
     305,     0,     0,   308,   306,     0,   254,     0,   254,   254,
     286,   287,   279,   313,   277,   321,     0,   319,   275,     0,
     274,   276,     0,   273,     0,     0,   394,   384,   368,     0,
       0,   386,     0,   376,     0,   351,   379,     0,    60,   270,
     268,     0,   272,   269,     0,     0,   388,     0,   399,   372,
       0,     0,   302,     0,     0,   496,     0,   502,   387,   371,
       0,     0,     0,     0,     0,     0,     0,     0,   396,     0,
       0,   355,   354,   353,     0,     0,     0,     0,     0,     0,
       0,     0,   385,   359,   364,     0,   358,   365,     0,   370,
       0,   382,   356,   380,     0,   369,     0,     0,   352,   366,
       0,   357,     0,   377
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -765,  -765,  -146,  -150,  -765,   523,  -765,  -765,  -765,  -765,
    -765,    -1,   642,  -765,  -765,   -68,   150,  -202,  -707,  -765,
    -765,   250,  -765,  -765,  -765,  -765,  -765,  -765,  -765,  -765,
    -692,  -126,  -268,  -632,  -476,  -765,  -765,  -765,  -765,  -765,
    -765,  -765,  -501,  -765,  -765,  -765,  -194,  -765,  -765,  -765,
    -765,  -199,  -119,  -765,  -765,  -765,   -32,  -240,  -193,   131,
     -29,  -765,  -765,  -482,   675,  -765,   680,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,   682,  -765,  -765,  -765,  -765,  -765,
     417,  -765,  -668,  -765,   -33,  -201,  -765,  -765,  -719,  -764,
     121,  -765,  -765,   -61,  -765,  -765,   -48,  -765,  -765,  -285,
    -765,  -765,    36,  -765,  -765,  -765,  -523,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -203,  -765,  -765,  -765,  -765,
     584,  -765,  -765,   691,  -765,   109,  -765,  -765,   594,  -765,
    -765,  -765,  -765,  -765,  -765,  -261,  -765,   -97,   -64,  -114,
    -765,  -765,  -765,  -765,  -765,  -643,  -765,  -765,  -765,  -765,
    -765,  -765,  -765,  -765,  -765,  -765,  -765,  -286,  -765,  -115,
    -765,  -765,  -551,   -36,    54,   285,  -118,  -324,  -247,  -238,
    -275,  -765,  -765,  -765,   271,  6178,   252,  -765,   196,  -765,
    -765,  -765,  -206,  -765,    -6,  -765,  -765,   187,  -765,  -765,
     544,  -765,  -765,  -765,  -442,  -256,  -544,   -16,     1,    18,
     -17
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,   191,   190,   192,   405,     9,   134,   135,
      10,   810,   128,   129,    12,   841,   158,   242,   735,   576,
     294,   243,   584,   533,   221,    13,   743,   886,   535,   155,
     523,   182,   744,   758,   745,   746,    56,   649,   650,   651,
     652,   653,    14,    15,   159,    42,   789,   244,   245,   149,
     334,   453,   747,   160,   418,   419,   279,   420,   151,   330,
     421,   528,   287,   402,   203,   211,   207,   208,   201,   283,
     739,   395,   396,   686,   196,   206,   288,   689,   771,   298,
     299,   692,   549,   553,   320,   811,   424,   711,   683,   852,
     754,   550,   554,   858,   859,   813,   761,   814,   815,   816,
     817,   877,   870,   818,   819,   820,   559,   427,   246,   713,
     831,   555,   792,   551,   846,   670,   671,   672,   514,   677,
      43,   268,   384,   516,   679,   517,   738,   518,    44,   132,
     385,    16,   821,   878,   923,   944,   968,   954,   247,   955,
     947,   822,   868,   915,   823,   864,   824,   876,   921,   825,
     879,   924,   960,   826,   867,   914,   827,   582,   828,   937,
     829,   917,   938,   866,   423,   430,   332,   249,   381,   748,
     432,   433,   443,   444,   445,   250,   251,   252,   727,   884,
     253,   254,   255,   256,   257,    31,    32,   508,   258,   259,
     318,   260,   313,   261,   339,   340,   458,    33,   262,   183,
     263
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      30,    11,   329,   329,   131,   111,   184,    34,   150,   217,
     161,   153,   669,   153,   111,   590,   383,   768,   124,   111,
     307,   308,   311,   291,   306,   306,   668,   297,   476,   708,
     862,   317,   311,   311,   154,   919,   154,   337,   311,   311,
     110,   306,   812,   328,   335,   397,   722,   114,   280,   122,
     566,   440,  -434,   379,   130,   777,   248,   407,   542,   248,
    -433,   534,   248,   521,   522,   837,     3,   883,   295,   329,
      35,   674,  -581,   833,   838,  -434,   278,   454,   -62,   197,
     282,   762,   887,  -433,   848,   387,   790,   329,   314,   117,
     529,   793,   114,   329,   675,   567,   920,   839,   111,   111,
     282,   317,   111,   849,   501,   379,   379,   863,   115,   379,
     413,   197,   317,   264,   111,   111,   267,  -301,   749,   172,
     787,   446,   387,   116,  -254,   693,   850,   337,   335,   193,
     712,   306,   111,   164,   166,   379,   194,   169,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,  -434,   525,   750,
    -434,   543,   111,   393,   394,  -433,   153,   215,  -433,   403,
     153,   152,   111,   152,   840,   880,  -581,   881,   124,   676,
    -581,   752,   316,   198,   365,   577,   882,   153,   925,   154,
     153,   929,   315,   154,   415,   569,   316,   130,   389,   194,
     383,   329,   321,   431,   435,   389,   586,   275,   431,   442,
     154,   316,   593,   154,   336,   218,    11,   329,   536,   194,
     756,   457,   896,  -601,   548,   526,   341,   365,  -254,   694,
     669,   669,   366,   367,  -311,   337,   786,   338,  -309,   306,
     832,  -309,   335,   112,   379,   865,   124,    36,   118,   872,
     451,   337,   452,   532,   153,   306,   188,   587,   119,   153,
     499,   431,   507,   510,   511,   512,  -237,   772,    21,  -237,
     725,   520,   930,   125,    37,   673,   387,   154,   386,   422,
     111,   791,   154,   193,    38,   388,   240,   520,   241,  -304,
     194,   387,   277,   680,   949,    39,   331,    21,   336,   277,
     392,   406,   111,  -433,   336,   959,   162,    20,   390,   338,
     447,   565,    21,   869,   527,   410,   341,   966,   871,    26,
     899,   338,   113,    40,   757,   707,   152,   338,   751,   240,
     152,   241,   497,   588,   170,   448,   659,   426,    22,   171,
     757,    37,  -309,   216,   506,  -309,   456,   152,    26,   918,
     152,    38,    41,    23,    24,    25,   -12,   189,   284,   436,
     331,   153,   178,    26,   285,   179,  -304,   448,   111,   387,
     124,   177,   681,   682,   338,   934,   449,   153,   684,   936,
      27,   939,   940,   538,   154,  -434,  -434,   180,   311,    28,
     900,   558,   123,   400,   401,  -207,  -207,   941,   961,   133,
     154,   222,   111,   215,   -17,   560,   173,   119,   360,   361,
     362,   119,   336,   660,   152,   661,   695,    29,   662,   152,
     663,   153,   387,   411,   341,   703,   412,   220,   336,   893,
     -17,   835,   894,   733,    17,   338,   437,   556,   438,   195,
     341,   439,   561,   199,   154,   -17,   -17,   -17,   578,  -434,
     431,   338,   269,   286,   945,   -17,   544,   946,   521,   522,
     539,   200,   540,   202,   718,   541,   205,   442,   665,   593,
     174,  -217,   -17,    21,   723,   724,   942,   591,   309,   943,
     310,   -17,   562,   175,   563,   176,   570,   564,   309,   309,
     323,   324,   327,   333,   309,   309,   342,   343,   338,    22,
     219,   368,   369,   956,   956,   380,   843,   844,   776,   -17,
     276,    18,   370,    19,    23,    24,    25,   277,   731,   111,
     732,   152,   956,   289,    26,   579,   580,   581,   766,   767,
     736,   111,   774,   545,   775,   546,   765,   152,   547,   371,
     290,    27,   372,   373,   348,   349,   374,   312,   319,   322,
      28,   174,   375,   391,   698,   376,   327,   380,   380,   654,
     248,   380,   377,   571,   592,   572,   705,   740,   573,   399,
     741,   699,   842,   450,   742,   888,   398,   441,    29,   778,
    -597,   152,   455,   333,  -597,   457,   901,   380,   459,   248,
     902,   851,   248,    57,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   916,   737,   185,   513,   345,   346,   922,
     770,   348,   349,   358,   359,   360,   361,   362,   519,   387,
     851,   928,   506,   785,   524,   788,   655,   161,   656,   889,
     153,   657,   530,   755,   531,   851,   760,   557,   700,   451,
     701,   845,   890,   702,   891,   270,   779,   153,   780,   952,
     153,   781,   338,   154,   568,   962,   963,   153,   575,   574,
      58,   585,    59,   965,   583,   948,   448,   594,   950,   951,
     154,   589,   971,   154,   658,   842,   958,   973,   591,   666,
     154,   333,   186,   763,   187,   667,   380,   678,   356,   357,
     358,   359,   360,   361,   362,   329,   329,   333,   853,   972,
     153,   687,   368,   369,   153,   358,   359,   360,   361,   362,
     685,   111,   688,   370,   329,   830,   696,   578,   153,   706,
     709,   710,   271,   154,   272,    11,   715,   154,   719,   337,
     337,   400,   401,   306,   306,   153,   153,   716,   111,   726,
     371,   154,   734,   372,   373,   338,   215,   374,   337,   532,
     111,   534,   306,   375,   753,   757,   376,   764,   154,   154,
     875,   248,   111,   377,   248,   592,   773,   248,   111,   885,
     782,    22,  -383,   834,   836,   854,  -367,   855,  -375,   751,
     338,  -350,   904,   892,   338,   895,    23,    24,    25,   889,
     152,    30,   926,   927,   579,   580,   581,   705,    34,   935,
     967,   931,   404,   860,   932,   933,   964,   152,   908,   730,
     152,   266,   210,    27,   204,   909,   209,   152,   910,   537,
     759,   913,    28,   912,   897,   898,   907,   873,   363,   830,
     214,  -653,  -653,   903,   309,   905,   906,   769,   364,   957,
     969,   970,  -653,   714,   728,   729,   721,   416,     0,     0,
      29,     0,     0,     0,     0,   338,     0,     0,   830,   338,
     152,   830,     0,     0,   152,     0,     0,   111,     0,  -653,
       0,     0,  -653,  -653,     0,     0,  -653,     0,   152,     0,
       0,     0,  -653,     0,   338,  -653,     0,     0,   338,     0,
       0,   338,  -653,     0,  -653,   152,   152,     0,   830,     0,
       0,     0,   860,     0,   830,   830,   336,   336,   874,     0,
     338,     0,   830,     0,   338,   338,   338,   338,   341,   341,
       0,   830,     0,     0,     0,   336,   830,     0,   338,   338,
     338,     0,     0,   338,   338,   338,     0,   341,     0,    -2,
       4,     0,   338,  -159,     0,     0,     0,     0,   338,     0,
     338,   338,     0,     0,     0,     0,   338,     0,     0,     0,
       0,     0,     0,     5,     0,     0,  -159,  -159,     0,     0,
    -159,  -159,     0,     0,  -159,     0,     0,     0,     0,     0,
    -159,  -159,  -159,     0,  -159,     0,  -159,  -159,  -159,     0,
       6,  -159,     7,  -159,  -159,  -159,     0,  -159,     0,  -159,
       0,     0,     0,  -159,  -159,     0,     0,  -159,  -159,     0,
    -159,  -159,  -159,  -159,  -159,     0,  -159,  -159,     0,  -159,
       0,  -159,  -159,  -159,     0,     0,  -159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   861,     0,     0,
       8,   224,    21,   225,   226,   227,    60,     0,  -159,     0,
    -159,   228,     0,     0,     0,     0,    61,   229,   230,    64,
     862,  -640,  -640,   136,   137,    67,    68,  -502,    22,    70,
      71,   138,  -640,    73,     0,     0,    74,  -502,    76,   139,
      78,   140,   232,    23,    24,    25,    83,    84,    85,    86,
      87,   233,    89,    26,   141,   234,   142,     0,   235,  -640,
     143,   144,  -640,  -640,    96,   145,  -640,    98,   146,   100,
     236,   102,  -640,   103,   147,  -640,     0,   237,   107,    28,
     148,     0,  -640,   109,  -640,     0,     0,   368,   369,     0,
       0,     0,   238,     0,     0,     0,   239,   863,   370,     0,
       0,   240,     0,   241,     0,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   371,     0,     0,   372,   373,
       0,     0,   374,     0,     0,     0,     0,     0,   375,     0,
       0,   376,     0,     0,     0,   333,   333,   861,   377,     0,
     382,   224,    21,   225,   226,   227,    60,     0,     0,     0,
       0,   228,     0,     0,   333,     0,    61,   229,   230,    64,
       0,  -651,  -651,   136,   137,    67,    68,  -502,    22,    70,
      71,   138,  -651,    73,   400,   401,    74,  -502,    76,   139,
      78,   140,   232,    23,    24,    25,    83,    84,    85,    86,
      87,   233,    89,    26,   141,   234,   142,     0,   235,  -651,
     143,   144,  -651,  -651,    96,   145,  -651,    98,   146,   100,
     236,   102,  -651,   103,   147,  -651,     0,   237,   107,    28,
     148,     0,  -651,   109,  -651,     0,     0,     0,     0,     0,
       0,     0,   238,     0,     0,     0,   239,     0,     0,     0,
       0,   240,     0,   241,     0,   794,     0,    29,   795,   224,
      21,   225,   226,   227,   796,     0,     0,     0,     0,   228,
       0,     0,     0,     0,   797,   229,   230,   798,   680,     0,
       0,   136,   137,   799,   800,  -502,    22,   801,   802,   138,
       0,   803,     0,     0,    74,  -502,    76,   139,   804,   140,
     232,    23,   805,    25,   806,   807,    85,    86,    87,   233,
      89,    26,   141,   234,   142,     0,   235,     0,   143,   144,
       0,     0,    96,   145,     0,    98,   146,   100,   236,   102,
       0,   103,   147,     0,     0,   237,   107,    28,   148,   808,
       0,   109,     0,     0,     0,     0,     0,     0,     0,     0,
     238,     0,     0,     0,   239,   809,     0,   681,     0,   240,
       0,   241,   502,   316,     0,    29,   224,    21,   225,   226,
     227,    60,     0,     0,     0,     0,   228,     0,     0,     0,
       0,    61,   229,   230,    64,   503,     0,     0,   136,   137,
      67,    68,  -502,    22,    70,    71,   138,     0,    73,  -563,
    -563,    74,  -502,    76,   139,    78,   140,   232,    23,    24,
      25,    83,    84,    85,    86,    87,   233,    89,    26,   141,
     234,   142,     0,   235,     0,   143,   144,     0,     0,    96,
     145,     0,    98,   146,   100,   236,   102,     0,   103,   147,
       0,     0,   237,   107,    28,   148,     0,     0,   109,     0,
       0,     0,     0,     0,     0,   504,     0,   238,   505,     0,
       0,   239,     0,     0,     0,     0,   240,     0,   241,     0,
     794,     0,    29,   795,   224,    21,   225,   226,   227,   796,
       0,     0,     0,     0,   228,     0,     0,     0,     0,   797,
     229,   230,   798,     0,     0,     0,   136,   137,   799,   800,
    -502,    22,   801,   802,   138,     0,   803,     0,     0,    74,
    -502,    76,   139,   804,   140,   232,    23,   805,    25,   806,
     807,    85,    86,    87,   233,    89,    26,   141,   234,   142,
       0,   235,     0,   143,   144,     0,     0,    96,   145,     0,
      98,   146,   100,   236,   102,     0,   103,   147,     0,     0,
     237,   107,    28,   148,   808,     0,   109,     0,     0,     0,
       0,     0,     0,     0,     0,   238,     0,     0,     0,   239,
     809,     0,     0,     0,   240,     0,   241,   861,   316,     0,
      29,   224,    21,   225,   226,   227,    60,     0,     0,     0,
       0,   228,     0,     0,     0,     0,    61,   229,   230,    64,
    -398,     0,     0,   136,   137,    67,    68,  -502,    22,    70,
      71,   138,     0,    73,     0,     0,    74,  -502,    76,   139,
      78,   140,   232,    23,    24,    25,    83,    84,    85,    86,
      87,   233,    89,    26,   141,   234,   142,     0,   235,     0,
     143,   144,     0,     0,    96,   145,     0,    98,   146,   100,
     236,   102,     0,   103,   147,     0,     0,   237,   107,    28,
     148,     0,     0,   109,     0,     0,     0,     0,     0,     0,
       0,     0,   238,     0,     0,     0,   239,  -398,  -398,  -398,
       0,   240,     0,   241,   861,     0,     0,    29,   224,    21,
     225,   226,   227,    60,     0,     0,     0,     0,   228,     0,
       0,     0,     0,    61,   229,   230,    64,  -395,     0,     0,
     136,   137,    67,    68,  -502,    22,    70,    71,   138,     0,
      73,     0,     0,    74,  -502,    76,   139,    78,   140,   232,
      23,    24,    25,    83,    84,    85,    86,    87,   233,    89,
      26,   141,   234,   142,     0,   235,     0,   143,   144,     0,
       0,    96,   145,     0,    98,   146,   100,   236,   102,     0,
     103,   147,     0,     0,   237,   107,    28,   148,     0,     0,
     109,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,     0,   239,     0,     0,  -395,     0,   240,  -395,
     241,   861,     0,     0,    29,   224,    21,   225,   226,   227,
      60,     0,     0,     0,     0,   228,     0,     0,     0,     0,
      61,   229,   230,    64,  -395,     0,     0,   136,   137,    67,
      68,  -502,    22,    70,    71,   138,     0,    73,     0,     0,
      74,  -502,    76,   139,    78,   140,   232,    23,    24,    25,
      83,    84,    85,    86,    87,   233,    89,    26,   141,   234,
     142,     0,   235,     0,   143,   144,     0,     0,    96,   145,
       0,    98,   146,   100,   236,   102,     0,   103,   147,     0,
       0,   237,   107,    28,   148,     0,     0,   109,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,     0,
     239,  -395,     0,     0,     0,   240,     0,   241,   861,     0,
       0,    29,   224,    21,   225,   226,   227,    60,     0,     0,
       0,     0,   228,     0,     0,     0,     0,    61,   229,   230,
      64,  -381,     0,     0,   136,   137,    67,    68,  -502,    22,
      70,    71,   138,     0,    73,     0,     0,    74,  -502,    76,
     139,    78,   140,   232,    23,    24,    25,    83,    84,    85,
      86,    87,   233,    89,    26,   141,   234,   142,     0,   235,
       0,   143,   144,     0,     0,    96,   145,     0,    98,   146,
     100,   236,   102,     0,   103,   147,     0,     0,   237,   107,
      28,   148,     0,     0,   109,     0,     0,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,   239,  -381,     0,
       0,     0,   240,     0,   241,   325,     0,     0,    29,   224,
      21,   225,   226,   227,    60,     0,     0,     0,     0,   228,
       0,     0,     0,     0,    61,   229,   230,    64,     0,     0,
       0,   136,   137,    67,    68,  -502,    22,    70,    71,   138,
       0,    73,     0,     0,    74,  -502,    76,   139,    78,   140,
     232,    23,    24,    25,    83,    84,    85,    86,    87,   233,
      89,    26,   141,   234,   142,     0,   235,     0,   143,   144,
       0,     0,    96,   145,     0,    98,   146,   100,   236,   102,
       0,   103,   147,     0,     0,   237,   107,    28,   148,     0,
       0,   109,     0,     0,     0,     0,     0,     0,     0,     0,
     238,     0,     0,     0,   239,     0,     0,     0,     0,   240,
       0,   241,   417,   326,     0,    29,   224,    21,   225,   226,
     227,    60,     0,     0,     0,     0,   228,     0,     0,     0,
       0,    61,   229,   230,    64,     0,     0,     0,   136,   137,
      67,    68,  -502,    22,    70,    71,   138,     0,    73,     0,
       0,    74,  -502,    76,   139,    78,   140,   232,    23,    24,
      25,    83,    84,    85,    86,    87,   233,    89,    26,   141,
     234,   142,     0,   235,     0,   143,   144,     0,     0,    96,
     145,     0,    98,   146,   100,   236,   102,     0,   103,   147,
       0,     0,   237,   107,    28,   148,     0,     0,   109,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
       0,   239,     0,     0,     0,     0,   240,     0,   241,   861,
       0,     0,    29,   224,    21,   225,   226,   227,    60,     0,
       0,     0,     0,   228,     0,     0,     0,     0,    61,   229,
     230,    64,     0,     0,     0,   136,   137,    67,    68,  -502,
      22,    70,    71,   138,     0,    73,     0,     0,    74,  -502,
      76,   139,    78,   140,   232,    23,    24,    25,    83,    84,
      85,    86,    87,   233,    89,    26,   141,   234,   142,     0,
     235,     0,   143,   144,     0,     0,    96,   145,     0,    98,
     146,   100,   236,   102,     0,   103,   147,     0,     0,   237,
     107,    28,   148,     0,     0,   109,     0,     0,     0,     0,
       0,   953,     0,     0,   238,   224,    21,   225,   239,     0,
      60,     0,     0,   240,     0,   241,     0,     0,     0,    29,
      61,   229,   230,    64,  -363,     0,     0,   136,   137,    67,
      68,  -502,    22,    70,    71,   138,     0,    73,     0,     0,
      74,  -502,    76,   139,    78,   140,   232,    23,    24,    25,
      83,    84,    85,    86,    87,   233,    89,    26,   141,   234,
     142,     0,   235,     0,   143,   144,     0,     0,    96,   145,
       0,    98,   146,   100,   236,   102,     0,   103,   147,     0,
       0,   237,   107,    28,   148,     0,     0,   109,     0,     0,
       0,     0,     0,   953,     0,     0,     0,   224,    21,   225,
       0,     0,    60,  -363,     0,   240,  -363,   241,     0,     0,
       0,    29,    61,   229,   230,    64,     0,     0,     0,   136,
     137,    67,    68,  -502,    22,    70,    71,   138,     0,    73,
       0,     0,    74,  -502,    76,   139,    78,   140,   232,    23,
      24,    25,    83,    84,    85,    86,    87,   233,    89,    26,
     141,   234,   142,     0,   235,     0,   143,   144,     0,     0,
      96,   145,     0,    98,   146,   100,   236,   102,     0,   103,
     147,     0,     0,   237,   107,    28,   148,     0,     0,   109,
       0,     0,     0,     0,     0,   953,     0,     0,     0,   224,
      21,   225,     0,  -363,    60,     0,     0,   240,     0,   241,
       0,     0,     0,    29,    61,   229,   230,    64,     0,     0,
       0,   136,   137,    67,    68,  -502,    22,    70,    71,   138,
       0,    73,     0,     0,    74,  -502,    76,   139,    78,   140,
     232,    23,    24,    25,    83,    84,    85,    86,    87,   233,
      89,    26,   141,   234,   142,     0,   235,     0,   143,   144,
       0,     0,    96,   145,     0,    98,   146,   100,   236,   102,
       0,   103,   147,     0,     0,   237,   107,    28,   148,     0,
       0,   109,     0,     0,     0,     0,     0,     0,   428,     0,
       0,     0,   224,    21,   225,   226,   227,    60,     0,   240,
       0,   241,   228,     0,     0,    29,     0,    61,   229,   230,
      64,     0,     0,     0,     0,     0,    67,    68,  -502,    22,
      70,    71,     0,     0,    73,     0,     0,    74,  -502,    76,
       0,    78,     0,   232,    23,    24,    25,    83,    84,    85,
      86,    87,   233,    89,    26,     0,   234,     0,  -435,   235,
       0,     0,     0,     0,     0,    96,     0,     0,    98,     0,
     100,   236,   102,     0,   103,     0,     0,     0,   237,   107,
      28,     0,     0,     0,   109,     0,     0,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,   239,     0,     0,
       0,     0,   240,  -435,   241,   500,     0,   429,    29,   224,
      21,   225,   226,   227,    60,     0,     0,     0,     0,   228,
       0,     0,     0,     0,    61,   229,   230,    64,     0,     0,
       0,     0,     0,    67,    68,  -502,    22,    70,    71,     0,
       0,    73,     0,     0,    74,  -502,    76,     0,    78,     0,
     232,    23,    24,    25,    83,    84,    85,    86,    87,   233,
      89,    26,     0,   234,     0,     0,   235,     0,     0,     0,
       0,     0,    96,     0,     0,    98,     0,   100,   236,   102,
       0,   103,     0,     0,     0,   237,   107,    28,     0,     0,
       0,   109,     0,     0,     0,     0,     0,     0,     0,     0,
     238,     0,     0,     0,   239,     0,     0,     0,     0,   240,
    -435,   241,   720,     0,   429,    29,   224,    21,   225,   226,
     227,    60,     0,     0,     0,     0,   228,     0,     0,     0,
       0,    61,   229,   230,    64,     0,     0,     0,     0,     0,
      67,    68,  -502,    22,    70,    71,     0,     0,    73,     0,
       0,    74,  -502,    76,     0,    78,     0,   232,    23,    24,
      25,    83,    84,    85,    86,    87,   233,    89,    26,     0,
     234,     0,     0,   235,     0,     0,     0,     0,     0,    96,
       0,     0,    98,     0,   100,   236,   102,     0,   103,     0,
       0,     0,   237,   107,    28,     0,     0,     0,   109,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
       0,   239,     0,     0,     0,     0,   240,  -434,   241,  -434,
     223,     0,    29,     0,   224,    21,   225,   226,   227,    60,
       0,     0,     0,     0,   228,     0,     0,     0,     0,    61,
     229,   230,    64,   231,     0,     0,     0,     0,    67,    68,
    -502,    22,    70,    71,     0,     0,    73,     0,     0,    74,
    -502,    76,     0,    78,     0,   232,    23,    24,    25,    83,
      84,    85,    86,    87,   233,    89,    26,     0,   234,     0,
       0,   235,     0,     0,     0,     0,     0,    96,     0,     0,
      98,     0,   100,   236,   102,     0,   103,     0,     0,     0,
     237,   107,    28,     0,     0,     0,   109,     0,     0,     0,
       0,     0,     0,     0,     0,   238,     0,     0,     0,   239,
       0,     0,     0,     0,   240,     0,   241,   325,     0,     0,
      29,   224,    21,   225,   226,   227,    60,     0,     0,     0,
       0,   228,     0,     0,     0,     0,    61,   229,   230,    64,
       0,     0,     0,     0,     0,    67,    68,  -502,    22,    70,
      71,     0,     0,    73,     0,     0,    74,  -502,    76,     0,
      78,     0,   232,    23,    24,    25,    83,    84,    85,    86,
      87,   233,    89,    26,     0,   234,     0,     0,   235,     0,
       0,     0,     0,     0,    96,     0,     0,    98,     0,   100,
     236,   102,     0,   103,     0,     0,     0,   237,   107,    28,
       0,     0,     0,   109,     0,     0,     0,     0,     0,     0,
       0,     0,   238,     0,     0,     0,   239,     0,     0,     0,
       0,   240,     0,   241,   690,   326,     0,    29,  -239,  -239,
    -239,  -239,  -239,  -239,     0,     0,     0,     0,  -239,     0,
       0,     0,     0,  -239,  -239,  -239,  -239,   691,     0,     0,
       0,     0,  -239,  -239,  -239,  -239,  -239,  -239,     0,     0,
    -239,     0,     0,  -239,  -239,  -239,     0,  -239,     0,  -239,
    -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,
    -239,     0,  -239,     0,     0,  -239,     0,     0,     0,     0,
       0,  -239,     0,     0,  -239,     0,  -239,  -239,  -239,     0,
    -239,     0,     0,     0,  -239,  -239,  -239,     0,     0,     0,
    -239,     0,     0,     0,     0,     0,     0,     0,     0,  -239,
       0,     0,     0,  -239,     0,     0,     0,     0,  -239,     0,
    -239,   783,     0,     0,  -239,   224,    21,   225,   226,   227,
      60,     0,     0,     0,     0,   228,     0,     0,     0,     0,
      61,   229,   230,    64,   784,     0,     0,     0,     0,    67,
      68,  -502,    22,    70,    71,     0,     0,    73,     0,     0,
      74,  -502,    76,     0,    78,     0,   232,    23,    24,    25,
      83,    84,    85,    86,    87,   233,    89,    26,     0,   234,
       0,     0,   235,     0,     0,     0,     0,     0,    96,     0,
       0,    98,     0,   100,   236,   102,     0,   103,     0,     0,
       0,   237,   107,    28,     0,     0,     0,   109,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,     0,
     239,     0,     0,     0,     0,   240,     0,   241,   414,     0,
       0,    29,   224,    21,   225,   226,   227,    60,     0,     0,
       0,     0,   228,     0,     0,     0,     0,    61,   229,   230,
      64,     0,     0,     0,     0,     0,    67,    68,  -502,    22,
      70,    71,     0,     0,    73,     0,     0,    74,  -502,    76,
       0,    78,     0,   232,    23,    24,    25,    83,    84,    85,
      86,    87,   233,    89,    26,     0,   234,     0,     0,   235,
       0,     0,     0,     0,     0,    96,     0,     0,    98,     0,
     100,   236,   102,     0,   103,     0,     0,     0,   237,   107,
      28,     0,     0,     0,   109,     0,     0,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,   239,     0,     0,
       0,     0,   240,     0,   241,   434,     0,     0,    29,   224,
      21,   225,   226,   227,    60,     0,     0,     0,     0,   228,
       0,     0,     0,     0,    61,   229,   230,    64,     0,     0,
       0,     0,     0,    67,    68,  -502,    22,    70,    71,     0,
       0,    73,     0,     0,    74,  -502,    76,     0,    78,     0,
     232,    23,    24,    25,    83,    84,    85,    86,    87,   233,
      89,    26,     0,   234,     0,     0,   235,     0,     0,     0,
       0,     0,    96,     0,     0,    98,     0,   100,   236,   102,
       0,   103,     0,     0,     0,   237,   107,    28,     0,     0,
       0,   109,     0,     0,     0,     0,     0,     0,     0,     0,
     238,     0,     0,     0,   239,     0,     0,     0,     0,   240,
       0,   241,   498,     0,     0,    29,   224,    21,   225,   226,
     227,    60,     0,     0,     0,     0,   228,     0,     0,     0,
       0,    61,   229,   230,    64,     0,     0,     0,     0,     0,
      67,    68,  -502,    22,    70,    71,     0,     0,    73,     0,
       0,    74,  -502,    76,     0,    78,     0,   232,    23,    24,
      25,    83,    84,    85,    86,    87,   233,    89,    26,     0,
     234,     0,     0,   235,     0,     0,     0,     0,     0,    96,
       0,     0,    98,     0,   100,   236,   102,     0,   103,     0,
       0,     0,   237,   107,    28,     0,     0,     0,   109,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
       0,   239,     0,     0,     0,     0,   240,     0,   241,   509,
       0,     0,    29,   224,    21,   225,   226,   227,    60,     0,
       0,     0,     0,   228,     0,     0,     0,     0,    61,   229,
     230,    64,     0,     0,     0,     0,     0,    67,    68,  -502,
      22,    70,    71,     0,     0,    73,     0,     0,    74,  -502,
      76,     0,    78,     0,   232,    23,    24,    25,    83,    84,
      85,    86,    87,   233,    89,    26,     0,   234,     0,     0,
     235,     0,     0,     0,     0,     0,    96,     0,     0,    98,
       0,   100,   236,   102,     0,   103,     0,     0,     0,   237,
     107,    28,     0,     0,     0,   109,     0,     0,     0,     0,
       0,     0,     0,     0,   238,     0,     0,     0,   239,     0,
       0,     0,     0,   240,     0,   241,   717,     0,     0,    29,
     224,    21,   225,   226,   227,    60,     0,     0,     0,     0,
     228,     0,     0,     0,     0,    61,   229,   230,    64,     0,
       0,     0,     0,     0,    67,    68,  -502,    22,    70,    71,
       0,     0,    73,     0,     0,    74,  -502,    76,     0,    78,
       0,   232,    23,    24,    25,    83,    84,    85,    86,    87,
     233,    89,    26,     0,   234,     0,     0,   235,     0,     0,
       0,     0,     0,    96,     0,     0,    98,     0,   100,   236,
     102,     0,   103,     0,     0,     0,   237,   107,    28,     0,
       0,     4,   109,     0,  -159,     0,     0,     0,     0,     0,
       0,   238,     0,     0,     0,   239,     0,     0,     0,     0,
     240,     0,   241,     0,   292,     0,    29,  -159,  -159,     0,
       0,  -159,  -159,     0,     0,  -159,     0,     0,     0,     0,
       0,  -159,  -159,  -159,     0,  -159,     0,  -159,  -159,  -159,
       0,     6,  -159,     7,  -159,  -159,  -159,     0,  -159,     0,
    -159,     0,     0,     0,  -159,  -159,     0,     0,  -159,  -159,
       0,  -159,  -159,  -159,  -159,  -159,     0,  -159,  -159,     0,
    -159,     0,  -159,  -159,  -159,     0,     0,  -159,     0,     4,
       0,     0,  -159,     0,     0,     0,     0,     0,     0,     0,
       0,     8,     0,   293,     0,     0,     0,     0,     0,  -159,
       0,  -159,   680,     0,     0,  -159,  -159,     0,     0,  -159,
    -159,     0,     0,  -159,     0,     0,     0,     0,     0,  -159,
    -159,  -159,     0,  -159,     0,  -159,  -159,  -159,     0,     6,
    -159,     7,  -159,  -159,  -159,     0,  -159,     0,  -159,     0,
       0,     0,  -159,  -159,     0,     0,  -159,  -159,     0,  -159,
    -159,  -159,  -159,  -159,     0,  -159,  -159,     0,  -159,     0,
    -159,  -159,  -159,   460,     0,  -159,     0,   224,    21,   225,
     226,   227,     0,     0,     0,     0,     0,   228,     0,     8,
       0,   681,     0,   300,   301,     0,     0,  -159,     0,  -159,
       0,     0,   462,  -502,    22,     0,   224,    21,   225,   226,
     227,     0,     0,  -502,     0,     0,   228,     0,   302,    23,
      24,    25,   300,   301,     0,     0,     0,   303,     0,    26,
       0,   304,  -502,    22,   235,     0,   136,   137,     0,     0,
       0,     0,  -502,     0,   138,     0,    27,   302,    23,    24,
      25,     0,   139,   305,   140,    28,   303,     0,    26,     0,
     304,     0,     0,   235,     0,     0,     0,   141,   238,   142,
       0,     0,   239,   143,   144,    27,     0,   240,   145,   241,
       0,   146,   305,    29,    28,     0,     0,   147,     0,   344,
     345,   346,   347,   148,   348,   349,     0,   238,     0,     0,
       0,   239,     0,     0,     0,     0,   240,     0,   241,   464,
       0,     0,    29,   224,    21,   225,   226,   227,     0,     0,
       0,     0,     0,   228,     0,     0,     0,     0,     0,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   466,  -502,
      22,     0,   224,    21,   225,   226,   227,     0,     0,  -502,
       0,     0,   228,     0,   302,    23,    24,    25,   300,   301,
       0,     0,     0,   303,     0,    26,     0,   304,  -502,    22,
     235,   356,   357,   358,   359,   360,   361,   362,  -502,     0,
       0,     0,    27,   302,    23,    24,    25,     0,     0,   305,
       0,    28,   303,     0,    26,     0,   304,     0,     0,   235,
       0,     0,     0,     0,   238,     0,     0,     0,   239,     0,
       0,    27,     0,   240,     0,   241,     0,     0,   305,    29,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,   239,     0,     0,
       0,     0,   240,     0,   241,   468,     0,     0,    29,   224,
      21,   225,   226,   227,     0,     0,     0,     0,     0,   228,
       0,     0,     0,     0,     0,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   470,  -502,    22,     0,   224,    21,
     225,   226,   227,     0,     0,  -502,     0,     0,   228,     0,
     302,    23,    24,    25,   300,   301,     0,     0,     0,   303,
       0,    26,     0,   304,  -502,    22,   235,     0,     0,     0,
       0,     0,     0,     0,  -502,     0,     0,     0,    27,   302,
      23,    24,    25,     0,     0,   305,     0,    28,   303,     0,
      26,     0,   304,     0,     0,   235,     0,     0,     0,     0,
     238,     0,     0,     0,   239,     0,     0,    27,     0,   240,
       0,   241,     0,     0,   305,    29,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,     0,   239,     0,     0,     0,     0,   240,     0,
     241,   472,     0,     0,    29,   224,    21,   225,   226,   227,
       0,     0,     0,     0,     0,   228,     0,     0,     0,     0,
       0,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     474,  -502,    22,     0,   224,    21,   225,   226,   227,     0,
       0,  -502,     0,     0,   228,     0,   302,    23,    24,    25,
     300,   301,     0,     0,     0,   303,     0,    26,     0,   304,
    -502,    22,   235,     0,     0,     0,     0,     0,     0,     0,
    -502,     0,     0,     0,    27,   302,    23,    24,    25,     0,
       0,   305,     0,    28,   303,     0,    26,     0,   304,     0,
       0,   235,     0,     0,     0,     0,   238,     0,     0,     0,
     239,     0,     0,    27,     0,   240,     0,   241,     0,     0,
     305,    29,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,     0,     0,     0,   239,
       0,     0,     0,     0,   240,     0,   241,   477,     0,     0,
      29,   224,    21,   225,   226,   227,     0,     0,     0,     0,
       0,   228,     0,     0,     0,     0,     0,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   479,  -502,    22,     0,
     224,    21,   225,   226,   227,     0,     0,  -502,     0,     0,
     228,     0,   302,    23,    24,    25,   300,   301,     0,     0,
       0,   303,     0,    26,     0,   304,  -502,    22,   235,     0,
       0,     0,     0,     0,     0,     0,  -502,     0,     0,     0,
      27,   302,    23,    24,    25,     0,     0,   305,     0,    28,
     303,     0,    26,     0,   304,     0,     0,   235,     0,     0,
       0,     0,   238,     0,     0,     0,   239,     0,     0,    27,
       0,   240,     0,   241,     0,     0,   305,    29,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   238,     0,     0,     0,   239,     0,     0,     0,     0,
     240,     0,   241,   481,     0,     0,    29,   224,    21,   225,
     226,   227,     0,     0,     0,     0,     0,   228,     0,     0,
       0,     0,     0,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   483,  -502,    22,     0,   224,    21,   225,   226,
     227,     0,     0,  -502,     0,     0,   228,     0,   302,    23,
      24,    25,   300,   301,     0,     0,     0,   303,     0,    26,
       0,   304,  -502,    22,   235,     0,     0,     0,     0,     0,
       0,     0,  -502,     0,     0,     0,    27,   302,    23,    24,
      25,     0,     0,   305,     0,    28,   303,     0,    26,     0,
     304,     0,     0,   235,     0,     0,     0,     0,   238,     0,
       0,     0,   239,     0,     0,    27,     0,   240,     0,   241,
       0,     0,   305,    29,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
       0,   239,     0,     0,     0,     0,   240,     0,   241,   485,
       0,     0,    29,   224,    21,   225,   226,   227,     0,     0,
       0,     0,     0,   228,     0,     0,     0,     0,     0,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   487,  -502,
      22,     0,   224,    21,   225,   226,   227,     0,     0,  -502,
       0,     0,   228,     0,   302,    23,    24,    25,   300,   301,
       0,     0,     0,   303,     0,    26,     0,   304,  -502,    22,
     235,     0,     0,     0,     0,     0,     0,     0,  -502,     0,
       0,     0,    27,   302,    23,    24,    25,     0,     0,   305,
       0,    28,   303,     0,    26,     0,   304,     0,     0,   235,
       0,     0,     0,     0,   238,     0,     0,     0,   239,     0,
       0,    27,     0,   240,     0,   241,     0,     0,   305,    29,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,   239,     0,     0,
       0,     0,   240,     0,   241,   489,     0,     0,    29,   224,
      21,   225,   226,   227,     0,     0,     0,     0,     0,   228,
       0,     0,     0,     0,     0,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   491,  -502,    22,     0,   224,    21,
     225,   226,   227,     0,     0,  -502,     0,     0,   228,     0,
     302,    23,    24,    25,   300,   301,     0,     0,     0,   303,
       0,    26,     0,   304,  -502,    22,   235,     0,     0,     0,
       0,     0,     0,     0,  -502,     0,     0,     0,    27,   302,
      23,    24,    25,     0,     0,   305,     0,    28,   303,     0,
      26,     0,   304,     0,     0,   235,     0,     0,     0,     0,
     238,     0,     0,     0,   239,     0,     0,    27,     0,   240,
       0,   241,     0,     0,   305,    29,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,     0,   239,     0,     0,     0,     0,   240,     0,
     241,   493,     0,     0,    29,   224,    21,   225,   226,   227,
       0,     0,     0,     0,     0,   228,     0,     0,     0,     0,
       0,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     495,  -502,    22,     0,   224,    21,   225,   226,   227,     0,
       0,  -502,     0,     0,   228,     0,   302,    23,    24,    25,
     300,   301,     0,     0,     0,   303,     0,    26,     0,   304,
    -502,    22,   235,     0,     0,     0,     0,     0,     0,     0,
    -502,     0,     0,     0,    27,   302,    23,    24,    25,     0,
       0,   305,     0,    28,   303,     0,    26,     0,   304,     0,
       0,   235,     0,     0,     0,     0,   238,   281,     0,     0,
     239,     0,     0,    27,     0,   240,     0,   241,  -638,  -638,
     305,    29,    28,     0,     0,     0,     0,     0,     0,  -638,
       0,     0,     0,   136,   137,   238,     0,     0,    22,   239,
       0,   138,     0,     0,   240,     0,   241,     0,     0,   139,
      29,   140,     0,    23,    24,    25,  -638,     0,     0,  -638,
    -638,   281,     0,  -638,   141,     0,   142,     0,     0,  -638,
     143,   144,  -638,     0,     0,   145,     0,     0,   146,  -638,
      27,  -638,     0,     0,   147,     0,     0,   136,   137,    28,
     148,     0,    22,     0,     0,   138,     0,     0,     0,     0,
       0,     0,     0,   139,     0,   140,     0,    23,    24,    25,
       0,    20,   296,     0,     0,     0,    21,    29,   141,     0,
     142,     0,     0,     0,   143,   144,     0,     0,     0,   145,
       0,     0,   146,     0,    27,  -641,  -641,     0,   147,     0,
       0,     0,    22,    28,   148,     0,  -641,     0,     0,     0,
     344,   345,   346,   347,     0,   348,   349,    23,    24,    25,
       0,     0,     0,   344,   345,   346,   347,    26,   348,   349,
     350,    29,     0,  -641,     0,     0,  -641,  -641,     0,     0,
    -641,     0,     0,     0,    27,     0,  -641,     0,     0,  -641,
       0,     0,     0,    28,  -539,     0,  -641,     0,  -641,  -539,
    -539,     0,  -539,  -539,  -539,  -539,     0,  -539,  -539,  -539,
    -539,     0,     0,     0,     0,  -539,  -539,  -539,     0,     0,
       0,    29,     0,     0,     0,     0,     0,  -539,     0,  -539,
    -539,   355,   356,   357,   358,   359,   360,   361,   362,   314,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,     0,     0,  -539,     0,     0,  -539,  -539,     0,
       0,  -539,  -645,  -645,  -645,     0,     0,  -539,     0,     0,
    -539,     0,     0,     0,  -645,     0,     0,  -539,     0,  -539,
    -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,
    -539,     0,  -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,
       0,  -645,   119,     0,  -645,  -645,     0,     0,  -645,     0,
       0,     0,     0,     0,  -645,     0,     0,  -645,     0,     0,
       0,     0,     0,     0,  -645,     0,  -645,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -645,
       0,  -645,  -645,   315,  -645,     0,  -645,   316,   224,    21,
     225,   226,   227,    60,     0,     0,     0,     0,   228,     0,
       0,     0,     0,    61,   229,   230,    64,   503,     0,     0,
     136,   137,    67,    68,     0,    22,    70,    71,   138,     0,
      73,     0,     0,    74,     0,    76,   139,    78,   140,   232,
      23,    24,    25,    83,    84,    85,    86,    87,   233,    89,
      26,   141,   234,   142,     0,   235,     0,   143,   144,     0,
       0,    96,   145,     0,    98,   146,   100,   236,   102,     0,
     103,   147,     0,     0,   237,   107,    28,   148,     0,     0,
     109,     0,     0,     0,     0,     0,     0,   504,     0,   238,
       0,     0,     0,   239,     0,     0,     0,     0,   240,     0,
     241,  -563,     0,     0,    29,   224,    21,   225,   226,   227,
      60,     0,     0,     0,     0,   228,     0,     0,     0,     0,
      61,   229,   230,    64,     0,     0,     0,   136,   137,    67,
      68,  -502,    22,    70,    71,   138,     0,    73,     0,     0,
      74,  -502,    76,   139,    78,   140,   232,    23,    24,    25,
      83,    84,    85,    86,    87,   233,    89,    26,   141,   234,
     142,     0,   235,     0,   143,   144,     0,     0,    96,   145,
       0,    98,   146,   100,   236,   102,     0,   103,   147,     0,
       0,   237,   107,    28,   148,     0,     0,   109,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,     0,
     239,     0,     0,     0,     0,   240,     0,   241,     0,     0,
       0,    29,   224,    21,   225,   226,   227,    60,     0,     0,
       0,     0,   228,     0,     0,     0,     0,    61,   229,   230,
      64,   664,     0,     0,   136,   137,    67,    68,     0,    22,
      70,    71,   138,     0,    73,     0,     0,    74,     0,    76,
     139,    78,   140,   232,    23,    24,    25,    83,    84,    85,
      86,    87,   233,    89,    26,   141,   234,   142,     0,   235,
       0,   143,   144,     0,     0,    96,   145,     0,    98,   146,
     100,   236,   102,     0,   103,   147,     0,     0,   237,   107,
      28,   148,     0,     0,   109,     0,     0,     0,     0,     0,
       0,     0,     0,   238,   224,    21,   225,   239,     0,    60,
       0,     0,   240,     0,   241,     0,     0,     0,    29,    61,
     229,   230,    64,     0,     0,     0,   136,   137,    67,    68,
       0,    22,    70,    71,   138,     0,    73,     0,     0,    74,
       0,    76,   139,    78,   140,   232,    23,    24,    25,    83,
      84,    85,    86,    87,   233,    89,    26,   141,   234,   142,
       0,   235,     0,   143,   144,     0,     0,    96,   145,     0,
      98,   146,   100,   236,   102,     0,   103,   147,     0,     0,
     237,   107,    28,   148,     0,     0,   109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,    21,   225,
     226,   227,    60,     0,   240,     0,   241,   228,     0,     0,
      29,     0,    61,   229,   230,    64,     0,     0,     0,     0,
       0,    67,    68,  -502,    22,    70,    71,     0,     0,    73,
       0,     0,    74,  -502,    76,     0,    78,     0,   232,    23,
      24,    25,    83,    84,    85,    86,    87,   233,    89,    26,
       0,   234,     0,     0,   235,     0,     0,     0,     0,     0,
      96,     0,     0,    98,     0,   100,   236,   102,     0,   103,
       0,     0,     0,   237,   107,    28,     0,     0,     0,   109,
       0,     0,     0,     0,     0,     0,     0,     0,   238,     0,
       0,     0,   239,     0,     0,     0,     0,   240,     0,   241,
       0,     0,   429,    29,   224,    21,   225,   226,   227,    60,
       0,     0,     0,     0,   228,     0,     0,     0,     0,    61,
     229,   230,    64,     0,     0,     0,     0,     0,    67,    68,
       0,    22,    70,    71,     0,     0,    73,     0,     0,    74,
       0,    76,     0,    78,     0,   232,    23,    24,    25,    83,
      84,    85,    86,    87,   233,    89,    26,     0,   234,     0,
       0,   235,     0,     0,     0,     0,     0,    96,     0,     0,
      98,     0,   100,   236,   102,     0,   103,     0,     0,     0,
     237,   107,    28,     0,     0,     0,   109,     0,     0,     0,
       0,   224,    21,   225,     0,   238,     0,     0,     0,   239,
       0,     0,     0,     0,   240,     0,   241,   300,   301,     0,
      29,   224,    21,   225,   226,   227,     0,     0,    22,     0,
       0,   228,     0,     0,     0,     0,     0,   300,   301,     0,
       0,     0,   302,    23,    24,    25,     0,     0,    22,     0,
       0,   303,     0,    26,     0,   304,     0,     0,   235,     0,
       0,     0,   302,    23,    24,    25,     0,     0,     0,     0,
      27,   303,     0,    26,     0,   304,     0,   305,   235,    28,
     365,     0,     0,     0,     0,   366,   367,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,   305,     0,    28,
       0,   240,   368,   369,     0,     0,     0,    29,     0,     0,
       0,     0,   238,   370,     0,     0,   239,     0,     0,     0,
       0,   240,     0,   241,     0,     0,   365,    29,     0,     0,
       0,   366,   367,     0,     0,     0,     0,     0,    45,     0,
     371,     0,     0,   372,   373,     0,     0,   374,   368,   369,
      46,    47,    48,   375,     0,     0,   376,     0,     0,   370,
       0,     0,     0,   377,    49,   378,     0,    50,     0,    51,
       0,    52,     0,    53,     0,     0,     0,     0,    54,     0,
       0,  -596,   240,    55,   241,  -596,   371,     0,     0,   372,
     373,     0,     0,   374,     0,     0,     0,     0,     0,   375,
       0,     0,   376,     0,     0,     0,     0,     0,     0,   377,
       0,   378,   515,     0,     0,     0,     0,     0,     0,     0,
       0,    60,     0,     0,     0,     0,     0,     0,   240,     0,
     241,    61,    62,    63,    64,  -340,     0,     0,    65,    66,
      67,    68,    69,     0,    70,    71,    72,     0,    73,     0,
       0,    74,    75,    76,    77,    78,    79,    80,     0,   212,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,     0,     0,     0,    94,    95,     0,     0,    96,
      97,     0,    98,    99,   100,   101,   102,     0,   103,   104,
       0,   105,   106,   107,     0,   108,     0,     0,   109,   344,
     345,   346,   347,     0,   348,   349,   350,   351,     0,     0,
       0,     0,     0,     0,  -340,  -340,   344,   345,   346,   347,
       0,   348,   349,     0,     0,   344,   345,   346,   347,     0,
     348,   349,   461,   463,   465,   467,   469,   471,   473,   475,
       0,   478,   480,   482,   484,   486,   488,   490,   492,   494,
     496,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,     0,     0,
       0,     0,     0,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   354,   355,   356,   357,   358,
     359,   360,   361,   362,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,    63,    64,     0,     0,
       0,    65,    66,    67,    68,    69,     0,    70,    71,    72,
       0,    73,   521,   522,    74,    75,    76,    77,    78,    79,
      80,     0,     0,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,     0,     0,     0,    94,    95,
       0,     0,    96,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,     0,   105,   106,   107,    60,   108,     0,
       0,   109,     0,     0,     0,     0,     0,    61,    62,    63,
      64,   409,     0,     0,    65,    66,    67,    68,    69,     0,
      70,    71,    72,     0,    73,     0,     0,    74,    75,    76,
      77,    78,    79,    80,     0,   212,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,     0,     0,
       0,    94,    95,     0,     0,    96,    97,     0,    98,    99,
     100,   101,   102,     0,   103,   104,     0,   105,   106,   107,
      60,   108,     0,     0,   109,     0,     0,     0,     0,     0,
      61,    62,    63,    64,   213,     0,     0,    65,    66,    67,
      68,    69,     0,    70,    71,    72,     0,    73,     0,     0,
      74,    75,    76,    77,    78,    79,    80,     0,   408,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,     0,     0,     0,    94,    95,     0,     0,    96,    97,
       0,    98,    99,   100,   101,   102,     0,   103,   104,     0,
     105,   106,   107,    60,   108,     0,     0,   109,     0,     0,
       0,     0,     0,    61,    62,    63,    64,   409,     0,     0,
      65,    66,    67,    68,    69,     0,    70,    71,    72,     0,
      73,     0,     0,    74,    75,    76,    77,    78,    79,    80,
       0,   697,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,     0,     0,     0,    94,    95,     0,
       0,    96,    97,     0,    98,    99,   100,   101,   102,     0,
     103,   104,     0,   105,   106,   107,    60,   108,     0,     0,
     109,     0,     0,     0,     0,     0,    61,    62,    63,    64,
     409,     0,     0,    65,    66,    67,    68,    69,     0,    70,
      71,    72,     0,    73,     0,     0,    74,    75,    76,    77,
      78,    79,    80,     0,   704,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,     0,     0,     0,
      94,    95,     0,     0,    96,    97,     0,    98,    99,   100,
     101,   102,     0,   103,   104,     0,   105,   106,   107,    60,
     108,     0,     0,   109,     0,     0,     0,     0,     0,    61,
      62,    63,    64,   409,     0,     0,    65,    66,    67,    68,
      69,     0,    70,    71,    72,     0,    73,     0,     0,    74,
      75,    76,    77,    78,    79,    80,     0,   847,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       0,     0,     0,    94,    95,     0,     0,    96,    97,     0,
      98,    99,   100,   101,   102,     0,   103,   104,     0,   105,
     106,   107,   595,   108,     0,   596,   109,     0,     0,     0,
       0,   597,     0,     0,     0,     0,   409,     0,     0,     0,
       0,   598,   599,   600,   601,     0,     0,     0,   602,   603,
     604,   605,   606,     0,   607,   608,   609,     0,   610,     0,
       0,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,     0,     0,     0,   632,   633,     0,     0,   634,
     635,   120,   636,   637,   638,   639,   640,     0,   641,   642,
      60,   643,   644,   645,     0,   646,   647,     0,   648,     0,
      61,    62,    63,    64,     0,     0,     0,    65,    66,    67,
      68,    69,     0,    70,    71,    72,     0,    73,     0,     0,
      74,    75,    76,    77,    78,    79,    80,     0,   121,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,     0,     0,     0,    94,    95,     0,     0,    96,    97,
     126,    98,    99,   100,   101,   102,     0,   103,   104,    60,
     105,   106,   107,     0,   108,     0,     0,   109,     0,    61,
      62,    63,    64,     0,     0,     0,    65,    66,    67,    68,
      69,     0,    70,    71,    72,     0,    73,     0,     0,    74,
      75,    76,    77,    78,    79,    80,     0,   127,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       0,     0,     0,    94,    95,     0,     0,    96,    97,   167,
      98,    99,   100,   101,   102,     0,   103,   104,    60,   105,
     106,   107,     0,   108,     0,     0,   109,     0,    61,    62,
      63,    64,     0,     0,     0,    65,    66,    67,    68,    69,
       0,    70,    71,    72,     0,    73,     0,     0,    74,    75,
      76,    77,    78,    79,    80,     0,   168,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,     0,
       0,     0,    94,    95,     0,     0,    96,    97,   265,    98,
      99,   100,   101,   102,     0,   103,   104,    60,   105,   106,
     107,     0,   108,     0,     0,   109,     0,    61,    62,    63,
      64,     0,     0,     0,    65,    66,    67,    68,    69,     0,
      70,    71,    72,     0,    73,     0,     0,    74,    75,    76,
      77,    78,    79,    80,     0,   127,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,     0,     0,
       0,    94,    95,     0,     0,    96,    97,   273,    98,    99,
     100,   101,   102,     0,   103,   104,    60,   105,   106,   107,
       0,   108,     0,     0,   109,     0,    61,    62,    63,    64,
       0,     0,     0,    65,    66,    67,    68,    69,     0,    70,
      71,    72,     0,    73,     0,     0,    74,    75,    76,    77,
      78,    79,    80,     0,   274,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,     0,     0,     0,
      94,    95,     0,     0,    96,    97,   856,    98,    99,   100,
     101,   102,     0,   103,   104,    60,   105,   106,   107,     0,
     108,     0,     0,   109,     0,    61,    62,    63,    64,     0,
       0,     0,    65,    66,    67,    68,    69,     0,    70,    71,
      72,     0,    73,     0,     0,    74,    75,    76,    77,    78,
      79,    80,     0,   857,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,     0,     0,     0,    94,
      95,     0,     0,    96,    97,   911,    98,    99,   100,   101,
     102,     0,   103,   104,    60,   105,   106,   107,     0,   108,
       0,     0,   109,     0,    61,    62,    63,    64,     0,     0,
       0,    65,    66,    67,    68,    69,     0,    70,    71,    72,
       0,    73,     0,     0,    74,    75,    76,    77,    78,    79,
      80,     0,   857,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,     0,     0,     0,    94,    95,
       0,     0,    96,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,     0,   105,   106,   107,     0,   108,   136,
     137,   109,     0,     0,    22,     0,     0,   138,     0,     0,
       0,     0,     0,     0,     0,   139,     0,   140,     0,    23,
      24,    25,     0,     0,     0,     0,     0,     0,     0,     0,
     141,     0,   142,     0,     0,     0,   143,   144,     0,     0,
       0,   145,     0,     0,   146,     0,    27,     0,     0,     0,
     147,     0,     0,   136,   137,    28,   148,     0,    22,     0,
       0,   138,     0,     0,     0,     0,     0,     0,     0,   139,
       0,   140,     0,    23,    24,    25,   393,     0,     0,     0,
       0,     0,     0,    29,   141,     0,   142,     0,     0,     0,
     143,   144,     0,     0,     0,   145,     0,     0,   146,     0,
      27,     0,     0,     0,   147,     0,     0,   136,   156,    28,
     148,     0,    22,     0,     0,   157,     0,     0,     0,     0,
       0,     0,     0,   139,     0,   140,     0,    23,    24,    25,
       0,     0,     0,     0,     0,     0,     0,    29,   141,     0,
     142,     0,     0,     0,   143,   144,     0,     0,     0,   145,
       0,     0,   146,     0,    27,     0,     0,     0,   147,     0,
       0,     0,    60,    28,   148,     0,     0,     0,     0,     0,
       0,     0,    61,    62,    63,    64,     0,     0,     0,    65,
      66,    67,    68,    69,     0,    70,    71,    72,     0,    73,
       0,    29,    74,    75,    76,    77,    78,    79,    80,     0,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     0,     0,     0,    94,    95,     0,     0,
      96,    97,     0,    98,    99,   100,   101,   102,     0,   103,
     104,    60,   105,   106,   107,     0,   108,     0,     0,   109,
       0,    61,    62,    63,    64,     0,     0,     0,    65,    66,
      67,    68,    69,     0,    70,    71,    72,     0,    73,     0,
       0,    74,    75,    76,    77,    78,    79,    80,     0,   163,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,     0,     0,     0,    94,    95,     0,     0,    96,
      97,     0,    98,    99,   100,   101,   102,     0,   103,   104,
      60,   105,   106,   107,     0,   108,     0,     0,   109,     0,
      61,    62,    63,    64,     0,     0,     0,    65,    66,    67,
      68,    69,     0,    70,    71,    72,     0,    73,     0,     0,
      74,    75,    76,    77,    78,    79,    80,     0,   165,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,     0,     0,     0,    94,    95,     0,     0,    96,    97,
       0,    98,    99,   100,   101,   102,     0,   103,   104,    60,
     105,   106,   107,     0,   108,     0,     0,   109,     0,    61,
      62,    63,    64,     0,     0,     0,    65,    66,    67,    68,
      69,     0,    70,    71,    72,     0,    73,     0,     0,    74,
      75,    76,    77,    78,    79,    80,     0,   181,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       0,     0,     0,    94,    95,     0,     0,    96,    97,     0,
      98,    99,   100,   101,   102,     0,   103,   104,    60,   105,
     106,   107,     0,   108,     0,     0,   109,     0,    61,    62,
      63,    64,     0,     0,     0,    65,    66,    67,    68,    69,
       0,    70,    71,    72,     0,    73,     0,     0,    74,    75,
      76,    77,    78,    79,    80,     0,   425,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,     0,
       0,     0,    94,    95,     0,     0,    96,    97,     0,    98,
      99,   100,   101,   102,     0,   103,   104,    60,   105,   106,
     107,     0,   108,     0,     0,   109,     0,    61,    62,    63,
      64,     0,     0,     0,    65,    66,    67,    68,    69,     0,
      70,    71,    72,     0,    73,     0,     0,    74,    75,    76,
      77,    78,    79,    80,     0,   552,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,     0,     0,
       0,    94,    95,     0,     0,    96,    97,     0,    98,    99,
     100,   101,   102,     0,   103,   104,    60,   105,   106,   107,
       0,   108,     0,     0,   109,     0,    61,    62,    63,    64,
       0,     0,     0,    65,    66,    67,    68,    69,     0,    70,
      71,    72,     0,    73,     0,     0,    74,    75,    76,    77,
      78,    79,    80,     0,   212,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,     0,     0,     0,
      94,    95,     0,     0,    96,    97,     0,    98,    99,   100,
     101,   102,     0,   103,   104,     0,   105,   106,   107,     0,
     108,     0,     0,   109
};

static const yytype_int16 yycheck[] =
{
       6,     2,   242,   243,    37,    22,   132,     6,    40,   155,
      42,    40,   513,    42,    31,   457,   263,   736,    34,    36,
     226,   227,   228,   216,   226,   227,   508,   221,   352,   552,
      24,   232,   238,   239,    40,    24,    42,   243,   244,   245,
      22,   243,   761,   242,   243,   283,   590,    32,   198,    31,
      61,   326,     1,   255,    36,   747,   174,   295,     1,   177,
       1,    88,   180,    38,    39,   772,     0,   831,   218,   309,
      48,     1,     1,   765,     1,    24,   195,   333,   105,     1,
     199,   713,   846,    24,   791,    97,   754,   327,     1,    48,
     102,   759,    32,   333,    24,   106,    85,    24,   115,   116,
     219,   302,   119,     1,   379,   307,   308,   101,    32,   311,
     309,     1,   313,   177,   131,   132,   180,   102,     1,   125,
     752,   327,    97,    32,     1,     1,    24,   333,   327,   135,
       1,   333,   149,   115,   116,   337,   135,   119,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   106,   396,   703,
     109,   104,   179,   104,   283,   106,   195,   149,   109,   288,
     199,    40,   189,    42,   101,   818,   105,   820,   194,   109,
     109,   704,   109,   105,     3,   441,   829,   216,   907,   195,
     219,    24,   105,   199,   312,   433,   109,   179,     1,   198,
     447,   441,   235,   321,   322,     1,   444,   189,   326,   327,
     216,   109,   459,   219,   243,   105,   217,   457,   412,   218,
       1,   104,   865,   106,   418,     7,   243,     3,   105,   105,
     731,   732,     8,     9,   105,   441,     1,   243,     1,   441,
     763,     1,   441,    32,   446,   796,   262,     4,   101,   800,
     104,   457,   106,    88,   283,   457,     1,   450,   111,   288,
     378,   379,   380,   381,   382,   383,   101,   743,     6,   104,
     594,   390,   105,   102,    31,   513,    97,   283,   277,   315,
     297,   757,   288,   289,    41,   106,   105,   406,   107,    24,
     289,    97,    95,    24,   937,    52,   242,     6,   327,    95,
     106,   104,   319,   106,   333,   948,    48,     1,   104,   315,
     327,   429,     6,    48,    96,   297,   333,   960,   800,    57,
     871,   327,   111,    80,   105,    88,   195,   333,    88,   105,
     199,   107,   365,   451,    32,    97,    24,   319,    32,    32,
     105,    31,   105,    90,   380,   105,   108,   216,    57,   900,
     219,    41,   109,    47,    48,    49,   101,   102,     1,    24,
     306,   390,   101,    57,     7,   104,   101,    97,   385,    97,
     386,    88,   103,   104,   380,   926,   106,   406,   106,   930,
      74,   932,   933,    24,   390,    38,    39,    88,   594,    83,
     872,   424,   101,    38,    39,    38,    39,    24,   949,     1,
     406,   101,   419,   385,     6,    24,    24,   111,    97,    98,
      99,   111,   441,   101,   283,   103,   534,   111,   106,   288,
     108,   450,    97,   101,   441,   543,   104,     4,   457,   101,
      32,   106,   104,   671,    24,   441,   101,   419,   103,   105,
     457,   106,    61,   105,   450,    47,    48,    49,    24,   102,
     568,   457,   109,    96,   101,    57,    24,   104,    38,    39,
     101,   105,   103,   105,   582,   106,   105,   585,   504,   716,
      88,   105,    74,     6,   592,   593,   103,     1,   228,   106,
     228,    83,   101,   101,   103,   103,    24,   106,   238,   239,
     238,   239,   242,   243,   244,   245,   244,   245,   504,    32,
     105,    25,    26,   945,   946,   255,   774,   775,   746,   111,
     101,   101,    36,   103,    47,    48,    49,    95,   102,   536,
     104,   390,   964,   105,    57,   101,   102,   103,   731,   732,
     676,   548,   102,   101,   104,   103,   730,   406,   106,    63,
     101,    74,    66,    67,    16,    17,    70,   105,    32,   105,
      83,    88,    76,   106,   536,    79,   306,   307,   308,    24,
     678,   311,    86,   101,    88,   103,   548,   686,   106,     7,
     689,    24,   773,    90,   692,    24,   106,   327,   111,    24,
     104,   450,    48,   333,   108,   104,   872,   337,   108,   707,
     875,   792,   710,    24,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   899,   678,    24,   105,    12,    13,   904,
     739,    16,    17,    95,    96,    97,    98,    99,   106,    97,
     831,   917,   668,   751,   104,   753,   101,   669,   103,    88,
     669,   106,   106,   707,   106,   846,   710,   106,   101,   104,
     103,   777,   101,   106,   103,    24,   101,   686,   103,   944,
     689,   106,   668,   669,   104,   950,   951,   696,   103,   106,
     101,   104,   103,   958,   108,   936,    97,   102,   939,   940,
     686,   108,   967,   689,   106,   886,   947,   972,     1,   108,
     696,   441,   101,   726,   103,   108,   446,    88,    93,    94,
      95,    96,    97,    98,    99,   945,   946,   457,    24,   970,
     739,     7,    25,    26,   743,    95,    96,    97,    98,    99,
     102,   738,   106,    36,   964,   761,   105,    24,   757,   104,
     104,    88,   101,   739,   103,   736,   106,   743,   106,   945,
     946,    38,    39,   945,   946,   774,   775,   108,   765,   109,
      63,   757,   106,    66,    67,   761,   738,    70,   964,    88,
     777,    88,   964,    76,    88,   105,    79,   108,   774,   775,
     803,   889,   789,    86,   892,    88,   106,   895,   795,    48,
     106,    32,   105,   765,   106,   101,   105,   103,   105,    88,
     796,   105,   102,    88,   800,    88,    47,    48,    49,    88,
     669,   807,   105,   105,   101,   102,   103,   789,   807,   927,
      40,   105,   289,   795,   105,   105,   101,   686,   886,   669,
     689,   179,   147,    74,   142,   889,   146,   696,   892,   412,
     709,   895,    83,   894,   867,   868,   884,   801,   254,   875,
     149,    25,    26,   876,   594,   878,   879,   738,   254,   946,
     964,   966,    36,   568,   658,   668,   585,   313,    -1,    -1,
     111,    -1,    -1,    -1,    -1,   871,    -1,    -1,   904,   875,
     739,   907,    -1,    -1,   743,    -1,    -1,   894,    -1,    63,
      -1,    -1,    66,    67,    -1,    -1,    70,    -1,   757,    -1,
      -1,    -1,    76,    -1,   900,    79,    -1,    -1,   904,    -1,
      -1,   907,    86,    -1,    88,   774,   775,    -1,   944,    -1,
      -1,    -1,   894,    -1,   950,   951,   945,   946,   102,    -1,
     926,    -1,   958,    -1,   930,   931,   932,   933,   945,   946,
      -1,   967,    -1,    -1,    -1,   964,   972,    -1,   944,   945,
     946,    -1,    -1,   949,   950,   951,    -1,   964,    -1,     0,
       1,    -1,   958,     4,    -1,    -1,    -1,    -1,   964,    -1,
     966,   967,    -1,    -1,    -1,    -1,   972,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    27,    28,    -1,    -1,
      31,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      41,    42,    43,    -1,    45,    -1,    47,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    -1,    60,
      -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    77,    78,    -1,    80,
      -1,    82,    83,    84,    -1,    -1,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
     101,     5,     6,     7,     8,     9,    10,    -1,   109,    -1,
     111,    15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      84,    -1,    86,    87,    88,    -1,    -1,    25,    26,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,    36,    -1,
      -1,   105,    -1,   107,    -1,    -1,    -1,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    66,    67,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    79,    -1,    -1,    -1,   945,   946,     1,    86,    -1,
      88,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    -1,    -1,   964,    -1,    20,    21,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      84,    -1,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,   105,    -1,   107,    -1,     1,    -1,   111,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    -1,    64,    65,
      -1,    -1,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    77,    78,    -1,    -1,    81,    82,    83,    84,    85,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,    -1,   103,    -1,   105,
      -1,   107,     1,   109,    -1,   111,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    -1,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    -1,    64,    65,    -1,    -1,    68,
      69,    -1,    71,    72,    73,    74,    75,    -1,    77,    78,
      -1,    -1,    81,    82,    83,    84,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    -1,    96,    97,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,    -1,
       1,    -1,   111,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    -1,    64,    65,    -1,    -1,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    77,    78,    -1,    -1,
      81,    82,    83,    84,    85,    -1,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
     101,    -1,    -1,    -1,   105,    -1,   107,     1,   109,    -1,
     111,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    -1,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    62,    -1,
      64,    65,    -1,    -1,    68,    69,    -1,    71,    72,    73,
      74,    75,    -1,    77,    78,    -1,    -1,    81,    82,    83,
      84,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
      -1,   105,    -1,   107,     1,    -1,    -1,   111,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      37,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    -1,    64,    65,    -1,
      -1,    68,    69,    -1,    71,    72,    73,    74,    75,    -1,
      77,    78,    -1,    -1,    81,    82,    83,    84,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
     107,     1,    -1,    -1,   111,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,    -1,    -1,    -1,   105,    -1,   107,     1,    -1,
      -1,   111,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,    72,
      73,    74,    75,    -1,    77,    78,    -1,    -1,    81,    82,
      83,    84,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,    -1,
      -1,    -1,   105,    -1,   107,     1,    -1,    -1,   111,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    -1,    64,    65,
      -1,    -1,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    77,    78,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,
      -1,   107,     1,   109,    -1,   111,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    -1,    64,    65,    -1,    -1,    68,
      69,    -1,    71,    72,    73,    74,    75,    -1,    77,    78,
      -1,    -1,    81,    82,    83,    84,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,     1,
      -1,    -1,   111,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,
      72,    73,    74,    75,    -1,    77,    78,    -1,    -1,    81,
      82,    83,    84,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    96,     5,     6,     7,   100,    -1,
      10,    -1,    -1,   105,    -1,   107,    -1,    -1,    -1,   111,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
      -1,    -1,    10,   103,    -1,   105,   106,   107,    -1,    -1,
      -1,   111,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      -1,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    -1,    64,    65,    -1,    -1,
      68,    69,    -1,    71,    72,    73,    74,    75,    -1,    77,
      78,    -1,    -1,    81,    82,    83,    84,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,    -1,   101,    10,    -1,    -1,   105,    -1,   107,
      -1,    -1,    -1,   111,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    -1,    64,    65,
      -1,    -1,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    77,    78,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    -1,   105,
      -1,   107,    15,    -1,    -1,   111,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    -1,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    59,    -1,    61,    62,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    -1,    77,    -1,    -1,    -1,    81,    82,
      83,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,   105,   106,   107,     1,    -1,   110,   111,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    34,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    59,    -1,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,
     106,   107,     1,    -1,   110,   111,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
      29,    30,    31,    32,    33,    34,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    -1,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      59,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    -1,    77,    -1,
      -1,    -1,    81,    82,    83,    -1,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
       1,    -1,   111,    -1,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    -1,    77,    -1,    -1,    -1,
      81,    82,    83,    -1,    -1,    -1,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,   105,    -1,   107,     1,    -1,    -1,
     111,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    -1,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    59,    -1,    -1,    62,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,   105,    -1,   107,     1,   109,    -1,   111,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    -1,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    71,    -1,    73,    74,    75,    -1,
      77,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,    -1,
     107,     1,    -1,    -1,   111,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    29,
      30,    31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    -1,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    59,
      -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    -1,    77,    -1,    -1,
      -1,    81,    82,    83,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,   105,    -1,   107,     1,    -1,
      -1,   111,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    -1,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    59,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    -1,    77,    -1,    -1,    -1,    81,    82,
      83,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,   105,    -1,   107,     1,    -1,    -1,   111,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    34,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    59,    -1,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,
      -1,   107,     1,    -1,    -1,   111,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
      29,    30,    31,    32,    33,    34,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    -1,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      59,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    -1,    77,    -1,
      -1,    -1,    81,    82,    83,    -1,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,     1,
      -1,    -1,   111,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    -1,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    59,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,   105,    -1,   107,     1,    -1,    -1,   111,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    34,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      -1,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    59,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    -1,    77,    -1,    -1,    -1,    81,    82,    83,    -1,
      -1,     1,    87,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
     105,    -1,   107,    -1,    24,    -1,   111,    27,    28,    -1,
      -1,    31,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    41,    42,    43,    -1,    45,    -1,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    -1,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    -1,
      80,    -1,    82,    83,    84,    -1,    -1,    87,    -1,     1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,
      -1,   111,    24,    -1,    -1,    27,    28,    -1,    -1,    31,
      32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    41,
      42,    43,    -1,    45,    -1,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    -1,    60,    -1,
      -1,    -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,
      72,    73,    74,    75,    -1,    77,    78,    -1,    80,    -1,
      82,    83,    84,     1,    -1,    87,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    15,    -1,   101,
      -1,   103,    -1,    21,    22,    -1,    -1,   109,    -1,   111,
      -1,    -1,     1,    31,    32,    -1,     5,     6,     7,     8,
       9,    -1,    -1,    41,    -1,    -1,    15,    -1,    46,    47,
      48,    49,    21,    22,    -1,    -1,    -1,    55,    -1,    57,
      -1,    59,    31,    32,    62,    -1,    27,    28,    -1,    -1,
      -1,    -1,    41,    -1,    35,    -1,    74,    46,    47,    48,
      49,    -1,    43,    81,    45,    83,    55,    -1,    57,    -1,
      59,    -1,    -1,    62,    -1,    -1,    -1,    58,    96,    60,
      -1,    -1,   100,    64,    65,    74,    -1,   105,    69,   107,
      -1,    72,    81,   111,    83,    -1,    -1,    78,    -1,    11,
      12,    13,    14,    84,    16,    17,    -1,    96,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,     1,
      -1,    -1,   111,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    31,
      32,    -1,     5,     6,     7,     8,     9,    -1,    -1,    41,
      -1,    -1,    15,    -1,    46,    47,    48,    49,    21,    22,
      -1,    -1,    -1,    55,    -1,    57,    -1,    59,    31,    32,
      62,    93,    94,    95,    96,    97,    98,    99,    41,    -1,
      -1,    -1,    74,    46,    47,    48,    49,    -1,    -1,    81,
      -1,    83,    55,    -1,    57,    -1,    59,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,
      -1,    74,    -1,   105,    -1,   107,    -1,    -1,    81,   111,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,   105,    -1,   107,     1,    -1,    -1,   111,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    31,    32,    -1,     5,     6,
       7,     8,     9,    -1,    -1,    41,    -1,    -1,    15,    -1,
      46,    47,    48,    49,    21,    22,    -1,    -1,    -1,    55,
      -1,    57,    -1,    59,    31,    32,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    74,    46,
      47,    48,    49,    -1,    -1,    81,    -1,    83,    55,    -1,
      57,    -1,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,    -1,    -1,    74,    -1,   105,
      -1,   107,    -1,    -1,    81,   111,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,    -1,
     107,     1,    -1,    -1,   111,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    31,    32,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    41,    -1,    -1,    15,    -1,    46,    47,    48,    49,
      21,    22,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,
      31,    32,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    74,    46,    47,    48,    49,    -1,
      -1,    81,    -1,    83,    55,    -1,    57,    -1,    59,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,    -1,    -1,    74,    -1,   105,    -1,   107,    -1,    -1,
      81,   111,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,   105,    -1,   107,     1,    -1,    -1,
     111,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    31,    32,    -1,
       5,     6,     7,     8,     9,    -1,    -1,    41,    -1,    -1,
      15,    -1,    46,    47,    48,    49,    21,    22,    -1,    -1,
      -1,    55,    -1,    57,    -1,    59,    31,    32,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      74,    46,    47,    48,    49,    -1,    -1,    81,    -1,    83,
      55,    -1,    57,    -1,    59,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,    74,
      -1,   105,    -1,   107,    -1,    -1,    81,   111,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
     105,    -1,   107,     1,    -1,    -1,   111,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    31,    32,    -1,     5,     6,     7,     8,
       9,    -1,    -1,    41,    -1,    -1,    15,    -1,    46,    47,
      48,    49,    21,    22,    -1,    -1,    -1,    55,    -1,    57,
      -1,    59,    31,    32,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    74,    46,    47,    48,
      49,    -1,    -1,    81,    -1,    83,    55,    -1,    57,    -1,
      59,    -1,    -1,    62,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,    -1,    -1,    74,    -1,   105,    -1,   107,
      -1,    -1,    81,   111,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,     1,
      -1,    -1,   111,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    31,
      32,    -1,     5,     6,     7,     8,     9,    -1,    -1,    41,
      -1,    -1,    15,    -1,    46,    47,    48,    49,    21,    22,
      -1,    -1,    -1,    55,    -1,    57,    -1,    59,    31,    32,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    74,    46,    47,    48,    49,    -1,    -1,    81,
      -1,    83,    55,    -1,    57,    -1,    59,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,
      -1,    74,    -1,   105,    -1,   107,    -1,    -1,    81,   111,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,   105,    -1,   107,     1,    -1,    -1,   111,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    31,    32,    -1,     5,     6,
       7,     8,     9,    -1,    -1,    41,    -1,    -1,    15,    -1,
      46,    47,    48,    49,    21,    22,    -1,    -1,    -1,    55,
      -1,    57,    -1,    59,    31,    32,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    74,    46,
      47,    48,    49,    -1,    -1,    81,    -1,    83,    55,    -1,
      57,    -1,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,    -1,    -1,    74,    -1,   105,
      -1,   107,    -1,    -1,    81,   111,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,    -1,
     107,     1,    -1,    -1,   111,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    31,    32,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    41,    -1,    -1,    15,    -1,    46,    47,    48,    49,
      21,    22,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,
      31,    32,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    74,    46,    47,    48,    49,    -1,
      -1,    81,    -1,    83,    55,    -1,    57,    -1,    59,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    96,     1,    -1,    -1,
     100,    -1,    -1,    74,    -1,   105,    -1,   107,    25,    26,
      81,   111,    83,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    27,    28,    96,    -1,    -1,    32,   100,
      -1,    35,    -1,    -1,   105,    -1,   107,    -1,    -1,    43,
     111,    45,    -1,    47,    48,    49,    63,    -1,    -1,    66,
      67,     1,    -1,    70,    58,    -1,    60,    -1,    -1,    76,
      64,    65,    79,    -1,    -1,    69,    -1,    -1,    72,    86,
      74,    88,    -1,    -1,    78,    -1,    -1,    27,    28,    83,
      84,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    45,    -1,    47,    48,    49,
      -1,     1,   106,    -1,    -1,    -1,     6,   111,    58,    -1,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    69,
      -1,    -1,    72,    -1,    74,    25,    26,    -1,    78,    -1,
      -1,    -1,    32,    83,    84,    -1,    36,    -1,    -1,    -1,
      11,    12,    13,    14,    -1,    16,    17,    47,    48,    49,
      -1,    -1,    -1,    11,    12,    13,    14,    57,    16,    17,
      18,   111,    -1,    63,    -1,    -1,    66,    67,    -1,    -1,
      70,    -1,    -1,    -1,    74,    -1,    76,    -1,    -1,    79,
      -1,    -1,    -1,    83,     3,    -1,    86,    -1,    88,     8,
       9,    -1,    11,    12,    13,    14,    -1,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,   111,    -1,    -1,    -1,    -1,    -1,    36,    -1,    38,
      39,    92,    93,    94,    95,    96,    97,    98,    99,     1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      -1,    70,    24,    25,    26,    -1,    -1,    76,    -1,    -1,
      79,    -1,    -1,    -1,    36,    -1,    -1,    86,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,    63,   111,    -1,    66,    67,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
      -1,   103,   104,   105,   106,    -1,   108,   109,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    -1,
      37,    -1,    -1,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    -1,    64,    65,    -1,
      -1,    68,    69,    -1,    71,    72,    73,    74,    75,    -1,
      77,    78,    -1,    -1,    81,    82,    83,    84,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    96,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,   105,    -1,
     107,   108,    -1,    -1,   111,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,   105,    -1,   107,    -1,    -1,
      -1,   111,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,    72,
      73,    74,    75,    -1,    77,    78,    -1,    -1,    81,    82,
      83,    84,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,     5,     6,     7,   100,    -1,    10,
      -1,    -1,   105,    -1,   107,    -1,    -1,    -1,   111,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    -1,    64,    65,    -1,    -1,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    77,    78,    -1,    -1,
      81,    82,    83,    84,    -1,    -1,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    -1,   105,    -1,   107,    15,    -1,    -1,
     111,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    34,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,    -1,    -1,    -1,    -1,   105,    -1,   107,
      -1,    -1,   110,   111,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
      -1,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,
      -1,    42,    -1,    44,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    -1,    77,    -1,    -1,    -1,
      81,    82,    83,    -1,    -1,    -1,    87,    -1,    -1,    -1,
      -1,     5,     6,     7,    -1,    96,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,   105,    -1,   107,    21,    22,    -1,
     111,     5,     6,     7,     8,     9,    -1,    -1,    32,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      -1,    -1,    46,    47,    48,    49,    -1,    -1,    32,    -1,
      -1,    55,    -1,    57,    -1,    59,    -1,    -1,    62,    -1,
      -1,    -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      74,    55,    -1,    57,    -1,    59,    -1,    81,    62,    83,
       3,    -1,    -1,    -1,    -1,     8,     9,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,
      -1,   105,    25,    26,    -1,    -1,    -1,   111,    -1,    -1,
      -1,    -1,    96,    36,    -1,    -1,   100,    -1,    -1,    -1,
      -1,   105,    -1,   107,    -1,    -1,     3,   111,    -1,    -1,
      -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      63,    -1,    -1,    66,    67,    -1,    -1,    70,    25,    26,
      54,    55,    56,    76,    -1,    -1,    79,    -1,    -1,    36,
      -1,    -1,    -1,    86,    68,    88,    -1,    71,    -1,    73,
      -1,    75,    -1,    77,    -1,    -1,    -1,    -1,    82,    -1,
      -1,   104,   105,    87,   107,   108,    63,    -1,    -1,    66,
      67,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,
      -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    88,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
     107,    20,    21,    22,    23,    24,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,
      69,    -1,    71,    72,    73,    74,    75,    -1,    77,    78,
      -1,    80,    81,    82,    -1,    84,    -1,    -1,    87,    11,
      12,    13,    14,    -1,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,   103,   104,    11,    12,    13,    14,
      -1,    16,    17,    -1,    -1,    11,    12,    13,    14,    -1,
      16,    17,   344,   345,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,    91,    92,    93,    94,    95,
      96,    97,    98,    99,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    33,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      -1,    -1,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    77,    78,    -1,    80,    81,    82,    10,    84,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    97,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,    72,
      73,    74,    75,    -1,    77,    78,    -1,    80,    81,    82,
      10,    84,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    97,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    -1,
      80,    81,    82,    10,    84,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    97,    -1,    -1,
      27,    28,    29,    30,    31,    -1,    33,    34,    35,    -1,
      37,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    65,    -1,
      -1,    68,    69,    -1,    71,    72,    73,    74,    75,    -1,
      77,    78,    -1,    80,    81,    82,    10,    84,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      97,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    -1,    -1,    68,    69,    -1,    71,    72,    73,
      74,    75,    -1,    77,    78,    -1,    80,    81,    82,    10,
      84,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    97,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    77,    78,    -1,    80,
      81,    82,     1,    84,    -1,     4,    87,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,
      69,     1,    71,    72,    73,    74,    75,    -1,    77,    78,
      10,    80,    81,    82,    -1,    84,    85,    -1,    87,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,
       1,    71,    72,    73,    74,    75,    -1,    77,    78,    10,
      80,    81,    82,    -1,    84,    -1,    -1,    87,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,     1,
      71,    72,    73,    74,    75,    -1,    77,    78,    10,    80,
      81,    82,    -1,    84,    -1,    -1,    87,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    -1,    -1,    68,    69,     1,    71,
      72,    73,    74,    75,    -1,    77,    78,    10,    80,    81,
      82,    -1,    84,    -1,    -1,    87,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    -1,    -1,    68,    69,     1,    71,    72,
      73,    74,    75,    -1,    77,    78,    10,    80,    81,    82,
      -1,    84,    -1,    -1,    87,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    -1,    -1,    68,    69,     1,    71,    72,    73,
      74,    75,    -1,    77,    78,    10,    80,    81,    82,    -1,
      84,    -1,    -1,    87,    -1,    20,    21,    22,    23,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    -1,    33,    34,
      35,    -1,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    -1,    -1,    68,    69,     1,    71,    72,    73,    74,
      75,    -1,    77,    78,    10,    80,    81,    82,    -1,    84,
      -1,    -1,    87,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      -1,    -1,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    77,    78,    -1,    80,    81,    82,    -1,    84,    27,
      28,    87,    -1,    -1,    32,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    60,    -1,    -1,    -1,    64,    65,    -1,    -1,
      -1,    69,    -1,    -1,    72,    -1,    74,    -1,    -1,    -1,
      78,    -1,    -1,    27,    28,    83,    84,    -1,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    45,    -1,    47,    48,    49,   104,    -1,    -1,    -1,
      -1,    -1,    -1,   111,    58,    -1,    60,    -1,    -1,    -1,
      64,    65,    -1,    -1,    -1,    69,    -1,    -1,    72,    -1,
      74,    -1,    -1,    -1,    78,    -1,    -1,    27,    28,    83,
      84,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    45,    -1,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    58,    -1,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    69,
      -1,    -1,    72,    -1,    74,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    10,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    33,    34,    35,    -1,    37,
      -1,   111,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    -1,    -1,
      68,    69,    -1,    71,    72,    73,    74,    75,    -1,    77,
      78,    10,    80,    81,    82,    -1,    84,    -1,    -1,    87,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,
      69,    -1,    71,    72,    73,    74,    75,    -1,    77,    78,
      10,    80,    81,    82,    -1,    84,    -1,    -1,    87,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    10,
      80,    81,    82,    -1,    84,    -1,    -1,    87,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    -1,    -1,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    77,    78,    10,    80,
      81,    82,    -1,    84,    -1,    -1,    87,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,
      72,    73,    74,    75,    -1,    77,    78,    10,    80,    81,
      82,    -1,    84,    -1,    -1,    87,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    -1,    -1,    68,    69,    -1,    71,    72,
      73,    74,    75,    -1,    77,    78,    10,    80,    81,    82,
      -1,    84,    -1,    -1,    87,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    -1,    -1,    68,    69,    -1,    71,    72,    73,
      74,    75,    -1,    77,    78,    -1,    80,    81,    82,    -1,
      84,    -1,    -1,    87
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   113,   114,     0,     1,    24,    51,    53,   101,   119,
     122,   123,   126,   137,   154,   155,   243,    24,   101,   103,
       1,     6,    32,    47,    48,    49,    57,    74,    83,   111,
     296,   297,   298,   309,   310,    48,     4,    31,    41,    52,
      80,   109,   157,   232,   240,    42,    54,    55,    56,    68,
      71,    73,    75,    77,    82,    87,   148,    24,   101,   103,
      10,    20,    21,    22,    23,    27,    28,    29,    30,    31,
      33,    34,    35,    37,    40,    41,    42,    43,    44,    45,
      46,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    64,    65,    68,    69,    71,    72,
      73,    74,    75,    77,    78,    80,    81,    82,    84,    87,
     311,   312,    32,   111,    32,    32,    32,    48,   101,   111,
       1,    48,   311,   101,   309,   102,     1,    48,   124,   125,
     311,   196,   241,     1,   120,   121,    27,    28,    35,    43,
      45,    58,    60,    64,    65,    69,    72,    78,    84,   161,
     168,   170,   171,   172,   296,   141,    28,    35,   128,   156,
     165,   168,    48,    48,   311,    48,   311,     1,    48,   311,
      32,    32,   296,    24,    88,   101,   103,    88,   101,   104,
      88,    48,   143,   311,   143,    24,   101,   103,     1,   102,
     116,   115,   117,   296,   310,   105,   186,     1,   105,   105,
     105,   180,   105,   176,   186,   105,   187,   178,   179,   178,
     176,   177,    48,    97,   235,   311,    90,   114,   105,   105,
       4,   136,   101,     1,     5,     7,     8,     9,    15,    21,
      22,    24,    46,    55,    59,    62,    74,    81,    96,   100,
     105,   107,   129,   133,   159,   160,   220,   250,   278,   279,
     287,   288,   289,   292,   293,   294,   295,   296,   300,   301,
     303,   305,   310,   312,   250,     1,   124,   250,   233,   109,
      24,   101,   103,     1,    48,   311,   101,    95,   164,   168,
     115,     1,   164,   181,     1,     7,    96,   174,   188,   105,
     101,   170,    24,   103,   132,   115,   106,   158,   191,   192,
      21,    22,    46,    55,    59,    81,   129,   294,   294,   133,
     288,   294,   105,   304,     1,   105,   109,   197,   302,    32,
     196,   196,   105,   288,   288,     1,   109,   133,   163,   169,
     171,   276,   278,   133,   162,   163,   172,   294,   296,   306,
     307,   312,   288,   288,    11,    12,    13,    14,    16,    17,
      18,    19,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   232,   240,     3,     8,     9,    25,    26,
      36,    63,    66,    67,    70,    76,    79,    86,    88,   129,
     133,   280,    88,   280,   234,   242,   310,    97,   106,     1,
     104,   106,   106,   104,   164,   183,   184,   281,   106,     7,
      38,    39,   175,   164,   117,   118,   104,   281,    48,    97,
     311,   101,   104,   163,     1,   278,   302,     1,   166,   167,
     169,   172,   275,   276,   198,    48,   311,   219,     1,   110,
     277,   278,   282,   283,     1,   278,    24,   101,   103,   106,
     282,   133,   278,   284,   285,   286,   294,   312,    97,   106,
      90,   104,   106,   163,   307,    48,   108,   104,   308,   108,
       1,   287,     1,   287,     1,   287,     1,   287,     1,   287,
       1,   287,     1,   287,     1,   287,   279,     1,   287,     1,
     287,     1,   287,     1,   287,     1,   287,     1,   287,     1,
     287,     1,   287,     1,   287,     1,   287,   196,     1,   278,
       1,   282,     1,    24,    94,    97,   275,   278,   299,     1,
     278,   278,   278,   105,   230,     1,   235,   237,   239,   106,
     164,    38,    39,   142,   104,   281,     7,    96,   173,   102,
     106,   106,    88,   135,    88,   140,   158,   192,    24,   101,
     103,   106,     1,   104,    24,   101,   103,   106,   158,   194,
     203,   225,    48,   195,   204,   223,   311,   106,   196,   218,
      24,    61,   101,   103,   106,   278,    61,   106,   104,   281,
      24,   101,   103,   106,   106,   103,   131,   307,    24,   101,
     102,   103,   269,   108,   134,   104,   281,   170,   278,   108,
     306,     1,    88,   280,   102,     1,     4,    10,    20,    21,
      22,    23,    27,    28,    29,    30,    31,    33,    34,    35,
      37,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    64,    65,    68,    69,    71,    72,    73,    74,
      75,    77,    78,    80,    81,    82,    84,    85,    87,   149,
     150,   151,   152,   153,    24,   101,   103,   106,   106,    24,
     101,   103,   106,   108,    24,   275,   108,   108,   175,   154,
     227,   228,   229,   281,     1,    24,   109,   231,    88,   236,
      24,   103,   104,   200,   106,   102,   185,     7,   106,   189,
       1,    24,   193,     1,   105,   278,   105,    48,   311,    24,
     101,   103,   106,   278,    48,   311,   104,    88,   218,   104,
      88,   199,     1,   221,   277,   106,   108,     1,   278,   106,
       1,   286,   308,   278,   278,   279,   109,   290,   290,   299,
     128,   102,   104,   281,   106,   130,   114,   250,   238,   182,
     164,   164,   278,   138,   144,   146,   147,   164,   281,     1,
     308,    88,   218,    88,   202,   250,     1,   105,   145,   202,
     250,   208,   145,   196,   108,   158,   227,   227,   200,   237,
     164,   190,   146,   106,   102,   104,   281,   142,    24,   101,
     103,   106,   106,     1,    24,   278,     1,   145,   278,   158,
     194,   146,   224,   194,     1,     4,    10,    20,    23,    29,
      30,    33,    34,    37,    44,    48,    50,    51,    85,   101,
     123,   197,   200,   207,   209,   210,   211,   212,   215,   216,
     217,   244,   253,   256,   258,   261,   265,   268,   270,   272,
     275,   222,   218,   142,   311,   106,   106,   130,     1,    24,
     101,   127,   197,   144,   144,   143,   226,    48,   130,     1,
      24,   197,   201,    24,   101,   103,     1,    48,   205,   206,
     311,     1,    24,   101,   257,   274,   275,   266,   254,    48,
     214,   175,   274,   214,   102,   196,   259,   213,   245,   262,
     257,   257,   257,   201,   291,    48,   139,   201,    24,    88,
     101,   103,    88,   101,   104,    88,   257,   196,   196,   274,
     175,   269,   211,   196,   102,   196,   196,   208,   127,   250,
     250,     1,   205,   250,   267,   255,   269,   273,   274,    24,
      85,   260,   211,   246,   263,   200,   105,   105,   269,    24,
     105,   105,   105,   105,   274,   278,   274,   271,   274,   274,
     274,    24,   103,   106,   247,   101,   104,   252,   247,   257,
     247,   247,   211,     1,   249,   251,   306,   249,   247,   257,
     264,   274,   211,   211,   101,   211,   257,    40,   248,   251,
     271,   211,   247,   211
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   112,   113,   113,   114,   114,   114,   115,   115,   116,
     116,   116,   116,   117,   117,   118,   119,   121,   120,   122,
     122,   122,   122,   122,   122,   122,   123,   123,   123,   123,
     123,   124,   124,   124,   125,   125,   126,   126,   126,   126,
     127,   127,   127,   127,   128,   129,   130,   130,   131,   131,
     132,   132,   133,   134,   134,   135,   136,   136,   138,   139,
     137,   137,   140,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   141,   137,   142,   142,   142,
     143,   143,   143,   144,   145,   146,   146,   147,   147,   147,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   152,   152,   152,   153,   153,   153,   154,   155,
     155,   156,   156,   156,   157,   157,   158,   158,   159,   160,
     161,   161,   162,   162,   163,   163,   164,   164,   165,   166,
     167,   168,   168,   169,   169,   170,   170,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   172,   173,   173,   173,   174,   174,   174,
     175,   175,   176,   176,   176,   177,   178,   179,   178,   181,
     182,   180,   180,   183,   183,   184,   185,   184,   186,   186,
     188,   189,   190,   187,   187,   191,   191,   192,   192,   193,
     192,   192,   192,   192,   194,   194,   194,   194,   194,   194,
     195,   195,   195,   195,   196,   198,   199,   197,   200,   200,
     201,   201,   201,   202,   203,   203,   204,   204,   205,   205,
     205,   206,   206,   207,   207,   207,   207,   208,   208,   209,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   213,   212,   214,   214,   215,   216,   216,   217,   218,
     219,   221,   222,   220,   220,   224,   223,   223,   226,   225,
     225,   227,   227,   228,   228,   228,   229,   229,   230,   230,
     231,   231,   231,   233,   234,   232,   235,   235,   236,   236,
     237,   237,   238,   239,   239,   239,   241,   242,   240,   243,
     245,   246,   244,   247,   247,   247,   248,   248,   249,   249,
     250,   250,   250,   251,   251,   252,   252,   254,   255,   253,
     256,   256,   256,   257,   257,   259,   260,   258,   262,   263,
     261,   264,   264,   266,   267,   265,   268,   268,   268,   269,
     269,   269,   269,   270,   270,   271,   271,   272,   273,   273,
     274,   274,   275,   275,   275,   275,   275,   276,   276,   277,
     277,   278,   278,   278,   278,   278,   278,   278,   278,   278,
     278,   279,   279,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   281,   281,   282,   282,   283,   283,   284,
     284,   285,   285,   285,   286,   286,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   288,   288,   288,   288,   288,   288,   288,
     288,   289,   289,   289,   290,   291,   290,   292,   292,   292,
     292,   292,   293,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   295,
     295,   295,   296,   296,   296,   296,   296,   296,   297,   297,
     297,   297,   298,   298,   298,   298,   298,   298,   298,   298,
     298,   298,   298,   299,   299,   299,   299,   299,   300,   301,
     301,   301,   301,   301,   302,   302,   302,   302,   302,   302,
     302,   304,   303,   305,   305,   305,   305,   305,   305,   305,
     305,   305,   305,   305,   305,   305,   306,   306,   306,   306,
     307,   308,   308,   309,   309,   310,   310,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     0,     1,     3,     2,
       2,     2,     0,     1,     1,     1,     5,     0,     2,     5,
       5,     5,     5,     4,     4,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     3,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     0,
       1,     1,     1,     1,     0,     0,     0,     1,     0,     0,
      13,     8,     0,    11,     6,     1,     1,     1,     1,     2,
       2,     1,     2,     2,     2,     0,     5,     1,     1,     0,
       1,     1,     0,     3,     3,     1,     2,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     5,     3,     1,     0,     2,     2,     0,     3,     3,
       1,     2,     1,     1,     2,     1,     2,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     6,     5,
       2,     4,     4,     1,     0,     1,     2,     0,     1,     2,
       1,     1,     0,     5,     3,     1,     0,     0,     4,     0,
       0,     8,     0,     1,     2,     1,     0,     4,     3,     0,
       0,     0,     0,     8,     0,     1,     3,     2,     2,     0,
       5,     4,     4,     4,     2,     2,     4,     4,     4,     4,
       1,     1,     3,     3,     0,     0,     0,     6,     1,     1,
       1,     1,     1,     0,     1,     4,     1,     4,     3,     3,
       3,     1,     3,     3,     3,     3,     3,     0,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     4,     1,     0,     2,     2,     1,     2,     0,
       0,     0,     0,     8,     5,     0,     5,     3,     0,     6,
       4,     5,     4,     1,     3,     3,     1,     2,     0,     3,
       3,     1,     1,     0,     0,     7,     1,     1,     0,     2,
       0,     2,     0,     1,     4,     1,     0,     0,     7,     5,
       0,     0,     9,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     0,     1,     2,     4,     0,     0,     9,
       8,     5,     4,     1,     1,     0,     0,    12,     0,     0,
       8,     0,     1,     0,     0,     8,     3,     5,     4,     1,
       1,     1,     1,     2,     3,     0,     1,     1,     0,     1,
       1,     1,     1,     2,     2,     2,     2,     1,     3,     1,
       2,     1,     3,     3,     3,     5,     3,     3,     3,     5,
       4,     1,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     0,     2,     1,     3,     0,
       2,     1,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     2,     2,     2,     2,     2,     2,
       2,     1,     2,     2,     0,     0,     6,     5,     5,     4,
       4,     4,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     4,     4,     6,     4,     4,
       4,     4,     4,     3,     5,     5,     4,     4,     3,     3,
       3,     3,     4,     4,     4,     4,     4,     4,     4,     1,
       3,     3,     1,     3,     2,     3,     3,     3,     2,     2,
       3,     3,     1,     1,     3,     3,     3,     3,     2,     2,
       2,     2,     2,     0,     1,     2,     1,     2,     2,     4,
       4,     4,     4,     4,     3,     3,     3,     3,     3,     1,
       1,     0,     3,     7,     7,     7,     7,     7,     5,     5,
       5,     5,     4,     4,     4,     4,     1,     3,     2,     1,
       2,     0,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 380 "language.yacc" /* yacc.c:1646  */
    { YYACCEPT; }
#line 3718 "y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 381 "language.yacc" /* yacc.c:1646  */
    { YYACCEPT; }
#line 3724 "y.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 392 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-2].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 3739 "y.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 404 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 3745 "y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 405 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3751 "y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 406 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3757 "y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 407 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3763 "y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 414 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    if (call_handle_inherit((yyvsp[0].n)->u.sval.u.string)) {
      STACK_LEVEL_CHECK(2);
      (yyval.n)=mksvaluenode(Pike_sp-1);
      pop_stack();
    }
    else
      (yyval.n)=mknewintnode(0);
    STACK_LEVEL_CHECK(1);
    if((yyval.n)->name) free_string((yyval.n)->name);
#ifdef PIKE_DEBUG
    if (Pike_sp[-1].type != T_STRING) {
      Pike_fatal("Compiler lost track of program name.\n");
    }
#endif /* PIKE_DEBUG */
    /* FIXME: Why not use $1->u.sval.u.string here? */
    add_ref( (yyval.n)->name=Pike_sp[-1].u.string );
    free_node((yyvsp[0].n));

    STACK_LEVEL_DONE(1);
  }
#line 3792 "y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 439 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    if(Pike_compiler->last_identifier)
    {
      ref_push_string(Pike_compiler->last_identifier);
    }else{
      push_empty_string();
    }
    (yyval.n)=(yyvsp[0].n);

    STACK_LEVEL_DONE(1);
  }
#line 3810 "y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 456 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    resolv_program((yyvsp[0].n));
    free_node((yyvsp[0].n));

    STACK_LEVEL_DONE(1);
  }
#line 3823 "y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 467 "language.yacc" /* yacc.c:1646  */
    {
#ifdef WITH_FACETS
    struct object *o;
    if (Pike_compiler->compiler_pass == 1) {
      if (Pike_compiler->new_program->flags & PROGRAM_IS_FACET) {
	yyerror("A class can only belong to one facet.");
      }
      else {
	resolv_constant((yyvsp[-1].n));
	if (Pike_sp[-1].type == T_OBJECT) {
	  /* FIXME: Object subtypes! */
	  o = Pike_sp[-1].u.object;
	  ref_push_string((yyvsp[-3].n)->u.sval.u.string);
	  push_int(Pike_compiler->new_program->id);
	  push_int(!!(Pike_compiler->new_program->flags & PROGRAM_IS_PRODUCT));
	  safe_apply(o, "add_facet_class", 3);
	  if (Pike_sp[-1].type == T_INT &&
	      Pike_sp[-1].u.integer >= 0) {
	    Pike_compiler->new_program->flags &= ~PROGRAM_IS_PRODUCT;
	    Pike_compiler->new_program->flags |= PROGRAM_IS_FACET;
	    Pike_compiler->new_program->facet_index = Pike_sp[-1].u.integer;
	    add_ref(Pike_compiler->new_program->facet_group = o);
	  }
	  else
	    yyerror("Could not add facet class to system.");
	  pop_stack();
	}
	else
	  yyerror("Invalid facet group specifier.");
	pop_stack();
      }
    }
    free_node((yyvsp[-3].n));
    free_node((yyvsp[-1].n));
#else
    yyerror("No support for facets.");
#endif
  }
#line 3866 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 508 "language.yacc" /* yacc.c:1646  */
    {
    SET_FORCE_RESOLVE((yyval.number));
  }
#line 3874 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 512 "language.yacc" /* yacc.c:1646  */
    {
    UNSET_FORCE_RESOLVE((yyvsp[-1].number));
    (yyval.n) = (yyvsp[0].n);
  }
#line 3883 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 519 "language.yacc" /* yacc.c:1646  */
    {
    if (((yyvsp[-4].number) & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared inherit.");
    }
    if((yyvsp[-2].n))
    {
      struct pike_string *s=Pike_sp[-1].u.string;
      if((yyvsp[-1].n)) s=(yyvsp[-1].n)->u.sval.u.string;
      compiler_do_inherit((yyvsp[-2].n),(yyvsp[-4].number),s);
    }

#ifdef WITH_FACETS
    /* If this is a product class, check that all product classes in its
     * facet-group inherit from all facets */
    if((yyvsp[-2].n) && Pike_compiler->compiler_pass == 2) {
      if (Pike_compiler->new_program->flags & PROGRAM_IS_PRODUCT) {
	if (!Pike_compiler->new_program->facet_group)
	  yyerror("Product class without facet group.");
	else {
	  safe_apply(Pike_compiler->new_program->facet_group,
		     "product_classes_checked", 0);
	  if (Pike_sp[-1].type == T_INT &&
	      Pike_sp[-1].u.integer == 0) {
	    pop_stack();
	    safe_apply(Pike_compiler->new_program->facet_group,
		       "check_product_classes", 0);
	  }
	  pop_stack();
	}
      }
    }
#endif
    if((yyvsp[-1].n)) free_node((yyvsp[-1].n));
    pop_stack();
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
  }
#line 3924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 556 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerrok;
  }
#line 3934 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 562 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 3945 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 569 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
  }
#line 3955 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 574 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 3961 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 576 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 3970 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 580 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 3976 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 584 "language.yacc" /* yacc.c:1646  */
    {
    resolv_constant((yyvsp[-1].n));
    free_node((yyvsp[-1].n));
    use_module(Pike_sp-1);
    pop_stack();
  }
#line 3987 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 591 "language.yacc" /* yacc.c:1646  */
    {
    if (call_handle_import((yyvsp[-1].n)->u.sval.u.string)) {
      use_module(Pike_sp-1);
      pop_stack();
    }
    free_node((yyvsp[-1].n));
  }
#line 3999 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 598 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 4005 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 600 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4014 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 604 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 4020 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 608 "language.yacc" /* yacc.c:1646  */
    {
    /* This can be made more lenient in the future */

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      Pike_compiler->compiler_pass=tmp;
    }

    if (!TEST_COMPAT(7, 6) && (Pike_compiler->current_modifiers & ID_EXTERN)) {
      int depth = 0;
      struct program_state *state = Pike_compiler;
      node *n = (yyvsp[0].n);
      while (((n->token == F_COMMA_EXPR) || (n->token == F_ARG_LIST)) &&
	     ((!CAR(n)) ^ (!CDR(n)))) {
	if (CAR(n)) n = CAR(n);
	else n = CDR(n);
      }
      if (n->token == F_EXTERNAL) {
	while (state && (state->new_program->id != n->u.integer.a)) {
	  depth++;
	  state = state->previous;
	}
      }
      if (depth && state) {
	/* Alias for a symbol in a surrounding scope. */
	int id = really_low_reference_inherited_identifier(state, 0,
							   n->u.integer.b);
	define_alias((yyvsp[-2].n)->u.sval.u.string, n->type,
		     Pike_compiler->current_modifiers & ~ID_EXTERN,
		     depth, id);
      } else if (Pike_compiler->compiler_pass == 1) {
	yyerror("Invalid extern declared constant.");
	add_constant((yyvsp[-2].n)->u.sval.u.string, &svalue_undefined,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      }
    } else {
      if (TEST_COMPAT(7, 6) &&
	  (Pike_compiler->current_modifiers & ID_EXTERN) &&
	  (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared constant.");
      }
      if(!is_const((yyvsp[0].n))) {
	if (Pike_compiler->compiler_pass == 2) {
	  yyerror("Constant definition is not constant.");
	}
	add_constant((yyvsp[-2].n)->u.sval.u.string, 0,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      } else {
	if(!Pike_compiler->num_parse_error)
	{
	  ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	  if(tmp < 1)
	  {
	    yyerror("Error in constant definition.");
	    push_undefined();
	  }else{
	    pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	  }
	} else {
	  push_undefined();
	}
	add_constant((yyvsp[-2].n)->u.sval.u.string, Pike_sp-1,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
	pop_stack();
      }
    }
  const_def_ok:
    if((yyvsp[0].n)) free_node((yyvsp[0].n));
    free_node((yyvsp[-2].n));
  }
#line 4097 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 680 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4103 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 681 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4109 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 688 "language.yacc" /* yacc.c:1646  */
    {}
#line 4115 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 689 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 4121 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 691 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4130 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 695 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 4136 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 699 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[0].n));
  }
#line 4145 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 703 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 4151 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 704 "language.yacc" /* yacc.c:1646  */
    { yyerror("Expected ';'."); (yyval.n) = NULL; }
#line 4157 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 705 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 4163 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 710 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    check_type_string((yyvsp[0].n)->u.sval.u.type);
#endif /* PIKE_DEBUG */
    if(Pike_compiler->compiler_frame->current_type)
      free_type(Pike_compiler->compiler_frame->current_type); 
    copy_pike_type(Pike_compiler->compiler_frame->current_type,
		   (yyvsp[0].n)->u.sval.u.type);
    free_node((yyvsp[0].n));
  }
#line 4178 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 723 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4187 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 730 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4196 "y.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 735 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4206 "y.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 744 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
  }
#line 4214 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 751 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
  }
#line 4222 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 757 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4231 "y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 765 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ']'.");
  }
#line 4239 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 771 "language.yacc" /* yacc.c:1646  */
    {
    push_compiler_frame(SCOPE_LOCAL);

    if(!Pike_compiler->compiler_frame->previous ||
       !Pike_compiler->compiler_frame->previous->current_type)
    {
      yyerror("Internal compiler error (push_compiler_frame0).");
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		mixed_type_string);
    }else{
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		Pike_compiler->compiler_frame->previous->current_type);
    }

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 4260 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 790 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT;
  }
#line 4268 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 794 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = 0;
  }
#line 4276 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 802 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = 0;
    /* Check for the (very special) case of create and create_args. */
    if (Pike_compiler->num_create_args) {
      struct pike_string *create_string = NULL;
      int e;
      MAKE_CONST_STRING(create_string, "create");
      if ((yyvsp[-2].n)->u.sval.u.string == create_string) {
	if (TEST_COMPAT(7, 6)) {
	  yywarning("Having both an implicit and an explicit create() "
		    "was not supported in Pike 7.6 and before.");
	}
	/* Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  Pike_compiler->varargs = 1;
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}
	(yyval.number) = e;
      }
    }
  }
#line 4320 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 842 "language.yacc" /* yacc.c:1646  */
    {
    int e;

    /* Adjust opt_flags in case we've got an optional_constant. */
    Pike_compiler->compiler_frame->opt_flags = (yyvsp[-7].number);

    /* construct the function type */
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if ((yyvsp[-6].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while(--(yyvsp[-6].number)>=0) push_type(T_ARRAY);
    
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type = compiler_pop_type();
    
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);
    
    e = (yyvsp[-2].number) + (yyvsp[-1].number) - 1;
    if(Pike_compiler->varargs &&
       (!(yyvsp[-2].number) || (Pike_compiler->num_create_args >= 0)))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    if ((yyvsp[-9].n)) {
      node *n = (yyvsp[-9].n);
      while (n) {
	push_type_attribute(CDR(n)->u.sval.u.string);
	n = CAR(n);
      }
    }

    {
      struct pike_type *s=compiler_pop_type();
      int i = isidentifier((yyvsp[-5].n)->u.sval.u.string);

      if (Pike_compiler->compiler_pass == 1) {
	if ((yyvsp[-10].number) & ID_VARIANT) {
	  /* FIXME: Lookup the type of any existing variant */
	  /* Or the types. */
	  fprintf(stderr, "Pass %d: Identifier %s:\n",
		  Pike_compiler->compiler_pass, (yyvsp[-5].n)->u.sval.u.string->str);

	  if (i >= 0) {
	    struct identifier *id = ID_FROM_INT(Pike_compiler->new_program, i);
	    if (id) {
	      struct pike_type *new_type;
	      fprintf(stderr, "Defined, type:\n");
#ifdef PIKE_DEBUG
	      simple_describe_type(id->type);
#endif

	      new_type = or_pike_types(s, id->type, 1);
	      free_type(s);
	      s = new_type;

	      fprintf(stderr, "Resulting type:\n");
#ifdef PIKE_DEBUG
	      simple_describe_type(s);
#endif
	    } else {
	      my_yyerror("Lost identifier %S (%d).",
			 (yyvsp[-5].n)->u.sval.u.string, i);
	    }
	  } else {
	    fprintf(stderr, "Not defined.\n");
	  }
	  fprintf(stderr, "New type:\n");
#ifdef PIKE_DEBUG
	  simple_describe_type(s);
#endif
	}
      } else {
	/* FIXME: Second pass reuses the type from the end of
	 * the first pass if this is a variant function.
	 */
	if (i >= 0) {
	  if (Pike_compiler->new_program->identifier_references[i].id_flags &
	      ID_VARIANT) {
	    struct identifier *id = ID_FROM_INT(Pike_compiler->new_program, i);
	    fprintf(stderr, "Pass %d: Identifier %s:\n",
		    Pike_compiler->compiler_pass, (yyvsp[-5].n)->u.sval.u.string->str);

	    free_type(s);
	    copy_pike_type(s, id->type);

	    fprintf(stderr, "Resulting type:\n");
#ifdef PIKE_DEBUG
	    simple_describe_type(s);
#endif
	  }
	} else {
	  my_yyerror("Identifier %S lost after first pass.",
		     (yyvsp[-5].n)->u.sval.u.string);
	}
      }

      (yyval.n) = mktypenode(s);
      free_type(s);
    }


/*    if(Pike_compiler->compiler_pass==1) */
    {
      /* FIXME:
       * set current_function_number for local functions as well
       */
      Pike_compiler->compiler_frame->current_function_number=
	define_function((yyvsp[-5].n)->u.sval.u.string,
			(yyval.n)->u.sval.u.type,
			(yyvsp[-10].number) & (~ID_EXTERN),
			IDENTIFIER_PIKE_FUNCTION |
			(Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			0,
			(yyvsp[-7].number));

      Pike_compiler->varargs=0;

      if ((yyvsp[-10].number) & ID_VARIANT) {
	fprintf(stderr, "Function number: %d\n",
		Pike_compiler->compiler_frame->current_function_number);
      }
    }
  }
#line 4461 "y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 979 "language.yacc" /* yacc.c:1646  */
    {
    int e;
    if((yyvsp[0].n))
    {
      int f;
      node *check_args = NULL;
      struct compilation *c = THIS_COMPILATION;
      struct pike_string *save_file = c->lex.current_file;
      int save_line  = c->lex.current_line;
      int num_required_args = 0;
      struct identifier *i;
      c->lex.current_file = (yyvsp[-7].n)->current_file;
      c->lex.current_line = (yyvsp[-7].n)->line_number;

      if (((yyvsp[-12].number) & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared function definition.");
      }

      for(e=0; e<(yyvsp[-4].number)+(yyvsp[-3].number); e++)
      {
	if((e >= (yyvsp[-4].number)) &&
	   (!Pike_compiler->compiler_frame->variable[e].name ||
	    !Pike_compiler->compiler_frame->variable[e].name->len))
	{
	  my_yyerror("Missing name for argument %d.", e - (yyvsp[-4].number));
	} else {
	  if (Pike_compiler->compiler_pass == 2) {
	    if ((yyvsp[-12].number) & ID_VARIANT) {
	      struct pike_type *arg_type =
		Pike_compiler->compiler_frame->variable[e].type;

	      /* FIXME: Generate code that checks the arguments. */
	      /* If there is a bad argument, call the fallback, and return. */
	      if (! pike_types_le(void_type_string, arg_type)) {
		/* Argument my not be void.
		 * ie it's required.
		 */
		num_required_args++;
	      }
	    } else {
	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		node *local_node;

		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mklocalnode(e, 0);

		/* The following is needed to go around the optimization in
		 * mksoftcastnode().
		 */
		free_type(local_node->type);
		copy_pike_type(local_node->type, mixed_type_string);

		check_args =
		  mknode(F_COMMA_EXPR, check_args,
			 mksoftcastnode(Pike_compiler->compiler_frame->variable[e].type,
					local_node));
	      }
	    }
	  }
	}
      }

      if ((yyvsp[-12].number) & ID_VARIANT) {
	struct pike_string *bad_arg_str;
	MAKE_CONST_STRING(bad_arg_str,
			  "Bad number of arguments!\n");

	fprintf(stderr, "Required args: %d\n", num_required_args);

	check_args =
	  mknode('?',
		 mkopernode("`<",
			    mkefuncallnode("query_num_arg", NULL),
			    mkintnode(num_required_args)),
		 mknode(':',
			mkefuncallnode("throw",
				       mkefuncallnode("aggregate",
						      mkstrnode(bad_arg_str))),
			NULL));
      }

      if ((yyvsp[-4].number)) {
	/* Hook in the initializers for the create arguments. */
	for (e = (yyvsp[-4].number); e--;) {
	  (yyvsp[0].n) = mknode(F_COMMA_EXPR,
		       mknode(F_POP_VALUE,
			      mknode(F_ASSIGN, mklocalnode(e, 0),
				     mkidentifiernode(e)), NULL),
		       (yyvsp[0].n));
	}
      }

      {
	int l = (yyvsp[0].n)->line_number;
	struct pike_string *f = (yyvsp[0].n)->current_file;
	if (check_args) {
	  /* Prepend the arg checking code. */
	  (yyvsp[0].n) = mknode(F_COMMA_EXPR, mknode(F_POP_VALUE, check_args, NULL), (yyvsp[0].n));
	}
	c->lex.current_line = l;
	c->lex.current_file = f;
      }

      f=dooptcode((yyvsp[-7].n)->u.sval.u.string, (yyvsp[0].n), (yyvsp[-1].n)->u.sval.u.type, (yyvsp[-12].number));

      i = ID_FROM_INT(Pike_compiler->new_program, f);
      i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

      if ((yyvsp[-12].number) & ID_VARIANT) {
	fprintf(stderr, "Function number: %d\n", f);
      }

#ifdef PIKE_DEBUG
      if(Pike_interpreter.recoveries &&
	 ((Pike_sp - Pike_interpreter.evaluator_stack) <
	  Pike_interpreter.recoveries->stack_pointer))
	Pike_fatal("Stack error (underflow)\n");

      if((Pike_compiler->compiler_pass == 1) &&
	 (f != Pike_compiler->compiler_frame->current_function_number)) {
	fprintf(stderr, "define_function()/do_opt_code() failed for symbol %s\n",
		(yyvsp[-7].n)->u.sval.u.string->str);
	dump_program_desc(Pike_compiler->new_program);
	Pike_fatal("define_function screwed up! %d != %d\n",
	      f, Pike_compiler->compiler_frame->current_function_number);
      }
#endif

      c->lex.current_line = save_line;
      c->lex.current_file = save_file;
    } else {
      /* Prototype; don't warn about unused arguments. */
      for (e = Pike_compiler->compiler_frame->current_number_of_locals; e--;) {
	Pike_compiler->compiler_frame->variable[e].flags |= LOCAL_VAR_IS_USED;
      }
    }
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-6].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-6].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-7].n));
    free_node((yyvsp[-2].n));
    free_node((yyvsp[-1].n));
    if ((yyvsp[-11].n)) free_node((yyvsp[-11].n));
  }
#line 4620 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1135 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-2].n));
    if ((yyvsp[-6].n))
      free_node((yyvsp[-6].n));
  }
#line 4639 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1150 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-4].n))
      free_node((yyvsp[-4].n));
    compiler_discard_type();
  }
#line 4649 "y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1156 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) free_node((yyvsp[0].n));
  }
#line 4657 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1160 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-4].n)) {
      yyerror("Invalid use of attributes in variable declaration.\n");
      free_node((yyvsp[-4].n));
    }
  }
#line 4668 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1166 "language.yacc" /* yacc.c:1646  */
    {}
#line 4674 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1167 "language.yacc" /* yacc.c:1646  */
    {}
#line 4680 "y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1168 "language.yacc" /* yacc.c:1646  */
    {}
#line 4686 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1169 "language.yacc" /* yacc.c:1646  */
    {}
#line 4692 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1170 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[0].n)); }
#line 4698 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1171 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[0].n)); }
#line 4704 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1172 "language.yacc" /* yacc.c:1646  */
    {}
#line 4710 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1174 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file");
  }
#line 4720 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1180 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerrok;
/*     if(Pike_compiler->num_parse_error>5) YYACCEPT; */
  }
#line 4730 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1186 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
   /* yychar = '}';	*/ /* Put the '}' back on the input stream */
  }
#line 4740 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1193 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.number)=THIS_COMPILATION->lex.pragmas;
      THIS_COMPILATION->lex.pragmas|=(yyvsp[-1].number);
    }
#line 4749 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1199 "language.yacc" /* yacc.c:1646  */
    {
      THIS_COMPILATION->lex.pragmas=(yyvsp[-2].number);
    }
#line 4757 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1204 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 4763 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1206 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Range indicator ('..') where elipsis ('...') expected.");
    (yyval.number)=1;
  }
#line 4772 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1210 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 4778 "y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1214 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 4784 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1215 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 4790 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1219 "language.yacc" /* yacc.c:1646  */
    {
    int i;
    if(Pike_compiler->varargs) yyerror("Can't define more arguments after ...");

    if((yyvsp[-1].number))
    {
      push_type(T_ARRAY);
      Pike_compiler->varargs=1;
    }

    if(!(yyvsp[0].n))
    {
      (yyvsp[0].n)=mkstrnode(empty_pike_string);
    }

    if((yyvsp[0].n)->u.sval.u.string->len &&
       islocal((yyvsp[0].n)->u.sval.u.string) >= 0)
      my_yyerror("Variable %S appears twice in argument list.",
		 (yyvsp[0].n)->u.sval.u.string);
    
    i = add_local_name((yyvsp[0].n)->u.sval.u.string, compiler_pop_type(),0);
    if (i >= 0) {
      /* Don't warn about unused arguments. */
      Pike_compiler->compiler_frame->variable[i].flags |= LOCAL_VAR_IS_USED;
    }
    free_node((yyvsp[0].n));
  }
#line 4822 "y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1249 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
    (yyval.number)=(yyvsp[-1].number);
  }
#line 4831 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1255 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 4837 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1259 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 1; }
#line 4843 "y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1260 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 4849 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1262 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected ':' in argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 4858 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1270 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.number) = ID_FINAL | ID_INLINE;
      if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
          !TEST_COMPAT(7, 6) && Pike_compiler->compiler_pass==1 )
        yywarning("Keyword nomask is deprecated in favour of 'final'.");

    }
#line 4870 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1277 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_FINAL | ID_INLINE; }
#line 4876 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1278 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PROTECTED; }
#line 4882 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1279 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_EXTERN; }
#line 4888 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1280 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_OPTIONAL; }
#line 4894 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1281 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PRIVATE | ID_PROTECTED; }
#line 4900 "y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1282 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_INLINE; }
#line 4906 "y.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1283 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PUBLIC; }
#line 4912 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1284 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PROTECTED; }
#line 4918 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1285 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_INLINE; }
#line 4924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1286 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_VARIANT; }
#line 4930 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1290 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "nomask"; }
#line 4936 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1291 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "final"; }
#line 4942 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1292 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "static"; }
#line 4948 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1293 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "extern"; }
#line 4954 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1294 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "private"; }
#line 4960 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1295 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "local"; }
#line 4966 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1296 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "public"; }
#line 4972 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1297 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "protected"; }
#line 4978 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1298 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "inline"; }
#line 4984 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1299 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "optional"; }
#line 4990 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1300 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "variant"; }
#line 4996 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1304 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "void"; }
#line 5002 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1305 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "mixed"; }
#line 5008 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1306 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "array"; }
#line 5014 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1307 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__attribute__"; }
#line 5020 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1308 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__deprecated__"; }
#line 5026 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1309 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "mapping"; }
#line 5032 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1310 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "multiset"; }
#line 5038 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1311 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "object"; }
#line 5044 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1312 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "function"; }
#line 5050 "y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1313 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__func__"; }
#line 5056 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1314 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "program"; }
#line 5062 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1315 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "string"; }
#line 5068 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1316 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "float"; }
#line 5074 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1317 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "int"; }
#line 5080 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1318 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "enum"; }
#line 5086 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1319 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "typedef"; }
#line 5092 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1323 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "if"; }
#line 5098 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1324 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "do"; }
#line 5104 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1325 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "for"; }
#line 5110 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1326 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "while"; }
#line 5116 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1327 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "else"; }
#line 5122 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1328 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "foreach"; }
#line 5128 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1329 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "catch"; }
#line 5134 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1330 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "gauge"; }
#line 5140 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1331 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "class"; }
#line 5146 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1332 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "break"; }
#line 5152 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1333 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "case"; }
#line 5158 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1334 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "constant"; }
#line 5164 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1335 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "continue"; }
#line 5170 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1336 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "default"; }
#line 5176 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1337 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "facet"; }
#line 5182 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1338 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "import"; }
#line 5188 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1339 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "inherit"; }
#line 5194 "y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1340 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "lambda"; }
#line 5200 "y.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1341 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "predef"; }
#line 5206 "y.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1342 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "return"; }
#line 5212 "y.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1343 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "sscanf"; }
#line 5218 "y.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1344 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "switch"; }
#line 5224 "y.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1345 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "typeof"; }
#line 5230 "y.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1346 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "global"; }
#line 5236 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1353 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *tmp=make_shared_string((yyvsp[0].str));
    (yyval.n)=mkstrnode(tmp);
    free_string(tmp);
  }
#line 5246 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1361 "language.yacc" /* yacc.c:1646  */
    {
   (yyval.number)=Pike_compiler->current_modifiers=(yyvsp[0].number) |
     (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
 }
#line 5255 "y.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1367 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 5261 "y.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1368 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) | (yyvsp[0].number); }
#line 5267 "y.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1372 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[-2].n);
  }
#line 5275 "y.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1376 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 5285 "y.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1382 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 5295 "y.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1389 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 5301 "y.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1390 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = mknode(F_ARG_LIST, (yyvsp[-1].n), (yyvsp[0].n)); }
#line 5307 "y.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1393 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=(yyvsp[-1].number) + 1; }
#line 5313 "y.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1394 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 5319 "y.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1398 "language.yacc" /* yacc.c:1646  */
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 5331 "y.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1408 "language.yacc" /* yacc.c:1646  */
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 5343 "y.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1419 "language.yacc" /* yacc.c:1646  */
    {
    if (Pike_compiler->compiler_pass == 2 && !TEST_COMPAT (0, 6)) {
       yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    push_type(T_ARRAY);
  }
#line 5354 "y.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1430 "language.yacc" /* yacc.c:1646  */
    {
    if (Pike_compiler->compiler_pass == 2 && !TEST_COMPAT (0, 6)) {
       yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    push_type(T_ARRAY);
  }
#line 5365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1440 "language.yacc" /* yacc.c:1646  */
    {
    if (Pike_compiler->compiler_pass == 2 && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    push_type(T_ARRAY);
  }
#line 5376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1450 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5391 "y.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1463 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5406 "y.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1476 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5421 "y.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1488 "language.yacc" /* yacc.c:1646  */
    { push_type(T_OR); }
#line 5427 "y.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1492 "language.yacc" /* yacc.c:1646  */
    { push_type(T_OR); }
#line 5433 "y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1499 "language.yacc" /* yacc.c:1646  */
    { push_type(T_FLOAT); }
#line 5439 "y.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1500 "language.yacc" /* yacc.c:1646  */
    { push_type(T_VOID); }
#line 5445 "y.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1501 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MIXED); }
#line 5451 "y.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1502 "language.yacc" /* yacc.c:1646  */
    {}
#line 5457 "y.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1503 "language.yacc" /* yacc.c:1646  */
    {}
#line 5463 "y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1504 "language.yacc" /* yacc.c:1646  */
    {}
#line 5469 "y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1505 "language.yacc" /* yacc.c:1646  */
    {}
#line 5475 "y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1506 "language.yacc" /* yacc.c:1646  */
    {}
#line 5481 "y.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1507 "language.yacc" /* yacc.c:1646  */
    { push_type(T_PROGRAM); }
#line 5487 "y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1508 "language.yacc" /* yacc.c:1646  */
    { push_type(T_ARRAY); }
#line 5493 "y.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1509 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MULTISET); }
#line 5499 "y.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1511 "language.yacc" /* yacc.c:1646  */
    {
    push_type_attribute((yyvsp[-3].n)->u.sval.u.string);
    free_node((yyvsp[-3].n));
  }
#line 5508 "y.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1516 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
    push_type_attribute((yyvsp[-2].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
  }
#line 5518 "y.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1522 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
  }
#line 5526 "y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1526 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type_attribute(deprecated_string);
  }
#line 5536 "y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1532 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type(T_MIXED);
    push_type_attribute(deprecated_string);
  }
#line 5547 "y.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1541 "language.yacc" /* yacc.c:1646  */
    { 
    resolv_constant((yyvsp[0].n));

    if (Pike_sp[-1].type == T_TYPE) {
      /* "typedef" */
      push_finished_type(Pike_sp[-1].u.type);
    } else {
      /* object type */
      struct program *p = NULL;

      if (Pike_sp[-1].type == T_OBJECT) {
	if(!(p = Pike_sp[-1].u.object->prog))
	{
	  pop_stack();
	  push_int(0);
	  yyerror("Destructed object used as program identifier.");
	}else{
	  int f = FIND_LFUN(p->inherits[Pike_sp[-1].subtype].prog, LFUN_CALL);
	  if(f!=-1)
	  {
	    Pike_sp[-1].subtype =
	      f + p->inherits[Pike_sp[-1].subtype].identifier_level;
	    Pike_sp[-1].type=T_FUNCTION;
	  }else{
	    extern void f_object_program(INT32);
	    if (Pike_compiler->compiler_pass == 2 && !TEST_COMPAT (7, 4)) {
	      yywarning("Using object as program identifier.");
	    }
	    f_object_program(1);
	  }
	}
      }

      switch(Pike_sp[-1].type) {
	case T_FUNCTION:
	if((p = program_from_function(Pike_sp-1))) {
	  push_object_type(0, p?(p->id):0);
	  break;
	} else {
	  /* Attempt to get the return type for the function. */
	  struct pike_type *a, *b;
	  a = get_type_of_svalue(Pike_sp-1);
	  /* Note: check_splice_call() below eats a reference from a.
	   * Note: CALL_INHIBIT_WARNINGS is needed since we don't
	   *       provide a function name (and we don't want
	   *       warnings here anyway).
	   */
	  a = check_splice_call(NULL, a, 0, mixed_type_string, NULL,
				CALL_INHIBIT_WARNINGS);
	  if (a) {
	    b = new_get_return_type(a, 0);
	    free_type(a);
	    if (b) {
	      push_finished_type(b);
	      free_type(b);
	      break;
	    }
	  }
	}
	/* FALL_THROUGH */
      
      default:
	if (Pike_compiler->compiler_pass!=1)
	  my_yyerror("Illegal program identifier: %O.", Pike_sp-1);
	pop_stack();
	push_int(0);
	push_object_type(0, 0);
	break;
	
      case T_PROGRAM:
	p = Pike_sp[-1].u.program;
	push_object_type(0, p?(p->id):0);
	break;
      }
    }
    /* Attempt to name the type. */
    if (Pike_compiler->last_identifier) {
      push_type_name(Pike_compiler->last_identifier);
    }
    pop_stack();
    free_node((yyvsp[0].n));
  }
#line 5634 "y.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1626 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkintnode(MAX_INT_TYPE);
  }
#line 5642 "y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1631 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (((yyvsp[0].n)->token != F_CONSTANT) || ((yyvsp[0].n)->u.sval.type != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
    free_node((yyvsp[0].n));
  }
#line 5656 "y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1643 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkintnode(MIN_INT_TYPE);
  }
#line 5664 "y.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1648 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (((yyvsp[0].n)->token != F_CONSTANT) || ((yyvsp[0].n)->u.sval.type != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
    free_node((yyvsp[0].n));
  }
#line 5678 "y.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1661 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Elipsis ('...') where range indicator ('..') expected.");
  }
#line 5686 "y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1667 "language.yacc" /* yacc.c:1646  */
    {
    push_int_type(MIN_INT_TYPE, MAX_INT_TYPE);
  }
#line 5694 "y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1671 "language.yacc" /* yacc.c:1646  */
    {
    INT_TYPE min = MIN_INT_TYPE;
    INT_TYPE max = MAX_INT_TYPE;

    /* FIXME: Check that $4 is >= $2. */
    if((yyvsp[-1].n)->token == F_CONSTANT) {
      if ((yyvsp[-1].n)->u.sval.type == T_INT) {
	max = (yyvsp[-1].n)->u.sval.u.integer;
#ifdef AUTO_BIGNUM
      } else if (is_bignum_object_in_svalue(&(yyvsp[-1].n)->u.sval)) {
	push_int(0);
	if (is_lt(&(yyvsp[-1].n)->u.sval, Pike_sp-1)) {
	  max = MIN_INT_TYPE;
	}
	pop_stack();
#endif /* AUTO_BIGNUM */
      }
    }

    if((yyvsp[-3].n)->token == F_CONSTANT) {
      if ((yyvsp[-3].n)->u.sval.type == T_INT) {
	min = (yyvsp[-3].n)->u.sval.u.integer;
#ifdef AUTO_BIGNUM
      } else if (is_bignum_object_in_svalue(&(yyvsp[-3].n)->u.sval)) {
	push_int(0);
	if (is_lt(Pike_sp-1, &(yyvsp[-3].n)->u.sval)) {
	  min = MAX_INT_TYPE;
	}
	pop_stack();
#endif /* AUTO_BIGNUM */
      }
    }

    push_int_type(min, max);

    free_node((yyvsp[-3].n));
    free_node((yyvsp[-1].n));
  }
#line 5737 "y.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1710 "language.yacc" /* yacc.c:1646  */
    {
    push_int_type(MIN_INT32, MAX_INT32);
    yyerror("Expected integer range.");
  }
#line 5746 "y.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1717 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_STRING);
  }
#line 5754 "y.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1722 "language.yacc" /* yacc.c:1646  */
    { push_object_type(0, 0); }
#line 5760 "y.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1723 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
      (yyval.ptr) = Pike_sp;
#endif /* PIKE_DEBUG */
    }
#line 5770 "y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1729 "language.yacc" /* yacc.c:1646  */
    {
    /* NOTE: On entry, there are two items on the stack:
     *   Pike_sp-2:	Name of the program reference (string).
     *   Pike_sp-1:	The resolved program (program|function|zero).
     */
    struct program *p=program_from_svalue(Pike_sp-1);

#ifdef PIKE_DEBUG
    if ((yyvsp[-3].ptr) != (Pike_sp - 2)) {
      Pike_fatal("Unexpected stack depth: %p != %p\n",
		 (yyvsp[-3].n), Pike_sp-2);
    }
#endif /* PIKE_DEBUG */

    if(!p) {
      if (Pike_compiler->compiler_pass!=1) {
	my_yyerror("Not a valid program specifier: %S", Pike_sp[-2].u.string);
      }
    }
    push_object_type(0, p?(p->id):0);
    /* Attempt to name the type. */
    if (Pike_sp[-2].type == T_STRING) {
      push_type_name(Pike_sp[-2].u.string);
    }
    pop_n_elems(2);
  }
#line 5801 "y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1758 "language.yacc" /* yacc.c:1646  */
    {
    type_stack_mark();
  }
#line 5809 "y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1762 "language.yacc" /* yacc.c:1646  */
    {
    /* Add the many type if there is none. */
    if ((yyvsp[-1].number))
    {
      if (!(yyvsp[-2].number)) {
	/* function_type_list ends with a comma, or is empty.
	 * FIXME: Should this be a syntax error or not?
	 */
	if (Pike_compiler->compiler_pass == 1) {
	  yyerror("Missing type before ... .");
	}
	push_type(T_MIXED);
      }
    }else{
      push_type(T_VOID);
    }
  }
#line 5831 "y.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1780 "language.yacc" /* yacc.c:1646  */
    {
    push_reverse_type(T_MANY);
    Pike_compiler->pike_type_mark_stackp--;
    while (*Pike_compiler->pike_type_mark_stackp+1 <
	   Pike_compiler->type_stackp) {
      push_reverse_type(T_FUNCTION);
    }
  }
#line 5844 "y.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1789 "language.yacc" /* yacc.c:1646  */
    {
   push_type(T_MIXED);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_ZERO);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_MANY);
  }
#line 5860 "y.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1802 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 5866 "y.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1803 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=!(yyvsp[0].number); }
#line 5872 "y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1806 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 5878 "y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1808 "language.yacc" /* yacc.c:1646  */
    {
  }
#line 5885 "y.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1814 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MIXED); }
#line 5891 "y.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1818 "language.yacc" /* yacc.c:1646  */
    { 
  }
#line 5898 "y.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1821 "language.yacc" /* yacc.c:1646  */
    { 
  }
#line 5905 "y.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1824 "language.yacc" /* yacc.c:1646  */
    { 
    push_reverse_type(T_MAPPING);
  }
#line 5913 "y.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1829 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
    push_type(T_MIXED);
    push_type(T_MAPPING);
  }
#line 5923 "y.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1842 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if ((yyvsp[-1].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-1].number)--) push_type(T_ARRAY);
    type=compiler_pop_type();
    define_variable((yyvsp[0].n)->u.sval.u.string, type,
		    Pike_compiler->current_modifiers);
    free_type(type);
    free_node((yyvsp[0].n));
  }
#line 5941 "y.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1855 "language.yacc" /* yacc.c:1646  */
    {}
#line 5947 "y.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1857 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if ((yyvsp[-2].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-2].number)--) push_type(T_ARRAY);
    type=compiler_pop_type();
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared variable has initializer.");
    }
    (yyval.number)=define_variable((yyvsp[-1].n)->u.sval.u.string, type,
			       Pike_compiler->current_modifiers & (~ID_EXTERN));
    free_type(type);
  }
#line 5968 "y.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1874 "language.yacc" /* yacc.c:1646  */
    {
    Pike_compiler->init_node=mknode(F_COMMA_EXPR,Pike_compiler->init_node,
		     mkcastnode(void_type_string,
				mknode(F_ASSIGN,(yyvsp[0].n),
				       mkidentifiernode((yyvsp[-1].number)))));
    free_node((yyvsp[-3].n));
  }
#line 5980 "y.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1882 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
  }
#line 5988 "y.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1886 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file in variable definition.");
    free_node((yyvsp[-2].n));
  }
#line 5997 "y.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1891 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
  }
#line 6005 "y.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1898 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    push_finished_type((yyvsp[-2].n)->u.sval.u.type);
    if ((yyvsp[-1].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-1].number)--) push_type(T_ARRAY);
    id = add_local_name((yyvsp[0].n)->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      (yyval.n)=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 6025 "y.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1913 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6031 "y.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1915 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    push_finished_type((yyvsp[-4].n)->u.sval.u.type);
    if ((yyvsp[-3].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-3].number)--) push_type(T_ARRAY);
    id = add_local_name((yyvsp[-2].n)->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[-2].n));
  }
#line 6054 "y.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1934 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
    (yyval.n)=0;
  }
#line 6063 "y.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1939 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 6073 "y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1945 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file in local variable definition.");
    free_node((yyvsp[-2].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 6084 "y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1954 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    add_ref((yyvsp[-1].n)->u.sval.u.type);
    id = add_local_name((yyvsp[0].n)->u.sval.u.string, (yyvsp[-1].n)->u.sval.u.type, 0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      (yyval.n)=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 6100 "y.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1965 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6106 "y.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1967 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    add_ref((yyvsp[-3].n)->u.sval.u.type);
    id = add_local_name((yyvsp[-2].n)->u.sval.u.string, (yyvsp[-3].n)->u.sval.u.type, 0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n), mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[-2].n));
  }
#line 6125 "y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1981 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 6131 "y.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1985 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 6140 "y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1992 "language.yacc" /* yacc.c:1646  */
    {
    (yyvsp[0].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 6149 "y.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1997 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;

    if((yyval.number) == -1) /* if 'first block' */
      Pike_compiler->compiler_frame->last_block_level=0; /* all variables */
    else
      Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 6163 "y.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2007 "language.yacc" /* yacc.c:1646  */
    {
    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-5].number));
    pop_local_variables((yyvsp[-4].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-2].number);
    if ((yyvsp[-1].n)) COPY_LINE_NUMBER_INFO((yyvsp[-1].n), (yyvsp[-3].n));
    free_node ((yyvsp[-3].n));
    (yyval.n)=(yyvsp[-1].n);
  }
#line 6176 "y.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 2019 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
    yyerror("Unexpected end of file.");
  }
#line 6185 "y.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2026 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6191 "y.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 2027 "language.yacc" /* yacc.c:1646  */
    { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 6197 "y.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 2032 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[(-2) - (0)].n);
  }
#line 6205 "y.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 2040 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n)); }
#line 6211 "y.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2046 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n)); }
#line 6217 "y.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2051 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      optimize_node((yyvsp[0].n));
      Pike_compiler->compiler_pass=tmp;
      type=(yyvsp[0].n)->u.node.a->type;
    }

    if(!is_const((yyvsp[0].n)))
    {
      if(Pike_compiler->compiler_pass==2)
	yyerror("Constant definition is not constant.");
    }else{
      ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
      if(tmp < 1)
      {
	yyerror("Error in constant definition.");
      }else{
	pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	if((yyvsp[0].n)) free_node((yyvsp[0].n));
	(yyvsp[0].n)=mksvaluenode(Pike_sp-1);
	type=(yyvsp[0].n)->type;
	pop_stack();
      }
    }
    if(!type) type = mixed_type_string;
    add_ref(type);
    low_add_local_name(Pike_compiler->compiler_frame, /*->previous,*/
		       (yyvsp[-2].n)->u.sval.u.string,
		       type, (yyvsp[0].n));
    /* Note: Intentionally not marked as used. */
    free_node((yyvsp[-2].n));
  }
#line 6259 "y.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2088 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 6265 "y.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2089 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 6271 "y.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2097 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 6277 "y.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2099 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 6286 "y.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2103 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 6292 "y.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2107 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6298 "y.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2109 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR, (yyvsp[-1].n), mkcastnode(void_type_string, (yyvsp[0].n)));
  }
#line 6306 "y.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2117 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6312 "y.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2120 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6318 "y.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2124 "language.yacc" /* yacc.c:1646  */
    { reset_type_stack(); (yyval.n)=0; yyerrok; }
#line 6324 "y.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2126 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=0;
  }
#line 6335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2133 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
/*    yychar = '}'; */	/* Put the '}' back on the input stream. */
    (yyval.n)=0;
  }
#line 6346 "y.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2139 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6352 "y.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2143 "language.yacc" /* yacc.c:1646  */
    {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 6360 "y.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2157 "language.yacc" /* yacc.c:1646  */
    {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 6368 "y.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2161 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(Pike_compiler->compiler_frame->opt_flags & OPT_CUSTOM_LABELS ?
		F_CUSTOM_STMT_LABEL : F_NORMAL_STMT_LABEL,
		(yyvsp[-3].n), (yyvsp[0].n));

    /* FIXME: This won't be correct if the node happens to be shared.
     * That's an issue to be solved with shared nodes in general,
     * though. */
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
  }
#line 6383 "y.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2174 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = 0;}
#line 6389 "y.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2177 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_BREAK,(yyvsp[0].n),0); }
#line 6395 "y.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2178 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_DEFAULT,0,0); }
#line 6401 "y.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2180 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_DEFAULT,0,0); yyerror("Expected ':' after default.");
  }
#line 6409 "y.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2185 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_CONTINUE,(yyvsp[0].n),0); }
#line 6415 "y.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2188 "language.yacc" /* yacc.c:1646  */
    {
    push_compiler_frame(SCOPE_LOCAL);

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 6425 "y.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2196 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    (yyval.n)=mkstrnode(name = get_new_name(NULL));
    free_string(name);
  }
#line 6435 "y.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2204 "language.yacc" /* yacc.c:1646  */
    {
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);
  }
#line 6447 "y.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2212 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name = (yyvsp[-3].n)->u.sval.u.string;
    struct pike_type *type;
    int e;

    (yyval.number) = Pike_compiler->varargs;
    Pike_compiler->varargs = 0;

    if (Pike_compiler->compiler_pass == 1) {
      /* Define a tentative prototype for the lambda. */
      push_finished_type(mixed_type_string);
      e=(yyvsp[0].number)-1;
      if((yyval.number))
      {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	e--;
	pop_type_stack(T_ARRAY);
      }else{
	push_type(T_VOID);
      }
      Pike_compiler->varargs=0;
      push_type(T_MANY);
      for(; e>=0; e--) {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	push_type(T_FUNCTION);
      }    
      type=compiler_pop_type();
      Pike_compiler->compiler_frame->current_function_number =
	define_function(name, type,
			ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			IDENTIFIER_PIKE_FUNCTION, NULL,
			(unsigned INT16)
			(Pike_compiler->compiler_frame->opt_flags));
      free_type(type);
    } else {
      /* In pass 2 we just reuse the type from pass 1. */
      Pike_compiler->compiler_frame->current_function_number =
	isidentifier(name);
    }
  }
#line 6492 "y.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2253 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int f,e;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-6].n)->current_file;
    c->lex.current_line = (yyvsp[-6].n)->line_number;

    debug_malloc_touch((yyvsp[0].n));
    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type((yyvsp[0].n));
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    e=(yyvsp[-2].number)-1;
    if((yyvsp[-1].number))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    Pike_compiler->varargs=0;
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }
    
    type=compiler_pop_type();

    name = (yyvsp[-5].n)->u.sval.u.string;

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n%d:   type: ",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1,
	    Pike_compiler->compiler_pass);
    simple_describe_type(type);
    fprintf(stderr, "\n");
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		(yyvsp[0].n),
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

#ifdef PIKE_DEBUG
    if (f != Pike_compiler->compiler_frame->current_function_number) {
      Pike_fatal("Lost track of lambda %s.\n", name->str);
    }
#endif /* PIKE_DEBUG */

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d:   lexical_scope: 0x%08x\n",
	    Pike_compiler->compiler_pass,
	    Pike_compiler->compiler_frame->lexical_scope);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f, Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }
    free_type(type);
    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node((yyvsp[-5].n));
    free_node ((yyvsp[-6].n));
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-4].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-4].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 6592 "y.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2349 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n) = mkintnode(0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node((yyvsp[-2].n));
    free_node((yyvsp[-3].n));
  }
#line 6612 "y.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2367 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   (yyvsp[-3].n)->u.sval.u.type);


    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);
    
    e=(yyvsp[0].number)-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
    push_type(T_FUNCTION);
    }
    
    type=compiler_pop_type();
    /***/

    name = get_new_name((yyvsp[-2].n)->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION |
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       (yyvsp[-2].n)->u.sval.u.string, type, n);

    (yyval.number)=id;
    free_string(name);
  }
#line 6692 "y.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2443 "language.yacc" /* yacc.c:1646  */
    {
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-1].number));
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));

    debug_malloc_touch((yyvsp[0].n));
    dooptcode(i->name,
	      (yyvsp[0].n),
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope & 
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
	(yyval.n) = mktrampolinenode((yyvsp[-1].number),Pike_compiler->compiler_frame);
      }else{
	(yyval.n) = mkidentifiernode((yyvsp[-1].number));
      }
    }
  }
#line 6748 "y.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2495 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n)=mkintnode(0);
  }
#line 6765 "y.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2510 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    /***/
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    
    push_finished_type((yyvsp[-4].n)->u.sval.u.type);
    if ((yyvsp[-3].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-3].number)--) push_type(T_ARRAY);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type=compiler_pop_type();

    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);
    
    e=(yyvsp[0].number)-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }
    
    type=compiler_pop_type();
    /***/

    name = get_new_name((yyvsp[-2].n)->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION|
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       (yyvsp[-2].n)->u.sval.u.string, type, n);
    (yyval.number)=id;
    free_string(name);
  }
#line 6850 "y.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2591 "language.yacc" /* yacc.c:1646  */
    {
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-1].number));
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    debug_malloc_touch((yyvsp[0].n));
    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));


    debug_malloc_touch((yyvsp[0].n));
    dooptcode(i->name,
	      (yyvsp[0].n),
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope & 
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
        (yyval.n) = mktrampolinenode((yyvsp[-1].number),Pike_compiler->compiler_frame);
      }else{
        (yyval.n) = mkidentifiernode((yyvsp[-1].number));
      }
    }
  }
#line 6908 "y.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2645 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-2].n));
    (yyval.n)=mkintnode(0);
  }
#line 6926 "y.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2661 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int ref_no;

    if (Pike_compiler->num_create_args < 0) {
      yyerror("Can't define more variables after ...");
    }

    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if ((yyvsp[-2].number) && (Pike_compiler->compiler_pass == 2) && !TEST_COMPAT (0, 6)) {
      yywarning("The *-syntax in types is obsolete. Use array instead.");
    }
    while((yyvsp[-2].number)--) push_type(T_ARRAY);
    if ((yyvsp[-1].number)) {
      push_type(T_ARRAY);
    }
    type=compiler_pop_type();

    /* Add the identifier globally.
     * Note: Since these are the first identifiers (and references)
     *       to be added to the program, they will be numbered in
     *       sequence starting at 0 (zero). This means that the
     *       counter num_create_args is sufficient extra information
     *       to be able to keep track of them.
     */
    ref_no = define_variable((yyvsp[0].n)->u.sval.u.string, type,
			     Pike_compiler->current_modifiers);
    free_type(type);

    if (Pike_compiler->num_create_args != ref_no) {
      my_yyerror("Multiple definitions of create variable %S (%d != %d).",
		 (yyvsp[0].n)->u.sval.u.string,
		 Pike_compiler->num_create_args, ref_no);
    }
    if ((yyvsp[-1].number)) {
      /* Encode varargs marker as negative number of args. */
      Pike_compiler->num_create_args = -(ref_no + 1);
    } else {
      Pike_compiler->num_create_args = ref_no + 1;
    }

    /* free_type(type); */
    free_node((yyvsp[0].n));
    (yyval.number)=0;
  }
#line 6976 "y.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2706 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 6982 "y.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2709 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 1; }
#line 6988 "y.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2710 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 6994 "y.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2712 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected ':' in create argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 7003 "y.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2718 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 7009 "y.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2722 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 7015 "y.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2724 "language.yacc" /* yacc.c:1646  */
    {
    /* NOTE: One more than the number of arguments, so that we
<     *       can detect the case of no parenthesis below. */
    (yyval.number) = (yyvsp[-1].number) + 1;
    free_node((yyvsp[0].n));
  }
#line 7026 "y.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2733 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 7032 "y.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2735 "language.yacc" /* yacc.c:1646  */
    {
		  yyerror("End of file where program definition expected.");
		}
#line 7040 "y.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2742 "language.yacc" /* yacc.c:1646  */
    {
    if(!(yyvsp[0].n))
    {
      struct pike_string *s;
      char buffer[42];
      sprintf(buffer,"__class_%ld_%ld_line_%d",
	      (long)Pike_compiler->new_program->id,
	      (long)Pike_compiler->local_class_counter++,
	      (int) (yyvsp[-1].n)->line_number);
      s=make_shared_string(buffer);
      (yyvsp[0].n)=mkstrnode(s);
      free_string(s);
      (yyvsp[-3].number)|=ID_PROTECTED | ID_PRIVATE | ID_INLINE;
    }
    /* fprintf(stderr, "LANGUAGE.YACC: CLASS start\n"); */
    if(Pike_compiler->compiler_pass==1)
    {
      if ((yyvsp[-3].number) & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, 1, (yyvsp[0].n)->u.sval.u.string,
			    (yyvsp[-3].number),
			    &(yyval.number));

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber((yyvsp[-1].n)->line_number, (yyvsp[-1].n)->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			(yyvsp[-1].n)->current_file->str,
			(yyvsp[-1].n)->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier((yyvsp[0].n)->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, 2, 0,
			      (yyvsp[-3].number),
			      &(yyval.number));
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.offset >= 0) &&
	      ((s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
		constants[id->func.offset].sval)->type == T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, 2,
				  (yyvsp[0].n)->u.sval.u.string,
				  (yyvsp[-3].number),
				  &(yyval.number));

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, 2, 0,
				  (yyvsp[-3].number),
				  &(yyval.number));
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, 2, 0,
				(yyvsp[-3].number),
				&(yyval.number));
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
#line 7121 "y.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2818 "language.yacc" /* yacc.c:1646  */
    {
    /* Clear scoped modifiers. */
    (yyval.number) = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
#line 7131 "y.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2824 "language.yacc" /* yacc.c:1646  */
    {
    struct program *p;

    /* Check if we have create arguments but no locally defined create(). */
    if ((yyvsp[-1].number)) {
      struct pike_string *create_string = NULL;
      struct reference *ref = NULL;
      struct identifier *id = NULL;
      int ref_id;
      MAKE_CONST_STRING(create_string, "create");
      if (((ref_id = isidentifier(create_string)) < 0) ||
	  (ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id))->inherit_offset ||
	  ((id = ID_FROM_PTR(Pike_compiler->new_program, ref))->func.offset == -1)) {
	int e;
	struct pike_type *type = NULL;
	int nargs = Pike_compiler->num_create_args;

	push_compiler_frame(SCOPE_LOCAL);
	
	/* Init: Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}

	/* First: Deduce the type for the create() function. */
	push_type(T_VOID); /* Return type. */

	if ((e = nargs) < 0) {
	  /* Varargs */
	  e = nargs = -nargs;
	  push_finished_type(Pike_compiler->compiler_frame->variable[--e].type);
	  pop_type_stack(T_ARRAY); /* Pop one level of array. */
	} else {
	  /* Not varargs. */
	  push_type(T_VOID);
	}
	push_type(T_MANY);
	while(e--) {
	  push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	  push_type(T_FUNCTION);
	}

	type = compiler_pop_type();

	/* Second: Declare the function. */

	Pike_compiler->compiler_frame->current_function_number=
	  define_function(create_string, type,
			  ID_INLINE | ID_PROTECTED,
			  IDENTIFIER_PIKE_FUNCTION |
			  (Pike_compiler->num_create_args < 0?IDENTIFIER_VARARGS:0),
			  0,
			  OPT_SIDE_EFFECT);
	
	if (Pike_compiler->compiler_pass == 2) {
	  node *create_code = NULL;
	  int f;

	  /* Third: Generate the initialization code.
	   *
	   * global_arg = [type]local_arg;
	   * [,..]
	   */

	  for(e=0; e<nargs; e++)
	  {
	    if(!Pike_compiler->compiler_frame->variable[e].name ||
	       !Pike_compiler->compiler_frame->variable[e].name->len)
	    {
	      my_yyerror("Missing name for argument %d.",e);
	    } else {
	      node *local_node = mklocalnode(e, 0);

	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_pass == 2) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		/* The following is needed to go around the optimization in
		 * mksoftcastnode().
		 */
		free_type(local_node->type);
		copy_pike_type(local_node->type, mixed_type_string);
	  
		local_node = mksoftcastnode(Pike_compiler->compiler_frame->
					    variable[e].type, local_node);
	      }
	      create_code =
		mknode(F_COMMA_EXPR, create_code,
		       mknode(F_ASSIGN, local_node,
			      mkidentifiernode(e)));
	    }
	  }

	  /* Fourth: Add a return 0; at the end. */

	  create_code = mknode(F_COMMA_EXPR,
			       mknode(F_POP_VALUE, create_code, NULL),
			       mknode(F_RETURN, mkintnode(0), NULL));

	  /* Fifth: Define the function. */

	  f=dooptcode(create_string, create_code, type, ID_PROTECTED);

#ifdef PIKE_DEBUG
	  if(Pike_interpreter.recoveries &&
	     Pike_sp-Pike_interpreter.evaluator_stack < Pike_interpreter.recoveries->stack_pointer)
	    Pike_fatal("Stack error (underflow)\n");

	  if(Pike_compiler->compiler_pass == 1 &&
	     f!=Pike_compiler->compiler_frame->current_function_number)
	    Pike_fatal("define_function screwed up! %d != %d\n",
		       f, Pike_compiler->compiler_frame->current_function_number);
#endif
	}

	/* Done. */

	free_type(type);
	pop_compiler_frame();
      }
    }

    if(Pike_compiler->compiler_pass == 1)
      p=end_first_pass(0);
    else
      p=end_first_pass(1);

    /* fprintf(stderr, "LANGUAGE.YACC: CLASS end\n"); */

    if(p) {
      /* Update the type for the program constant,
       * since we might have a lfun::create(). */
      struct identifier *i;
      struct svalue sv;
      sv.type = T_PROGRAM;
      sv.subtype = 0;
      sv.u.program = p;
      i = ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-3].number));
      free_type(i->type);
      i->type = get_type_of_svalue(&sv);
      free_program(p);
    } else if (!Pike_compiler->num_parse_error) {
      /* Make sure code in this class is aware that something went wrong. */
      Pike_compiler->num_parse_error = 1;
    }

    (yyval.n)=mkidentifiernode((yyvsp[-3].number));

    free_node((yyvsp[-5].n));
    free_node((yyvsp[-4].n));
    check_tree((yyval.n),0);
    THIS_COMPILATION->lex.pragmas = (yyvsp[-2].number);
  }
#line 7308 "y.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2999 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 7314 "y.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 3002 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 7320 "y.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 3003 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 7326 "y.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 3009 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].n)) {
      if ((yyvsp[0].n)) {
	/* Explicit enum value. */

	/* This can be made more lenient in the future */

	/* Ugly hack to make sure that $2 is optimized */
	{
	  int tmp=Pike_compiler->compiler_pass;
	  (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
	  Pike_compiler->compiler_pass=tmp;
	}

	if(!is_const((yyvsp[0].n)))
	{
	  if(Pike_compiler->compiler_pass==2)
	    yyerror("Enum definition is not constant.");
	  push_int(0);
	} else {
	  if(!Pike_compiler->num_parse_error)
	  {
	    ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	    if(tmp < 1)
	    {
	      yyerror("Error in enum definition.");
	      push_int(0);
	    }else{
	      pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	    }
	  } else {
	    push_int(0);
	  }
	}
	free_node((yyvsp[0].n));
	free_node((yyvsp[-2].n));
	(yyvsp[-2].n) = mkconstantsvaluenode(Pike_sp-1);
      } else {
	/* Implicit enum value. */
	(yyvsp[-2].n) = safe_inc_enum((yyvsp[-2].n));
	push_svalue(&(yyvsp[-2].n)->u.sval);
      }
      add_constant((yyvsp[-1].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      /* Update the type. */
      {
	struct pike_type *current = pop_unfinished_type();
	struct pike_type *new = get_type_of_svalue(Pike_sp-1);
	struct pike_type *res = or_pike_types(new, current, 1);
	free_type(current);
	free_type(new);
	type_stack_mark();
	push_finished_type(res);
	free_type(res);
      }
      pop_stack();
      free_node((yyvsp[-1].n));
    } else if ((yyvsp[0].n)) {
      free_node((yyvsp[0].n));
    }
  }
#line 7392 "y.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 3074 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[(-2) - (0)].n);
  }
#line 7400 "y.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 3081 "language.yacc" /* yacc.c:1646  */
    { (yyvsp[-4].n) = (yyvsp[-1].n); }
#line 7406 "y.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 3087 "language.yacc" /* yacc.c:1646  */
    {
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared enum.");
    }

    type_stack_mark();
    push_type(T_ZERO);	/* Joined type so far. */
  }
#line 7420 "y.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 3097 "language.yacc" /* yacc.c:1646  */
    {
    push_int(-1);	/* Previous value. */
    (yyval.n) = mkconstantsvaluenode(Pike_sp-1);
    pop_stack();
  }
#line 7430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 3103 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t = pop_unfinished_type();
    free_node((yyvsp[-2].n));
    if ((yyvsp[-4].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-4].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-4].n));
    }
    (yyval.n) = mktypenode(t);
    free_type(t);
  }
#line 7448 "y.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 3119 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t = compiler_pop_type();

    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared typedef.");
    }

    if ((yyvsp[-1].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-1].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-1].n));
    }
    free_type(t);
  }
#line 7470 "y.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 3139 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7478 "y.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 3143 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7488 "y.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 3149 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode('?', (yyvsp[-3].n),
		mknode(':',
		       mkcastnode(void_type_string, (yyvsp[-1].n)),
		       mkcastnode(void_type_string, (yyvsp[0].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    (yyval.n) = mkcastnode(void_type_string, (yyval.n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    pop_local_variables((yyvsp[-7].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-5].number);
  }
#line 7505 "y.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 3164 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ')'."); }
#line 7511 "y.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 3166 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 7520 "y.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 3172 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7526 "y.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 3173 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7532 "y.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 3177 "language.yacc" /* yacc.c:1646  */
    {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) && (yyvsp[0].n)) {
      if ((yyvsp[0].n)->token == F_ARRAY_LVALUE) {
	mark_lvalues_as_used(CAR((yyvsp[0].n)));
      } else if (((yyvsp[0].n)->token == F_LOCAL) && !((yyvsp[0].n)->u.integer.b)) {
	Pike_compiler->compiler_frame->variable[(yyvsp[0].n)->u.integer.a].flags |=
	  LOCAL_VAR_IS_USED;
      }
    }
  }
#line 7547 "y.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 3187 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7553 "y.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 3191 "language.yacc" /* yacc.c:1646  */
    { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 7559 "y.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 3192 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7565 "y.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 3196 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 3200 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7577 "y.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3202 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(':',(yyvsp[-2].n),(yyvsp[0].n)); }
#line 7583 "y.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3206 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7591 "y.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3210 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7601 "y.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 3216 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) {
      (yyval.n)=mknode(F_FOREACH,
		mknode(F_VAL_LVAL,(yyvsp[-3].n),(yyvsp[-2].n)),
		(yyvsp[0].n));
    } else {
      /* Error in lvalue */
      (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n));
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    pop_local_variables((yyvsp[-7].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-5].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7621 "y.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3235 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_DO,(yyvsp[-5].n),(yyvsp[-2].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7632 "y.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3242 "language.yacc" /* yacc.c:1646  */
    {
    free_node ((yyvsp[-3].n));
    (yyval.n)=0;
    yyerror("Missing '(' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 7643 "y.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3249 "language.yacc" /* yacc.c:1646  */
    {
    free_node ((yyvsp[-2].n));
    (yyval.n)=0;
    yyerror("Missing 'while' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 7654 "y.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3259 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 7663 "y.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3266 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7671 "y.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3270 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7681 "y.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3277 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-6].n)),
	      mknode(F_FOR,(yyvsp[-4].n),mknode(':',(yyvsp[0].n),(yyvsp[-2].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-9].n));
    free_node ((yyvsp[-9].n));
    pop_local_variables((yyvsp[-10].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-8].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7695 "y.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3290 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7703 "y.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3294 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7713 "y.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3300 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_FOR,(yyvsp[-2].n),mknode(':',(yyvsp[0].n),NULL));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    free_node ((yyvsp[-5].n));
    pop_local_variables((yyvsp[-6].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-4].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7726 "y.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3310 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkintnode(1); }
#line 7732 "y.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3315 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7740 "y.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3319 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7750 "y.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3325 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_SWITCH,(yyvsp[-2].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    free_node ((yyvsp[-5].n));
    pop_local_variables((yyvsp[-6].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-4].number);
  }
#line 7762 "y.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3335 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_CASE,(yyvsp[-1].n),0);
  }
#line 7770 "y.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3339 "language.yacc" /* yacc.c:1646  */
    {
     (yyval.n)=mknode(F_CASE_RANGE,(yyvsp[-3].n),(yyvsp[-1].n));
  }
#line 7778 "y.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3343 "language.yacc" /* yacc.c:1646  */
    {
     (yyval.n)=mknode(F_CASE_RANGE,0,(yyvsp[-1].n));
  }
#line 7786 "y.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3350 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
  }
#line 7794 "y.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3354 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
  }
#line 7802 "y.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3358 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
    yyerror("Unexpected end of file.");
  }
#line 7811 "y.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3365 "language.yacc" /* yacc.c:1646  */
    {
    if(!TEST_COMPAT(0,6) &&
       !match_types(Pike_compiler->compiler_frame->current_return_type,
		    void_type_string))
    {
      yytype_error("Must return a value for a non-void function.",
		   Pike_compiler->compiler_frame->current_return_type,
		   void_type_string, 0);
    }
    (yyval.n)=mknode(F_RETURN,mkintnode(0),0);
  }
#line 7827 "y.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3377 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_RETURN,(yyvsp[-1].n),0);
  }
#line 7835 "y.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3382 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7841 "y.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3383 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n));  }
#line 7847 "y.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3386 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n));  }
#line 7853 "y.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3388 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7859 "y.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3393 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7865 "y.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3397 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7871 "y.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3398 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7877 "y.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3399 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7883 "y.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3400 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7889 "y.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3406 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-2].n)), (yyvsp[0].n)); 
  }
#line 7897 "y.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3412 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_PUSH_ARRAY,(yyvsp[0].n),0); }
#line 7903 "y.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3415 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),(yyvsp[-2].n)); }
#line 7909 "y.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3416 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); reset_type_stack(); yyerrok; }
#line 7915 "y.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3417 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7921 "y.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3419 "language.yacc" /* yacc.c:1646  */
    {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-3].n));
    }
    (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),mknode(F_ARRAY_LVALUE,(yyvsp[-3].n),0));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 7934 "y.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3427 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode((yyvsp[-1].number),(yyvsp[-2].n),(yyvsp[0].n)); }
#line 7940 "y.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3428 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); reset_type_stack(); yyerrok; }
#line 7946 "y.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3429 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7952 "y.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3431 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode((yyvsp[-1].number),mknode(F_ARRAY_LVALUE,(yyvsp[-3].n),0),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 7962 "y.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3437 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.n)=(yyvsp[-2].n); free_node ((yyvsp[-3].n)); reset_type_stack(); yyerrok;
    }
#line 7970 "y.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3444 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode('?',(yyvsp[-4].n),mknode(':',(yyvsp[-2].n),(yyvsp[0].n))); }
#line 7976 "y.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3447 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_AND_EQ; }
#line 7982 "y.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3448 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_OR_EQ; }
#line 7988 "y.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3449 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_XOR_EQ; }
#line 7994 "y.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3450 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_LSH_EQ; }
#line 8000 "y.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3451 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_RSH_EQ; }
#line 8006 "y.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3452 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_ADD_EQ; }
#line 8012 "y.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3453 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_SUB_EQ; }
#line 8018 "y.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3454 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_MULT_EQ; }
#line 8024 "y.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3455 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_MOD_EQ; }
#line 8030 "y.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3456 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_DIV_EQ; }
#line 8036 "y.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3459 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 8042 "y.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3459 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 8048 "y.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3461 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 8054 "y.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3467 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8060 "y.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3470 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 8066 "y.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3476 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) {
      (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
    } else {
      /* Error in assoc_pair */
      (yyval.n)=(yyvsp[-2].n);
    }
  }
#line 8079 "y.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3488 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
  }
#line 8087 "y.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3491 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[-2].n)); (yyval.n)=0; }
#line 8093 "y.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3495 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_LOR,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8099 "y.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3496 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_LAND,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8105 "y.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3497 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`|",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8111 "y.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3498 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`^",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8117 "y.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3499 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`&",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8123 "y.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3500 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`==",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8129 "y.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3501 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`!=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8135 "y.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3502 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8141 "y.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3503 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8147 "y.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3504 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3505 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8159 "y.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3506 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<<",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8165 "y.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3507 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>>",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8171 "y.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3508 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`+",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8177 "y.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3509 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`-",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8183 "y.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3510 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`*",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8189 "y.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3511 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`%",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8195 "y.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3512 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`/",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8201 "y.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3535 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 8210 "y.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3540 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mksoftcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 8219 "y.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3544 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_INC,(yyvsp[0].n),0); }
#line 8225 "y.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3545 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_DEC,(yyvsp[0].n),0); }
#line 8231 "y.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3546 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`!",(yyvsp[0].n),0); }
#line 8237 "y.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3547 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`~",(yyvsp[0].n),0); }
#line 8243 "y.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3548 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`-",(yyvsp[0].n),0); }
#line 8249 "y.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3552 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_POST_INC,(yyvsp[-1].n),0); }
#line 8255 "y.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3553 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_POST_DEC,(yyvsp[-1].n),0); }
#line 8261 "y.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3575 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 8267 "y.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3579 "language.yacc" /* yacc.c:1646  */
    {
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);

    /* block code */
    (yyvsp[-2].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 8283 "y.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3591 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int f/*, e */;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    /* block code */
    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-5].number));
    pop_local_variables((yyvsp[-2].number));

    debug_malloc_touch((yyvsp[-1].n));
    (yyvsp[-1].n)=mknode(F_COMMA_EXPR,(yyvsp[-1].n),mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type((yyvsp[-1].n));
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for implicit lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }
    
    push_type(T_VOID);
    push_type(T_MANY);
/*
    e=$5-1;
    for(; e>=0; e--)
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
*/
    
    type=compiler_pop_type();

    name = get_new_name(NULL);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: IMPLICIT LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */
    
    f=dooptcode(name,
		(yyvsp[-1].n),
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f,Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node ((yyvsp[-4].n));
    free_string(name);
    free_type(type);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 8365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3672 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkapplynode((yyvsp[-4].n), mknode(F_ARG_LIST, (yyvsp[-2].n), (yyvsp[0].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node ((yyvsp[-3].n));
  }
#line 8375 "y.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3678 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mkapplynode((yyvsp[-4].n), (yyvsp[0].n));
    free_node ((yyvsp[-3].n));
    yyerrok;
  }
#line 8385 "y.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3684 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8396 "y.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3691 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8406 "y.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3697 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8416 "y.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3705 "language.yacc" /* yacc.c:1646  */
    {
    if (TEST_COMPAT(7, 6)) {
      (yyval.number) = Pike_compiler->current_modifiers =
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    } else {
      (yyval.number) = Pike_compiler->current_modifiers = ID_PROTECTED|ID_INLINE|ID_PRIVATE |
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    }
  }
#line 8430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3718 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkfloatnode((FLOAT_TYPE)(yyvsp[0].fnum)); }
#line 8436 "y.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3724 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 8442 "y.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3725 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 8448 "y.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3729 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_AUTO_MAP_MARKER, (yyvsp[-3].n), 0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 8458 "y.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3735 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_INDEX,(yyvsp[-3].n),(yyvsp[-1].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 8468 "y.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3742 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_RANGE,(yyvsp[-5].n),mknode(':',(yyvsp[-3].n),(yyvsp[-1].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 8478 "y.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3748 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-3].n);
    free_node ((yyvsp[-2].n));
    yyerrok;
  }
#line 8488 "y.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3754 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'.");
    yyerror("Unexpected end of file.");
    free_node ((yyvsp[-2].n));
  }
#line 8498 "y.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3760 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8504 "y.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3762 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8510 "y.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3764 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8516 "y.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3766 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.n)=(yyvsp[-1].n);
      if ((yyval.n)) {
	COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      }
      free_node ((yyvsp[-2].n));
    }
#line 8528 "y.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3774 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
    }
#line 8539 "y.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3783 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_mapping",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
      free_node ((yyvsp[-3].n));
    }
#line 8551 "y.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3791 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8562 "y.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3798 "language.yacc" /* yacc.c:1646  */
    {
      yyerror("Missing '>'.");
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8573 "y.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3804 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 8579 "y.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3806 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 8588 "y.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3810 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 8594 "y.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3811 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 8600 "y.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3812 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 8606 "y.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3813 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '>'.");
    (yyval.n)=(yyvsp[-2].n); yyerrok;
  }
#line 8615 "y.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3818 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'.");
    yyerror("Unexpected end of file.");
  }
#line 8624 "y.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3822 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8630 "y.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3823 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8636 "y.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3825 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARROW,(yyvsp[-3].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-1].n));
  }
#line 8646 "y.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3830 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); free_node ((yyvsp[-1].n));}
#line 8652 "y.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3835 "language.yacc" /* yacc.c:1646  */
    {
    int i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if (((i = find_shared_string_identifier(Pike_compiler->last_identifier,
					    Pike_compiler->new_program)) >= 0) ||
	((i = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						       Pike_compiler->new_program,
						       SEE_PROTECTED|
						       SEE_PRIVATE)) >= 0)) {
      struct reference *ref = Pike_compiler->new_program->identifier_references + i;
      if (!TEST_COMPAT (7, 2) &&
	  IDENTIFIER_IS_VARIABLE (
	    ID_FROM_PTR (Pike_compiler->new_program, ref)->identifier_flags)) {
	/* Allowing local:: on variables would lead to pathological
	 * behavior: If a non-local variable in a class is referenced
	 * both with and without local::, both references would
	 * address the same variable in all cases except where an
	 * inheriting program overrides it (c.f. [bug 1252]).
	 *
	 * Furthermore, that's not how it works currently; if this
	 * error is removed then local:: will do nothing on variables
	 * except forcing a lookup in the closest surrounding class
	 * scope. */
	yyerror ("Cannot make local references to variables.");
	(yyval.n) = 0;
      }
      else {
	if (!(ref->id_flags & ID_HIDDEN)) {
	  /* We need to generate a new reference. */
	  int d;
	  struct reference funp = *ref;
	  funp.id_flags = (funp.id_flags & ~ID_INHERITED) | ID_INLINE|ID_HIDDEN;
	  i = -1;
	  for(d = 0; d < (int)Pike_compiler->new_program->num_identifier_references; d++) {
	    struct reference *refp;
	    refp = Pike_compiler->new_program->identifier_references + d;

	    if((refp->inherit_offset == funp.inherit_offset) &&
	       (refp->identifier_offset == funp.identifier_offset) &&
	       ((refp->id_flags | ID_USED) == (funp.id_flags | ID_USED))) {
	      i = d;
	      break;
	    }
	  }
	  if (i < 0) {
	    add_to_identifier_references(funp);
	    i = Pike_compiler->new_program->num_identifier_references - 1;
	  }
	}
	(yyval.n) = mkidentifiernode(i);
      }
    } else {
      if (Pike_compiler->compiler_pass == 2) {
	my_yyerror("%S not defined in local scope.",
		   Pike_compiler->last_identifier);
	(yyval.n) = 0;
      } else {
	(yyval.n) = mknode(F_UNDEFINED, 0, 0);
      }
    }

    free_node((yyvsp[0].n));
  }
#line 8723 "y.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3902 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 8731 "y.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3909 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=index_node((yyvsp[-2].n), Pike_compiler->last_identifier?Pike_compiler->last_identifier->str:NULL,
		  (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 8744 "y.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3918 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *dot;
    MAKE_CONST_STRING(dot, ".");
    if (call_handle_import(dot)) {
      node *tmp=mkconstantsvaluenode(Pike_sp-1);
      pop_stack();
      (yyval.n)=index_node(tmp, ".", (yyvsp[0].n)->u.sval.u.string);
      free_node(tmp);
    }
    else
      (yyval.n)=mknewintnode(0);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 8764 "y.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3934 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = resolve_identifier ((yyvsp[0].n)->u.sval.u.string);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node ((yyvsp[0].n));
  }
#line 8775 "y.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3940 "language.yacc" /* yacc.c:1646  */
    {}
#line 8781 "y.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3941 "language.yacc" /* yacc.c:1646  */
    {}
#line 8787 "y.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3945 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    int e = -1;

    inherit_state = Pike_compiler;

    for (inherit_depth = 0;; inherit_depth++, inherit_state = inherit_state->previous) {
      int inh = find_inherit(inherit_state->new_program, (yyvsp[-1].n)->u.sval.u.string);
      if (inh) {
	e = inh;
	break;
      }
      if (inherit_depth == c->compilation_depth) break;
      if (!TEST_COMPAT (7, 2) &&
	  ID_FROM_INT (inherit_state->previous->new_program,
		       inherit_state->parent_identifier)->name ==
	  (yyvsp[-1].n)->u.sval.u.string) {
	e = 0;
	break;
      }
    }
    if (e == -1) {
      if (TEST_COMPAT (7, 2))
	my_yyerror("No such inherit %S.", (yyvsp[-1].n)->u.sval.u.string);
      else {
	if ((yyvsp[-1].n)->u.sval.u.string == this_program_string) {
	  inherit_state = Pike_compiler;
	  inherit_depth = 0;
	  e = 0;
	}
	else
	  my_yyerror("No inherit or surrounding class %S.",
		     (yyvsp[-1].n)->u.sval.u.string);
      }
    }
    free_node((yyvsp[-1].n));
    (yyval.number) = e;
  }
#line 8830 "y.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3984 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    inherit_state = Pike_compiler;
    for (inherit_depth = 0; inherit_depth < c->compilation_depth;
	 inherit_depth++, inherit_state = inherit_state->previous) {}
    (yyval.number) = -1;
  }
#line 8842 "y.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3992 "language.yacc" /* yacc.c:1646  */
    {
    int e = 0;
    if ((yyvsp[-2].number) < 0) {
      (yyvsp[-2].number) = 0;
    }
#if 0
    /* FIXME: The inherit modifiers aren't kept. */
    if (!(inherit_state->new_program->inherits[(yyvsp[-2].number)].flags & ID_PRIVATE)) {
#endif /* 0 */
      e = find_inherit(inherit_state->new_program->inherits[(yyvsp[-2].number)].prog,
		       (yyvsp[-1].n)->u.sval.u.string);
#if 0
    }
#endif /* 0 */
    if (!e) {
      if (inherit_state->new_program->inherits[(yyvsp[-2].number)].name) {
	my_yyerror("No such inherit %S::%S.",
		   inherit_state->new_program->inherits[(yyvsp[-2].number)].name,
		   (yyvsp[-1].n)->u.sval.u.string);
      } else {
	my_yyerror("No such inherit %S.", (yyvsp[-1].n)->u.sval.u.string);
      }
      (yyval.number) = -1;
    } else {
      /* We know stuff about the inherit structure... */
      (yyval.number) = e + (yyvsp[-2].number);
    }
    free_node((yyvsp[-1].n));
  }
#line 8876 "y.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4021 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = -1; }
#line 8882 "y.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4025 "language.yacc" /* yacc.c:1646  */
    {
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if(((yyval.n)=lexical_islocal(Pike_compiler->last_identifier)))
    {
      /* done, nothing to do here */
    }else if(!((yyval.n)=find_module_identifier(Pike_compiler->last_identifier,1)) &&
	     !((yyval.n) = program_magic_identifier (Pike_compiler, 0, -1,
					      Pike_compiler->last_identifier, 0))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %S.",
		   Pike_compiler->last_identifier);
	/* FIXME: Add this identifier as a constant in the current program to
	 *        avoid multiple reporting of the same identifier.
	 * NOTE: This should then only be done in the second pass.
	 */	
	(yyval.n)=0;
      }else{
	(yyval.n)=mknode(F_UNDEFINED,0,0);
      }
    }
    free_node((yyvsp[0].n));
  }
#line 8912 "y.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4051 "language.yacc" /* yacc.c:1646  */
    {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
    (yyval.n) = 0;
  }
#line 8924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4059 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    node *tmp2;

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    tmp2 = mkconstantsvaluenode(&c->default_module);
    (yyval.n) = index_node(tmp2, "predef", (yyvsp[0].n)->u.sval.u.string);
    if(!(yyval.n)->name)
      add_ref( (yyval.n)->name=(yyvsp[0].n)->u.sval.u.string );
    free_node(tmp2);
    free_node((yyvsp[0].n));
  }
#line 8944 "y.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4075 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 8952 "y.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4079 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    int old_major = Pike_compiler->compat_major;
    int old_minor = Pike_compiler->compat_minor;
    struct svalue *efun = NULL;

    change_compiler_compatibility((yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b);

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    /* Check predef:: first, and then the modules. */

    (yyval.n) = 0;

    if (c->default_module.type == T_MAPPING) {
      if ((efun = low_mapping_lookup(c->default_module.u.mapping,
				     &((yyvsp[0].n)->u.sval))))
	(yyval.n) = mkconstantsvaluenode(efun);
    }

    else if (c->default_module.type != T_INT) {
      JMP_BUF tmp;
      if (SETJMP (tmp))
	handle_compile_exception ("Couldn't index %d.%d "
				  "default module with %O.",
				  (yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b,
				  &(yyvsp[0].n)->u.sval);
      else {
	push_svalue (&c->default_module);
	push_svalue (&(yyvsp[0].n)->u.sval);
	f_index (2);
	if (!IS_UNDEFINED (Pike_sp - 1))
	  (yyval.n) = mkconstantsvaluenode (Pike_sp - 1);
	pop_stack();
      }
      UNSETJMP(tmp);
    }

    if (!(yyval.n) && !((yyval.n) = resolve_identifier(Pike_compiler->last_identifier))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %d.%d::%S.",
		   (yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b,
		   Pike_compiler->last_identifier);
	(yyval.n)=0;
      }else{
	(yyval.n)=mknode(F_UNDEFINED,0,0);
      }
    }

    change_compiler_compatibility(old_major, old_minor);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
  }
#line 9013 "y.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4136 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
    (yyval.n)=0;
  }
#line 9022 "y.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4141 "language.yacc" /* yacc.c:1646  */
    {
    int id;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if ((yyvsp[-1].number) > 0)
      id = low_reference_inherited_identifier(inherit_state,
					      (yyvsp[-1].number),
					      Pike_compiler->last_identifier,
					      SEE_PROTECTED);
    else
      id = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						    inherit_state->new_program,
						    SEE_PROTECTED|SEE_PRIVATE);

    if (id != -1) {
      if (inherit_depth > 0) {
	(yyval.n) = mkexternalnode(inherit_state->new_program, id);
      } else {
	(yyval.n) = mkidentifiernode(id);
      }
    } else if (((yyval.n) = program_magic_identifier (inherit_state, inherit_depth, (yyvsp[-1].number),
					       Pike_compiler->last_identifier, 1))) {
      /* All done. */
    }
    else {
      if ((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	  (Pike_compiler->compiler_pass == 2)) {
	if (((yyvsp[-1].number) >= 0) && inherit_state->new_program->inherits[(yyvsp[-1].number)].name) {
	  my_yyerror("Undefined identifier %S::%S.",
		     inherit_state->new_program->inherits[(yyvsp[-1].number)].name,
		     Pike_compiler->last_identifier);
	} else {
	  my_yyerror("Undefined identifier %S.",
		     Pike_compiler->last_identifier);
	}
	(yyval.n)=0;
      }
      else
	(yyval.n)=mknode(F_UNDEFINED,0,0);
    }

    free_node((yyvsp[0].n));
  }
#line 9072 "y.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4186 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 9078 "y.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4187 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 9084 "y.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4189 "language.yacc" /* yacc.c:1646  */
    {
    int e,i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    (yyval.n)=0;
    for(e=1;e<(int)Pike_compiler->new_program->num_inherits;e++)
    {
      if(Pike_compiler->new_program->inherits[e].inherit_level!=1) continue;
      i=low_reference_inherited_identifier(0,e,(yyvsp[0].n)->u.sval.u.string,SEE_PROTECTED);
      if(i==-1) continue;
      if((yyval.n))
      {
	(yyval.n)=mknode(F_ARG_LIST,(yyval.n),mkidentifiernode(i));
      }else{
	(yyval.n)=mkidentifiernode(i);
      }
    }
    if(!(yyval.n))
    {
      if (!((yyval.n) = program_magic_identifier (Pike_compiler, 0, -1,
					   (yyvsp[0].n)->u.sval.u.string, 1)))
      {
	if (Pike_compiler->compiler_pass == 2) {
	  if (TEST_COMPAT(7,2)) {
	    yywarning("Undefined identifier ::%S.", (yyvsp[0].n)->u.sval.u.string);
	  } else {
	    my_yyerror("Undefined identifier ::%S.", (yyvsp[0].n)->u.sval.u.string);
	  }
	}
	(yyval.n)=mkintnode(0);
      }
    }else{
      if((yyval.n)->token==F_ARG_LIST) (yyval.n)=mkefuncallnode("aggregate",(yyval.n));
    }
    free_node((yyvsp[0].n));
  }
#line 9127 "y.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4228 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 9135 "y.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4235 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);}
#line 9141 "y.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4237 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_FROM_BEG, (yyvsp[0].n), NULL);}
#line 9147 "y.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4239 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_FROM_END, (yyvsp[0].n), NULL);}
#line 9153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4241 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 9162 "y.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4246 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 9171 "y.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4253 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mkopernode("`/",
		  mkopernode("`-",
			     mkopernode("`-",
					mkefuncallnode("gethrvtime",
						       mkintnode(1)),
					mknode(F_COMMA_EXPR,
					       mknode(F_POP_VALUE, (yyvsp[0].n), NULL),
					       mkefuncallnode("gethrvtime",
							      mkintnode(1)))),
			     NULL),
		  mkfloatnode((FLOAT_TYPE)1e9));
  }
#line 9189 "y.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4268 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t;
    node *tmp;

    /* FIXME: Why build the node at all? */
    /* Because the optimizer cannot optimize the root node of the
     * tree properly -Hubbe
     */
    tmp=mknode(F_COMMA_EXPR, (yyvsp[-1].n), 0);
    optimize_node(tmp);

    t=(tmp && CAR(tmp) && CAR(tmp)->type ? CAR(tmp)->type : mixed_type_string);
    if(TEST_COMPAT(7,0))
    {
      struct pike_string *s=describe_type(t);
      (yyval.n) = mkstrnode(s);
      free_string(s);
    }else{
      (yyval.n) = mktypenode(t);
    }
    free_node(tmp);
  }
#line 9216 "y.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4290 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9222 "y.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4291 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9228 "y.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4293 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9237 "y.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4297 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9243 "y.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4300 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-1].n); }
#line 9249 "y.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4301 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9255 "y.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4303 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9264 "y.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4307 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9270 "y.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4308 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9276 "y.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4310 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Bad expression for catch."); }
#line 9282 "y.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4314 "language.yacc" /* yacc.c:1646  */
    {
       Pike_compiler->catch_level++;
     }
#line 9290 "y.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4318 "language.yacc" /* yacc.c:1646  */
    {
       (yyval.n)=mknode(F_CATCH,(yyvsp[0].n),NULL);
       Pike_compiler->catch_level--;
     }
#line 9299 "y.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4325 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].n) && !(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-1].n));
    }
    (yyval.n)=mknode(F_SSCANF,mknode(':', mkintnode(TEST_COMPAT(7, 6)? SSCANF_FLAG_76_COMPAT : 0), mknode(F_ARG_LIST,(yyvsp[-4].n),(yyvsp[-2].n))),(yyvsp[-1].n));
  }
#line 9310 "y.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4332 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 9321 "y.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4339 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9333 "y.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4347 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9344 "y.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4354 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9355 "y.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4361 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 9365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4367 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4374 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9386 "y.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4380 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9396 "y.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4385 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9402 "y.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4387 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9411 "y.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4391 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9417 "y.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4392 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9423 "y.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4397 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARRAY_LVALUE, (yyvsp[-1].n),0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node((yyvsp[-2].n));
  }
#line 9433 "y.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4403 "language.yacc" /* yacc.c:1646  */
    {
    int id = add_local_name((yyvsp[0].n)->u.sval.u.string,compiler_pop_type(),0);
    /* Note: Variable intentionally not marked as used. */
    if (id >= 0)
      (yyval.n)=mklocalnode(id,-1);
    else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 9447 "y.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4414 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknewintnode(0); }
#line 9453 "y.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4418 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 9461 "y.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4423 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 9467 "y.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4425 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 9475 "y.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4432 "language.yacc" /* yacc.c:1646  */
    {
    struct compiler_frame *f = Pike_compiler->compiler_frame;
    if (!f || (f->current_function_number < 0)) {
      (yyval.n) = mkstrnode(lfun_strings[LFUN___INIT]);
    } else {
      struct identifier *id =
	ID_FROM_INT(Pike_compiler->new_program, f->current_function_number);
      if (!id->name->size_shift) {
	int len;
	if ((len = strlen(id->name->str)) == id->name->len) {
	  /* Most common case. */
	  (yyval.n) = mkstrnode(id->name);
	} else {
	  struct pike_string *str =
	    make_shared_binary_string(id->name->str, len);
	  (yyval.n) = mkstrnode(str);
	  free_string(str);
	}
      } else {
	struct pike_string *str;
	struct array *split;
	MAKE_CONST_STRING(str, "\0");
	split = explode(id->name, str);
	(yyval.n) = mkstrnode(split->item->u.string);
	free_array(split);
      }
    }
  }
#line 9508 "y.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4464 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-1].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 9523 "y.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4483 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("array"); }
#line 9529 "y.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4485 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__attribute__"); }
#line 9535 "y.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4487 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("class"); }
#line 9541 "y.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4489 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__deprecated__"); }
#line 9547 "y.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4491 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("enum"); }
#line 9553 "y.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4493 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("float");}
#line 9559 "y.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4495 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("function");}
#line 9565 "y.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4497 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__FUNCTION__");}
#line 9571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4499 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("int"); }
#line 9577 "y.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4501 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("mapping"); }
#line 9583 "y.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4503 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("mixed"); }
#line 9589 "y.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4505 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("multiset"); }
#line 9595 "y.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4507 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("object"); }
#line 9601 "y.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4509 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("program"); }
#line 9607 "y.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4511 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("string"); }
#line 9613 "y.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4513 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("typedef"); }
#line 9619 "y.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4515 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("void"); }
#line 9625 "y.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4517 "language.yacc" /* yacc.c:1646  */
    {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
  }
#line 9636 "y.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4527 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("inline"); }
#line 9642 "y.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4529 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("local"); }
#line 9648 "y.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4531 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("nomask"); }
#line 9654 "y.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4533 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("predef"); }
#line 9660 "y.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4535 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("private"); }
#line 9666 "y.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4537 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("protected"); }
#line 9672 "y.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4539 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("public"); }
#line 9678 "y.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4541 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("optional"); }
#line 9684 "y.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4543 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("variant"); }
#line 9690 "y.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4545 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("static"); }
#line 9696 "y.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4547 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("extern"); }
#line 9702 "y.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4549 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("final");}
#line 9708 "y.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4551 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("do"); }
#line 9714 "y.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4553 "language.yacc" /* yacc.c:1646  */
    { yyerror("else without if."); }
#line 9720 "y.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4555 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("return"); }
#line 9726 "y.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4557 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("import"); }
#line 9732 "y.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4559 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("facet"); }
#line 9738 "y.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4561 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("inherit"); }
#line 9744 "y.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4563 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("catch"); }
#line 9750 "y.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4565 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("gauge"); }
#line 9756 "y.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4567 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("lambda"); }
#line 9762 "y.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4569 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("sscanf"); }
#line 9768 "y.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4571 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("switch"); }
#line 9774 "y.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4573 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("typeof"); }
#line 9780 "y.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4575 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("break"); }
#line 9786 "y.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4577 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("case"); }
#line 9792 "y.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4579 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("continue"); }
#line 9798 "y.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4581 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("default"); }
#line 9804 "y.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4583 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("for"); }
#line 9810 "y.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4585 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("foreach"); }
#line 9816 "y.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4587 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("if"); }
#line 9822 "y.tab.c" /* yacc.c:1646  */
    break;


#line 9826 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4600 "language.yacc" /* yacc.c:1906  */


static void yyerror_reserved(const char *keyword)
{
  my_yyerror("%s is a reserved word.", keyword);
}

static struct pike_string *get_new_name(struct pike_string *prefix)
{
  char buf[40];
  /* Generate a name for a global symbol... */
  sprintf(buf,"__lambda_%ld_%ld_line_%d",
	  (long)Pike_compiler->new_program->id,
	  (long)(Pike_compiler->local_class_counter++ & 0xffffffff), /* OSF/1 cc bug. */
	  (int) THIS_COMPILATION->lex.current_line);
  if (prefix) {
    struct string_builder sb;
    init_string_builder_alloc(&sb, prefix->len + strlen(buf) + 1,
			      prefix->size_shift);
    string_builder_shared_strcat(&sb, prefix);
    string_builder_putchar(&sb, 0);
    string_builder_strcat(&sb, buf);
    return finish_string_builder(&sb);
  }
  return make_shared_string(buf);
}


static int low_islocal(struct compiler_frame *f,
		       struct pike_string *str)
{
  int e;
  for(e=f->current_number_of_locals-1;e>=0;e--)
    if(f->variable[e].name==str) {
      f->variable[e].flags |= LOCAL_VAR_IS_USED;
      return e;
    }
  return -1;
}


/* Add a local variable to the current function in frame.
 * NOTE: Steals the references to type and def, but not to str.
 */
int low_add_local_name(struct compiler_frame *frame,
		       struct pike_string *str,
		       struct pike_type *type,
		       node *def)
{

  if (str->len && !TEST_COMPAT(7,0)) {
    int tmp=low_islocal(frame,str);
    if(tmp>=0 && tmp >= frame->last_block_level)
    {
      my_yyerror("Duplicate local variable %S, "
		 "previous declaration on line %d\n",
		 str, frame->variable[tmp].line);
    }

    if(type == void_type_string)
    {
      my_yyerror("Local variable %S is void.\n", str);
    }
  }

  debug_malloc_touch(def);
  debug_malloc_touch(type);
  debug_malloc_touch(str);
  /* NOTE: The number of locals can be 0..255 (not 256), due to
   *       the use of READ_INCR_BYTE() in apply_low.h.
   */
  if (frame->current_number_of_locals == MAX_LOCAL-1)
  {
    my_yyerror("Too many local variables: no space for local variable %S.",
	       str);
    free_type(type);
    if (def) free_node(def);
    return -1;
  } else {
    int var = frame->current_number_of_locals;

#ifdef PIKE_DEBUG
    check_type_string(type);
#endif /* PIKE_DEBUG */
    if (pike_types_le(type, void_type_string)) {
      if (Pike_compiler->compiler_pass != 1) {
	yywarning("Declaring local variable %S with type void "
		  "(converted to type zero).", str);
      }
      free_type(type);
      copy_pike_type(type, zero_type_string);
    }
    frame->variable[var].type = type;
    frame->variable[var].name = str;
    reference_shared_string(str);
    frame->variable[var].def = def;

    frame->variable[var].line = THIS_COMPILATION->lex.current_line;
    copy_shared_string(frame->variable[var].file,
		       THIS_COMPILATION->lex.current_file);

    if (pike_types_le(void_type_string, type)) {
      /* Don't warn about unused voidable variables. */
      frame->variable[var].flags = LOCAL_VAR_IS_USED;
    } else {
      frame->variable[var].flags = 0;
    }

    frame->current_number_of_locals++;
    if(frame->current_number_of_locals > frame->max_number_of_locals)
    {
      frame->max_number_of_locals = frame->current_number_of_locals;
    }

    return var;
  }
}


/* argument must be a shared string */
/* Note that this function eats a reference to 'type' */
/* If def is nonzero, it also eats a ref to def */
int add_local_name(struct pike_string *str,
		   struct pike_type *type,
		   node *def)
{
  return low_add_local_name(Pike_compiler->compiler_frame,
			    str,
			    type,
			    def);
}

/* Mark local variables declared in a multi-assign or sscanf expression
 * as used. */
static void mark_lvalues_as_used(node *n)
{
  while (n && n->token == F_LVALUE_LIST) {
    if (!CAR(n)) {
      /* Can happen if a variable hasn't been declared. */
    } else if (CAR(n)->token == F_ARRAY_LVALUE) {
      mark_lvalues_as_used(CAAR(n));
    } else if ((CAR(n)->token == F_LOCAL) && !(CAR(n)->u.integer.b)) {
      Pike_compiler->compiler_frame->variable[CAR(n)->u.integer.a].flags |=
	LOCAL_VAR_IS_USED;
    }
    n = CDR(n);
  }
}

#if 0
/* Note that this function eats a reference to each of
 * 'type' and 'initializer', but not to 'name'.
 * Note also that 'initializer' may be NULL.
 */
static node *add_protected_variable(struct pike_string *name,
				    struct pike_type *type,
				    int depth,
				    node *initializer)
{
  struct compiler_frame *f = Pike_compiler->compiler_frame;
  int i;
  int id;
  node *n = NULL;

  if (initializer) {
    /* FIXME: We need to pop levels off local and external variables here. */
  }

  for(i = depth; f && i; i--) {
    f->lexical_scope |= SCOPE_SCOPED;
    f = f->previous;
  }
  if (!f) {
    int parent_depth = i;
    struct program_state *p = Pike_compiler;
    struct pike_string *tmp_name;
    while (i--) {
      if (!p->previous) {
	my_yyerror("Too many levels of protected (%d, max:%d).",
		   depth, depth - (i+1));
	parent_depth -= i+1;
	break;
      }
      p->new_program->flags |= PROGRAM_USES_PARENT;
      p = p->previous;
    }
    
    tmp_name = get_new_name(name);
    id = define_parent_variable(p, tmp_name, type,
				ID_PROTECTED|ID_PRIVATE|ID_INLINE);
    free_string(tmp_name);
    if (id >= 0) {
      if (def) {
	p->init_node =
	  mknode(F_COMMA_EXPR, Pike_compiler->init_node,
		 mkcastnode(void_type_string,
			    mknode(F_ASSIGN, initializer,
				   mkidentifiernode(id))));
	initializer = NULL;
      }
      n = mkexternalnode(id, parent_depth);
    }
  } else if (depth) {
    f->lexical_scope|=SCOPE_SCOPE_USED;
    tmp_name = get_new_name(name);
    id = low_add_local_name(f, tmp_name, type, NULL);
    free_string(tmp_name);
    if(f->min_number_of_locals < id+1)
      f->min_number_of_locals = id+1;
    if (initializer) {
      /* FIXME! */
      yyerror("Initializers not yet supported for protected variables with function scope.");
    }
    n = mklocalnode(id, depth);
  }
  id = add_local_name(name, type, n);
  if (id >= 0) {
    if (initializer) {
      return mknode(F_ASSIGN, initializer, mklocalnode(id,0));
    }
    return mklocalnode(id, 0);
  }
  if (initializer) {
    free_node(initializer);
  }
  return NULL;
}
#endif /* 0 */

int islocal(struct pike_string *str)
{
  return low_islocal(Pike_compiler->compiler_frame, str);
}

/* argument must be a shared string */
static node *lexical_islocal(struct pike_string *str)
{
  int e,depth=0;
  struct compiler_frame *f=Pike_compiler->compiler_frame;
  
  while(1)
  {
    for(e=f->current_number_of_locals-1;e>=0;e--)
    {
      if(f->variable[e].name==str)
      {
	struct compiler_frame *q=Pike_compiler->compiler_frame;

	f->variable[e].flags |= LOCAL_VAR_IS_USED;

	while(q!=f) 
	{
	  q->lexical_scope|=SCOPE_SCOPED;
	  q=q->previous;
	}

	if(depth) {
	  q->lexical_scope|=SCOPE_SCOPE_USED;

	  if(q->min_number_of_locals < e+1)
	    q->min_number_of_locals = e+1;
	}

	if(f->variable[e].def) {
	  /*fprintf(stderr, "Found prior definition of \"%s\"\n", str->str); */
	  return copy_node(f->variable[e].def);
	}

	return mklocalnode(e,depth);
      }
    }
    if(!(f->lexical_scope & SCOPE_LOCAL)) return 0;
    depth++;
    f=f->previous;
  }
}

static node *safe_inc_enum(node *n)
{
  JMP_BUF recovery;
  STACK_LEVEL_START(0);

  if (SETJMP(recovery)) {
    handle_compile_exception ("Bad implicit enum value (failed to add 1).");
    push_int(0);
  } else {
    if (n->token != F_CONSTANT) Pike_fatal("Bad node to safe_inc_enum().\n");
    push_svalue(&n->u.sval);
    push_int(1);
    f_add(2);
  }
  UNSETJMP(recovery);
  STACK_LEVEL_DONE(1);
  free_node(n);
  n = mkconstantsvaluenode(Pike_sp-1);
  pop_stack();
  return n;
}


static int call_handle_import(struct pike_string *s)
{
  struct compilation *c = THIS_COMPILATION;
  int args;

  ref_push_string(s);
  ref_push_string(c->lex.current_file);
  if (c->handler && c->handler->prog) {
    ref_push_object(c->handler);
    args = 3;
  }
  else args = 2;

  if (safe_apply_handler("handle_import", c->handler, c->compat_handler,
			 args, BIT_MAPPING|BIT_OBJECT|BIT_PROGRAM|BIT_ZERO))
    if (Pike_sp[-1].type != T_INT)
      return 1;
    else {
      pop_stack();
      my_yyerror("Couldn't find module to import: %S", s);
    }
  else
    handle_compile_exception ("Error finding module to import");

  return 0;
}

void cleanup_compiler(void)
{
}
